module     p0_ddbar_neepdubar_abbrevd19h0
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb19n1
   complex(ki), public :: abb19n2
   complex(ki), public :: abb19n3
   complex(ki), public :: abb19n4
   complex(ki), public :: abb19n5
   complex(ki), public :: abb19n6
   complex(ki), public :: abb19n7
   complex(ki), public :: abb19n8
   complex(ki), public :: abb19n9
   complex(ki), public :: abb19n10
   complex(ki), public :: abb19n11
   complex(ki), public :: abb19n12
   complex(ki), public :: abb19n13
   complex(ki), public :: abb19n14
   complex(ki), public :: rat2d19
   complex(ki), public :: abb19n16
   complex(ki), public :: abb19n17
   complex(ki), public :: abb19n18
   complex(ki), public :: abb19n19
   complex(ki), public :: abb19n20
   complex(ki), public :: abb19n21
   complex(ki), public :: abb19n22
   complex(ki), public :: abb19n23
   complex(ki), public :: abb19n24
   complex(ki), public :: abb19n25
   complex(ki), public :: abb19n26
   complex(ki), public :: abb19n27
   complex(ki), public :: abb19n28
   complex(ki), public :: abb19n29
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   real(ki) :: t51
   real(ki) :: t52
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = Nfrat*c2*i_
      t3 = t2*spak1k5
      t4 = t3*spak3k4
      t51 = TR*TR
      t5 = t51*t4*spbk4k2*spbk6k4
      t6 = (es12+es34-(es56+es345))*t1
      t7 = es12*t6
      t8 = t3*spak3k6
      t9 = t51*t8*spbk6k2*spbk6k4
      t10 = t2*spak1k3*spak3k5
      t11 = t10*spbk4k3
      t12 = t51*t11*spbk6k2
      t13 = es345*es12*t1
      t3 = t3*spak3k5
      t14 = t3*spbk5k4
      t15 = t51*t14*spbk6k2
      t16 = Nfrat*c1*i_
      t17 = t16*spak1k5
      t18 = t17*spak3k4
      t19 = t51*t18*spbk4k2*spbk6k4
      t20 = NC*t6
      t21 = es12*t20
      t22 = t17*spak3k6
      t23 = t51*t22*spbk6k2*spbk6k4
      t24 = t16*spak1k3*spak3k5
      t25 = t24*spbk4k3
      t26 = t51*t25*spbk6k2
      t27 = NC*t1
      t28 = es345*es12*t27
      t17 = t17*spak3k5
      t29 = t17*spbk5k4
      t30 = t51*t29*spbk6k2
      t31 = c1*i_
      t32 = t31*spak1k5
      t33 = t32*spak3k4
      t34 = t51*t33*spbk4k2*spbk6k4
      t35 = t32*spak3k6
      t36 = t51*t35*spbk6k2*spbk6k4
      t37 = t31*spak1k3*spak3k5*spbk4k3
      t38 = t51*t37*spbk6k2
      t32 = t32*spak3k5*spbk5k4
      t39 = t51*t32*spbk6k2
      t40 = NC*c2*i_
      t41 = t40*spak1k5
      t42 = t41*spak3k4
      t43 = t51*t42*spbk4k2*spbk6k4
      t44 = t41*spak3k6
      t45 = t51*t44*spbk6k2*spbk6k4
      t46 = t40*spak1k3*spak3k5*spbk4k3
      t47 = t51*t46*spbk6k2
      t41 = t41*spak3k5*spbk5k4
      t48 = t51*t41*spbk6k2
      t49 = t38/t13+t48/t13+t34/t7+t36/t7-(t45/t7+t43/t7+t47/t13+t39/t13)
      abb19n1 = ((20.0_ki/3.0_ki)*(t15/t13+t19/t21+t23/t21+t26/t28-(t9/t7+t5/t7+&
      &t30/t28+t12/t13))+(2.0_ki/3.0_ki)*t49)
      t7 = t31*spak3k5
      t52 = es12*es12
      t6 = t52*t6
      t13 = t40*spak3k5
      abb19n2 = ((16.0_ki)*(t51/t6*t7*spbk6k4-t51*t13/t6*spbk6k4))
      abb19n3 = ((8.0_ki)*(t51*t13/t6*spbk6k3+t51*t40/t6*spak4k5*spbk6k4-(t51*t3&
      &1/t6*spak4k5*spbk6k4+t51/t6*t7*spbk6k3)))
      t20 = t52*t20
      abb19n4 = ((20.0_ki)*(t51*t4/t6*spbk2k1*spbk6k4-t51*t18/t20*spbk2k1*spbk6k&
      &4))
      abb19n5 = ((40.0_ki)*(t51*t2/t6*spak3k4*spbk6k4-t51*t16/t20*spak3k4*spbk6k&
      &4))
      abb19n6 = ((10.0_ki)*t49)
      t21 = t2*spak1k2
      t28 = t21*spak3k5
      t1 = es345*t52*t1
      t49 = t16*spak1k2
      t50 = t49*spak3k5
      t27 = es345*t52*t27
      abb19n7 = ((20.0_ki)*(t51*t50/t27*spbk4k3*spbk6k2-t51*t28/t1*spbk4k3*spbk6&
      &k2))
      abb19n8 = ((20.0_ki)*(t51*t28/t1*spbk5k4*spbk6k2+t51*t49/t20*spak3k4*spbk4&
      &k2*spbk6k4+t51*t49/t20*spak3k6*spbk6k2*spbk6k4-(t51*t21/t6*spak3k6*spbk6k&
      &2*spbk6k4+t51*t21/t6*spak3k4*spbk4k2*spbk6k4+t51*t50/t27*spbk5k4*spbk6k2)&
      &))
      abb19n9 = ((20.0_ki)*(t51*t10/t1*spbk2k1*spbk4k3+t51*t17/t27*spbk2k1*spbk5&
      &k4+t51/t6*t8*spbk2k1*spbk6k4-(t51*t24/t27*spbk2k1*spbk4k3+t51*t22/t20*spb&
      &k2k1*spbk6k4+t51*t3/t1*spbk2k1*spbk5k4)))
      t3 = t5/t6
      t5 = t9/t6
      t9 = t12/t1
      t10 = t15/t1
      t12 = t19/t20
      t15 = t23/t20
      t17 = t26/t27
      t19 = t30/t27
      t21 = t34/t6
      t23 = t36/t6
      t24 = t38/t1
      t26 = t39/t1
      t28 = t43/t6
      t30 = t45/t6
      t34 = t47/t1
      t36 = t48/t1
      abb19n10 = ((80.0_ki)*(t19+t3+t5+t9-(t17+t15+t12+t10))+(4.0_ki)*(t26+t28+t&
      &30+t34-(t36+t24+t23+t21)))
      abb19n11 = ((40.0_ki)*(t10+t12+t15+t17-(t9+t5+t3+t19))+(4.0_ki)*(t21+t23+t&
      &24+t36-(t34+t30+t28+t26)))
      t3 = t2*spak2k5
      t5 = t16*spak2k5
      t9 = t31*spak2k5
      t10 = t40*spak2k5
      abb19n12 = ((40.0_ki)*(t51*t14/t1*spbk6k1+t51*t25/t27*spbk6k1+t51*t18/t20*&
      &spbk4k1*spbk6k4+t51*t22/t20*spbk6k1*spbk6k4+t51*t3/t1*spak3k5*spbk5k4*spb&
      &k6k2+t51*t5/t20*spak3k4*spbk4k2*spbk6k4+t51*t5/t20*spak3k6*spbk6k2*spbk6k&
      &4+t51*t16/t27*spak2k3*spak3k5*spbk4k3*spbk6k2-(t51*t2/t1*spak2k3*spak3k5*&
      &spbk4k3*spbk6k2+t51*t3/t6*spak3k6*spbk6k2*spbk6k4+t51*t3/t6*spak3k4*spbk4&
      &k2*spbk6k4+t51*t5/t27*spak3k5*spbk5k4*spbk6k2+t51/t6*t8*spbk6k1*spbk6k4+t&
      &51*t4/t6*spbk4k1*spbk6k4+t51*t29/t27*spbk6k1+t51*t11/t1*spbk6k1))+(3.0_ki&
      &)*(t51*t32/t1*spbk6k1+t51*t46/t1*spbk6k1+t51*t42/t6*spbk4k1*spbk6k4+t51*t&
      &44/t6*spbk6k1*spbk6k4+t51/t1*t9*spak3k5*spbk5k4*spbk6k2+t51*t10/t6*spak3k&
      &4*spbk4k2*spbk6k4+t51*t10/t6*spak3k6*spbk6k2*spbk6k4+t51*t40/t1*spak2k3*s&
      &pak3k5*spbk4k3*spbk6k2-(t51*t31/t1*spak2k3*spak3k5*spbk4k3*spbk6k2+t51/t6&
      &*t9*spak3k6*spbk6k2*spbk6k4+t51/t6*t9*spak3k4*spbk4k2*spbk6k4+t51*t10/t1*&
      &spak3k5*spbk5k4*spbk6k2+t51*t35/t6*spbk6k1*spbk6k4+t51*t33/t6*spbk4k1*spb&
      &k6k4+t51*t41/t1*spbk6k1+t51*t37/t1*spbk6k1)))
      t3 = t2*spak3k5
      t4 = t16*spak3k5
      t5 = t51*t7*spbk4k3
      t8 = t51*t13*spbk4k3
      abb19n13 = ((40.0_ki)*(t51*t3/t1*spbk4k3-t51*t4/t27*spbk4k3)+(8.0_ki)*(t5/&
      &t1+t5/t6+t51*t31/t6*spak5k6*spbk6k4-(t51*t40/t6*spak5k6*spbk6k4+t8/t6+t8/&
      &t1)))
      abb19n14 = ((8.0_ki)*(t51*t13/t1*spbk5k4-t51/t1*t7*spbk5k4)+(40.0_ki)*(t51&
      &*t4/t27*spbk5k4+t51*t2/t6*spak3k6*spbk6k4-(t51*t16/t20*spak3k6*spbk6k4+t5&
      &1*t3/t1*spbk5k4)))
      rat2d19 = abb19n1
      rat2 = rat2 + rat2d19
      abb19n16 = abb19n6
      abb19n17 = abb19n14
      abb19n18 = abb19n13
      abb19n19 = abb19n11
      abb19n20 = abb19n5
      abb19n21 = abb19n3
      abb19n22 = abb19n2
      abb19n23 = -(abb19n4)
      abb19n24 = -(abb19n7)
      abb19n25 = -(abb19n8)
      abb19n26 = -(abb19n9)
      abb19n27 = -(abb19n10)
      abb19n28 = ((2.0_ki)*abb19n11)
      abb19n29 = -(abb19n12)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd19h0
