module     p0_ddbar_neepdubar_abbrevd55h0
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb55n1
   complex(ki), public :: abb55n2
   complex(ki), public :: abb55n3
   complex(ki), public :: abb55n4
   complex(ki), public :: abb55n5
   complex(ki), public :: abb55n6
   complex(ki), public :: abb55n7
   complex(ki), public :: abb55n8
   complex(ki), public :: abb55n9
   complex(ki), public :: abb55n10
   complex(ki), public :: abb55n11
   complex(ki), public :: abb55n12
   complex(ki), public :: abb55n13
   complex(ki), public :: abb55n14
   complex(ki), public :: abb55n15
   complex(ki), public :: abb55n16
   complex(ki), public :: abb55n17
   complex(ki), public :: abb55n18
   complex(ki), public :: abb55n19
   complex(ki), public :: abb55n20
   complex(ki), public :: abb55n21
   complex(ki), public :: abb55n22
   complex(ki), public :: abb55n23
   complex(ki), public :: abb55n24
   complex(ki), public :: abb55n25
   complex(ki), public :: abb55n26
   complex(ki), public :: abb55n27
   complex(ki), public :: abb55n28
   complex(ki), public :: rat2d55
   complex(ki), public :: abb55n30
   complex(ki), public :: abb55n31
   complex(ki), public :: abb55n32
   complex(ki), public :: abb55n33
   complex(ki), public :: abb55n34
   complex(ki), public :: abb55n35
   complex(ki), public :: abb55n36
   complex(ki), public :: abb55n37
   complex(ki), public :: abb55n38
   complex(ki), public :: abb55n39
   complex(ki), public :: abb55n40
   complex(ki), public :: abb55n41
   complex(ki), public :: abb55n42
   complex(ki), public :: abb55n43
   complex(ki), public :: abb55n44
   complex(ki), public :: abb55n45
   complex(ki), public :: abb55n46
   complex(ki), public :: abb55n47
   complex(ki), public :: abb55n48
   complex(ki), public :: abb55n49
   complex(ki), public :: abb55n50
   complex(ki), public :: abb55n51
   complex(ki), public :: abb55n52
   complex(ki), public :: abb55n53
   complex(ki), public :: abb55n54
   complex(ki), public :: abb55n55
   complex(ki), public :: abb55n56
   complex(ki), public :: abb55n57
   complex(ki), public :: abb55n58
   complex(ki), public :: abb55n59
   complex(ki), public :: abb55n60
   complex(ki), public :: abb55n61
   complex(ki), public :: abb55n62
   complex(ki), public :: abb55n63
   complex(ki), public :: abb55n64
   complex(ki), public :: abb55n65
   complex(ki), public :: abb55n66
   complex(ki), public :: abb55n67
   complex(ki), public :: abb55n68
   complex(ki), public :: abb55n69
   complex(ki), public :: abb55n70
   complex(ki), public :: abb55n71
   complex(ki), public :: abb55n72
   complex(ki), public :: abb55n73
   complex(ki), public :: abb55n74
   complex(ki), public :: abb55n75
   complex(ki), public :: abb55n76
   complex(ki), public :: abb55n77
   complex(ki), public :: abb55n78
   complex(ki), public :: abb55n79
   complex(ki), public :: abb55n80
   complex(ki), public :: abb55n81
   complex(ki), public :: abb55n82
   complex(ki), public :: abb55n83
   complex(ki), public :: abb55n84
   complex(ki), public :: abb55n85
   complex(ki), public :: abb55n86
   complex(ki), public :: abb55n87
   complex(ki), public :: abb55n88
   complex(ki), public :: abb55n89
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   real(ki) :: t16
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k2
      t16 = TR*TR
      t4 = NC*t1
      t5 = t2*spak1k3
      t6 = c1*i_
      t7 = t6*spak1k2
      t8 = NC*NC*t1
      t9 = t6*spak1k3
      t10 = NC*c2*i_
      t11 = t10*spak1k2
      t12 = t10*spak1k3
      abb55n1 = ((8.0_ki)*(t16*t3/t4*spak1k3*spbk4k2*spbk6k2+t16/t4*t5*spak1k6*s&
      &pbk6k2*spbk6k4)+(4.0_ki)*(-(t16/t8*t9*spak1k6*spbk6k2*spbk6k4+t16*t7/t8*s&
      &pak1k3*spbk4k2*spbk6k2+t16*t12/t1*spak1k6*spbk6k2*spbk6k4+t16*t11/t1*spak&
      &1k3*spbk4k2*spbk6k2)))
      abb55n2 = ((4.0_ki)*(t16*t11/t1*spbk6k2+t16*t7/t8*spbk6k2-(2.0_ki)*t16*t3/&
      &t4*spbk6k2))
      t13 = t16/t8*t9*spbk4k2
      t14 = (2.0_ki)*t16/t4*t5*spbk4k2
      t15 = t16*t12/t1*spbk4k2
      abb55n3 = ((4.0_ki)*(t13+t15-t14))
      abb55n4 = ((8.0_ki)*(t14-(t15+t13)))
      abb55n5 = ((16.0_ki)*(t16/t4*t5*spak2k5*spbk4k2*spbk6k2-t16/t4*t5*spak5k6*&
      &spbk6k2*spbk6k4)+(8.0_ki)*(t16*t12/t1*spak5k6*spbk6k2*spbk6k4+t16/t8*t9*s&
      &pak5k6*spbk6k2*spbk6k4-(t16/t8*t9*spak2k5*spbk4k2*spbk6k2+t16*t12/t1*spak&
      &2k5*spbk4k2*spbk6k2)))
      t13 = t16/t8*t9*spbk6k2
      t14 = (2.0_ki)*t16/t4*t5*spbk6k2
      t15 = t16*t12/t1*spbk6k2
      abb55n6 = ((8.0_ki)*(t13+t15-t14))
      t13 = t14-(t15+t13)
      abb55n7 = ((4.0_ki)*t13)
      abb55n8 = ((8.0_ki)*t13)
      t9 = t16/t8*t9*spbk6k4
      t5 = (2.0_ki)*t16/t4*t5*spbk6k4
      t12 = t16*t12/t1*spbk6k4
      abb55n9 = ((4.0_ki)*(t12+t9-t5))
      abb55n10 = ((8.0_ki)*(t5-(t9+t12)))
      t5 = t2*spak1k6
      t9 = t6*spak1k6
      t12 = t10*spak1k6
      abb55n11 = ((16.0_ki)*(t16*t3/t4*spak3k5*spbk4k2*spbk6k2+t16/t4*t5*spak3k5&
      &*spbk6k2*spbk6k4)+(8.0_ki)*(-(t16/t8*t9*spak3k5*spbk6k2*spbk6k4+t16*t7/t8&
      &*spak3k5*spbk4k2*spbk6k2+t16*t12/t1*spak3k5*spbk6k2*spbk6k4+t16*t11/t1*sp&
      &ak3k5*spbk4k2*spbk6k2)))
      abb55n12 = ((4.0_ki)*((2.0_ki)*t16/t4*t5*spbk6k2-(t16/t8*t9*spbk6k2+t16*t1&
      &2/t1*spbk6k2)))
      t3 = t16*t6/t8*spak2k3*spbk6k2
      t5 = (2.0_ki)*t16*t2/t4*spak2k3*spbk6k2
      t7 = t16*t10/t1*spak2k3*spbk6k2
      abb55n13 = ((4.0_ki)*(t3+t7-t5))
      abb55n14 = ((4.0_ki)*(t5-(t7+t3)))
      t3 = t6*spak3k5
      t5 = t16*t3/t8*spbk4k2
      t7 = t2*spak3k5
      t9 = (2.0_ki)*t16/t4*t7*spbk4k2
      t11 = t10*spak3k5
      t12 = t16*t11/t1*spbk4k2
      abb55n15 = ((8.0_ki)*(t12+t5-t9))
      abb55n16 = ((4.0_ki)*(t9-(t5+t12)))
      t5 = t6*spak2k5
      t9 = t2*spak2k5
      t12 = t10*spak2k5
      abb55n17 = ((4.0_ki)*(t16*t12/t1*spbk6k2+t16*t5/t8*spbk6k2-(2.0_ki)*t16/t4&
      &*t9*spbk6k2))
      abb55n18 = ((8.0_ki)*(t16/t4*t9*spak3k5*spbk4k2*spbk6k2-t16/t4*t7*spak5k6*&
      &spbk6k2*spbk6k4)+(4.0_ki)*(t16*t11/t1*spak5k6*spbk6k2*spbk6k4+t16*t3/t8*s&
      &pak5k6*spbk6k2*spbk6k4-(t16*t5/t8*spak3k5*spbk4k2*spbk6k2+t16*t12/t1*spak&
      &3k5*spbk4k2*spbk6k2)))
      t5 = t16*t3/t8*spbk6k2
      t9 = (2.0_ki)*t16/t4*t7*spbk6k2
      t12 = t16*t11/t1*spbk6k2
      abb55n19 = ((8.0_ki)*(t12+t5-t9))
      t5 = t9-(t5+t12)
      abb55n20 = ((4.0_ki)*t5)
      abb55n21 = ((8.0_ki)*t5)
      t5 = t16*t6/t8*spak3k6*spbk6k2
      t9 = (2.0_ki)*t16*t2/t4*spak3k6*spbk6k2
      t12 = t16*t10/t1*spak3k6*spbk6k2
      abb55n22 = ((4.0_ki)*(t12+t5-t9))
      abb55n23 = ((4.0_ki)*(t9-(t5+t12)))
      abb55n24 = ((4.0_ki)*(t16*t10/t1*spak5k6*spbk6k2+t16*t6/t8*spak5k6*spbk6k2&
      &-(2.0_ki)*t16*t2/t4*spak5k6*spbk6k2))
      t3 = t16*t3/t8*spbk6k4
      t5 = (2.0_ki)*t16/t4*t7*spbk6k4
      t7 = t16*t11/t1*spbk6k4
      abb55n25 = ((8.0_ki)*(t3+t7-t5))
      abb55n26 = ((4.0_ki)*(t5-(t7+t3)))
      t3 = t16*t6/t8
      t2 = (2.0_ki)*t16*t2/t4
      t1 = t16*t10/t1
      abb55n27 = ((8.0_ki)*(t1+t3-t2))
      abb55n28 = ((8.0_ki)*(t2-(t3+t1)))
      rat2d55 = 0
      rat2 = rat2 + rat2d55
      abb55n30 = -(abb55n1)
      abb55n31 = abb55n28
      abb55n32 = abb55n27
      abb55n33 = abb55n26
      abb55n34 = abb55n25
      abb55n35 = abb55n24
      abb55n36 = abb55n23
      abb55n37 = abb55n22
      abb55n38 = abb55n21
      abb55n39 = abb55n20
      abb55n40 = abb55n19
      abb55n41 = abb55n18
      abb55n42 = abb55n17
      abb55n43 = abb55n16
      abb55n44 = abb55n15
      abb55n45 = abb55n14
      abb55n46 = abb55n13
      abb55n47 = abb55n12
      abb55n48 = abb55n11
      abb55n49 = abb55n10
      abb55n50 = abb55n9
      abb55n51 = abb55n8
      abb55n52 = abb55n7
      abb55n53 = abb55n6
      abb55n54 = abb55n5
      abb55n55 = abb55n4
      abb55n56 = abb55n3
      abb55n57 = abb55n2
      abb55n58 = abb55n1
      abb55n59 = -(abb55n2)
      abb55n60 = -(abb55n3)
      abb55n61 = -(abb55n4)
      abb55n62 = -(abb55n5)
      abb55n63 = -(abb55n6)
      t1 = (2.0_ki)*abb55n7
      abb55n64 = t1
      abb55n65 = -(abb55n7)
      abb55n66 = -(t1)
      abb55n67 = -(abb55n8)
      abb55n68 = -(abb55n9)
      abb55n69 = -(abb55n10)
      abb55n70 = -(abb55n11)
      abb55n71 = -(abb55n12)
      abb55n72 = -(abb55n13)
      abb55n73 = -(abb55n14)
      abb55n74 = -(abb55n15)
      abb55n75 = -(abb55n16)
      abb55n76 = -(abb55n17)
      abb55n77 = -(abb55n18)
      abb55n78 = -(abb55n19)
      t1 = (2.0_ki)*abb55n20
      abb55n79 = t1
      abb55n80 = -(abb55n20)
      abb55n81 = -(t1)
      abb55n82 = -(abb55n21)
      abb55n83 = -(abb55n22)
      abb55n84 = -(abb55n23)
      abb55n85 = -(abb55n24)
      abb55n86 = -(abb55n25)
      abb55n87 = -(abb55n26)
      abb55n88 = -(abb55n27)
      abb55n89 = -(abb55n28)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd55h0
