module     p0_ddbar_neepdubar_d65h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity0/d65h0l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d65
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd65h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      real(ki) :: t18
      real(ki) :: t19
      real(ki) :: t20
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t2 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t18 = dotproduct(k3, qshift)
      t19 = dotproduct(k4, qshift)
      t20 = dotproduct(k6, qshift)
      t4 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t5 = (spvak4k2(1)*qshift(1)-spvak4k2(2)*qshift(2)-spvak4k2(3)*qshift(3)-sp&
      &vak4k2(4)*qshift(4))
      t6 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb65n12*(spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spva&
         &k5k6(3)*qshift(3)-spvak5k6(4)*qshift(4))+abb65n20*dotproduct(qshift, q&
         &shift)+abb65n21*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(&
         &3)*qshift(3)-spvak5k4(4)*qshift(4))+t1*t18*abb65n15+t1*t19*abb65n15+t1&
         &*t2*abb65n13+t1*t20*abb65n15+t1*t3*abb65n14+t18*t4*abb65n16+t19*t4*abb&
         &65n16+t2*t4*abb65n19+t2*t6*abb65n17+t20*t4*abb65n16+t3*t4*abb65n18+t3*&
         &t5*abb65n17)
         return
      end if
      t7 = k3(iv1)
      t8 = k4(iv1)
      t9 = k6(iv1)
      t10 = spvak1k2(iv1)
      t11 = t10*abb65n15
      t12 = spvak3k2(iv1)
      t13 = t12*abb65n16
      t14 = spvak3k4(iv1)
      t15 = spvak3k6(iv1)
      t16 = spvak4k2(iv1)
      t17 = spvak6k2(iv1)
      if(deg.eq.1) then
         numerator = (qshift(iv1)*abb65n22+spvak5k4(iv1)*abb65n21+spvak5k6(iv1)*&
         &abb65n12+t11*t18+t11*t19+t11*t20+t13*t18+t13*t19+t13*t20+t1*t14*abb65n&
         &14+t1*t15*abb65n13+t1*t7*abb65n15+t1*t8*abb65n15+t1*t9*abb65n15+t10*t2&
         &*abb65n13+t10*t3*abb65n14+t12*t2*abb65n19+t12*t3*abb65n18+t14*t4*abb65&
         &n18+t14*t5*abb65n17+t15*t4*abb65n19+t15*t6*abb65n17+t16*t3*abb65n17+t1&
         &7*t2*abb65n17+t4*t7*abb65n16+t4*t8*abb65n16+t4*t9*abb65n16)
         return
      end if
      t1 = spvak1k2(iv2)
      t2 = spvak3k2(iv2)
      t3 = k3(iv2)
      t4 = k4(iv2)
      t5 = k6(iv2)
      t6 = spvak3k4(iv2)
      t11 = spvak3k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb65n20+spvak4k2(iv2)*t14*abb65n17+sp&
         &vak6k2(iv2)*t15*abb65n17+t1*t14*abb65n14+t1*t15*abb65n13+t1*t7*abb65n1&
         &5+t1*t8*abb65n15+t1*t9*abb65n15+t10*t11*abb65n13+t10*t3*abb65n15+t10*t&
         &4*abb65n15+t10*t5*abb65n15+t10*t6*abb65n14+t11*t12*abb65n19+t11*t17*ab&
         &b65n17+t12*t3*abb65n16+t12*t4*abb65n16+t12*t5*abb65n16+t12*t6*abb65n18&
         &+t14*t2*abb65n18+t15*t2*abb65n19+t16*t6*abb65n17+t2*t7*abb65n16+t2*t8*&
         &abb65n16+t2*t9*abb65n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d65:
   subroutine     reconstruct_d65(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_65:
      coeffs%coeffs_65%c0 = derivative(czip)
      coeffs%coeffs_65%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_65%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_65%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_65%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_65%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_65%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_65%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_65%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_65%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_65%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_65%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_65%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_65%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_65%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_65:
   end subroutine reconstruct_d65
!---#] subroutine reconstruct_d65:
end module p0_ddbar_neepdubar_d65h0l1d
