module     p1_ddbar_neepscbar_abbrevd29h0
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb29n1
   complex(ki), public :: abb29n2
   complex(ki), public :: abb29n3
   complex(ki), public :: abb29n4
   complex(ki), public :: abb29n5
   complex(ki), public :: abb29n6
   complex(ki), public :: abb29n7
   complex(ki), public :: abb29n8
   complex(ki), public :: abb29n9
   complex(ki), public :: abb29n10
   complex(ki), public :: abb29n11
   complex(ki), public :: abb29n12
   complex(ki), public :: abb29n13
   complex(ki), public :: abb29n14
   complex(ki), public :: rat2d29
   complex(ki), public :: abb29n16
   complex(ki), public :: abb29n17
   complex(ki), public :: abb29n18
   complex(ki), public :: abb29n19
   complex(ki), public :: abb29n20
   complex(ki), public :: abb29n21
   complex(ki), public :: abb29n22
   complex(ki), public :: abb29n23
   complex(ki), public :: abb29n24
   complex(ki), public :: abb29n25
   complex(ki), public :: abb29n26
   complex(ki), public :: abb29n27
   complex(ki), public :: abb29n28
   complex(ki), public :: abb29n29
   complex(ki), public :: abb29n30
   complex(ki), public :: abb29n31
   complex(ki), public :: abb29n32
   complex(ki), public :: abb29n33
   complex(ki), public :: abb29n34
   complex(ki), public :: abb29n35
   complex(ki), public :: abb29n36
   complex(ki), public :: abb29n37
   complex(ki), public :: abb29n38
   complex(ki), public :: abb29n39
   complex(ki), public :: abb29n40
   complex(ki), public :: abb29n41
   complex(ki), public :: abb29n42
   complex(ki), public :: abb29n43
   complex(ki), public :: abb29n44
   complex(ki), public :: abb29n45
   complex(ki), public :: abb29n46
   complex(ki), public :: abb29n47
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak3k5
      t13 = TR*TR
      t4 = t13*t3*spak5k6*spbk5k2*spbk6k4
      t5 = NC*NC*t1
      t6 = c2*i_
      t7 = t6*spak3k5
      t8 = NC*t1
      abb29n1 = ((4.0_ki)*((2.0_ki)*t13*t7/t8*spak5k6*spbk5k2*spbk6k4-(t4/t5+t4/&
      &t1)))
      t4 = t13*t2*spak1k3*spbk4k2
      abb29n2 = ((8.0_ki)*((2.0_ki)*t13*t6/t8*spak1k3*spbk4k2-(t4/t5+t4/t1)))
      t4 = t2*spak1k5
      t9 = t13*t4*spbk4k2
      t10 = t9/t1
      t9 = t9/t5
      t11 = t6*spak1k5
      t12 = t13*(2.0_ki)*t11/t8*spbk4k2
      abb29n3 = ((8.0_ki)*(t10+t9-t12))
      t9 = t12-(t9+t10)
      abb29n4 = ((4.0_ki)*t9)
      abb29n5 = ((8.0_ki)*t9)
      t9 = t13*t4*spak3k5*spbk5k2*spbk6k4
      abb29n6 = ((8.0_ki)*(t13*(2.0_ki)*t11/t8*spak3k5*spbk5k2*spbk6k4-(t9/t5+t9&
      &/t1)))
      t4 = t13*t4*spbk6k2
      abb29n7 = ((8.0_ki)*(t4/t1+t4/t5-t13*(2.0_ki)*t11/t8*spbk6k2))
      t4 = t13*t3*spbk4k2
      t9 = t4/t1
      t4 = t4/t5
      t10 = (2.0_ki)*t13*t7/t8*spbk4k2
      t11 = t4+t9-t10
      abb29n8 = ((8.0_ki)*t11)
      abb29n9 = ((4.0_ki)*t11)
      abb29n10 = ((8.0_ki)*(t10-(t9+t4)))
      t4 = t13*t2*spak3k6*spbk4k2
      abb29n11 = ((4.0_ki)*((2.0_ki)*t13*t6/t8*spak3k6*spbk4k2-(t4/t5+t4/t1)))
      t3 = t13*t3*spbk5k2
      abb29n12 = ((4.0_ki)*((2.0_ki)*t13*t7/t8*spbk5k2-(t3/t5+t3/t1)))
      t3 = t13*t2*spak5k6*spbk6k2
      abb29n13 = ((4.0_ki)*(t3/t1+t3/t5-(2.0_ki)*t13*t6/t8*spak5k6*spbk6k2))
      t2 = t13*t2
      abb29n14 = ((4.0_ki)*(t2/t1+t2/t5-(2.0_ki)*t13*t6/t8))
      rat2d29 = 0
      rat2 = rat2 + rat2d29
      abb29n16 = -(abb29n1)
      abb29n17 = abb29n14
      abb29n18 = abb29n13
      abb29n19 = abb29n12
      abb29n20 = abb29n11
      abb29n21 = abb29n10
      abb29n22 = abb29n9
      abb29n23 = abb29n8
      abb29n24 = abb29n7
      abb29n25 = abb29n6
      abb29n26 = abb29n5
      abb29n27 = abb29n4
      abb29n28 = abb29n3
      abb29n29 = abb29n2
      abb29n30 = abb29n1
      abb29n31 = -(abb29n2)
      abb29n32 = -(abb29n3)
      t1 = (2.0_ki)*abb29n4
      abb29n33 = t1
      abb29n34 = -(abb29n4)
      abb29n35 = -(t1)
      abb29n36 = -(abb29n5)
      abb29n37 = -(abb29n6)
      abb29n38 = -(abb29n7)
      abb29n39 = -(abb29n8)
      t1 = (2.0_ki)*abb29n9
      abb29n40 = t1
      abb29n41 = -(abb29n9)
      abb29n42 = -(t1)
      abb29n43 = -(abb29n10)
      abb29n44 = -(abb29n11)
      abb29n45 = -(abb29n12)
      abb29n46 = -(abb29n13)
      abb29n47 = -(abb29n14)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd29h0
