module     p1_ddbar_neepscbar_abbrevd2h0
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb2n1
   complex(ki), public :: abb2n2
   complex(ki), public :: abb2n3
   complex(ki), public :: abb2n4
   complex(ki), public :: abb2n5
   complex(ki), public :: abb2n6
   complex(ki), public :: abb2n7
   complex(ki), public :: abb2n8
   complex(ki), public :: abb2n9
   complex(ki), public :: abb2n10
   complex(ki), public :: abb2n11
   complex(ki), public :: abb2n12
   complex(ki), public :: abb2n13
   complex(ki), public :: abb2n14
   complex(ki), public :: abb2n15
   complex(ki), public :: abb2n16
   complex(ki), public :: abb2n17
   complex(ki), public :: abb2n18
   complex(ki), public :: abb2n19
   complex(ki), public :: abb2n20
   complex(ki), public :: abb2n21
   complex(ki), public :: abb2n22
   complex(ki), public :: abb2n23
   complex(ki), public :: abb2n24
   complex(ki), public :: abb2n25
   complex(ki), public :: abb2n26
   complex(ki), public :: abb2n27
   complex(ki), public :: abb2n28
   complex(ki), public :: rat2d2
   complex(ki), public :: abb2n30
   complex(ki), public :: abb2n31
   complex(ki), public :: abb2n32
   complex(ki), public :: abb2n33
   complex(ki), public :: abb2n34
   complex(ki), public :: abb2n35
   complex(ki), public :: abb2n36
   complex(ki), public :: abb2n37
   complex(ki), public :: abb2n38
   complex(ki), public :: abb2n39
   complex(ki), public :: abb2n40
   complex(ki), public :: abb2n41
   complex(ki), public :: abb2n42
   complex(ki), public :: abb2n43
   complex(ki), public :: abb2n44
   complex(ki), public :: abb2n45
   complex(ki), public :: abb2n46
   complex(ki), public :: abb2n47
   complex(ki), public :: abb2n48
   complex(ki), public :: abb2n49
   complex(ki), public :: abb2n50
   complex(ki), public :: abb2n51
   complex(ki), public :: abb2n52
   complex(ki), public :: abb2n53
   complex(ki), public :: abb2n54
   complex(ki), public :: abb2n55
   complex(ki), public :: abb2n56
   complex(ki), public :: abb2n57
   complex(ki), public :: abb2n58
   complex(ki), public :: abb2n59
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   real(ki) :: t28
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = es56*c1*i_
      t28 = TR*TR
      t3 = es12*NC*NC*t1
      t4 = t2*spak1k5
      t5 = es56*c2*i_
      t1 = es12*NC*t1
      t6 = t5*spak1k5
      abb2n1 = ((4.0_ki)*(t28/t1*t6*spak3k5*spbk5k2*spbk6k4+t28*t2/t3*spak1k3*sp&
      &ak1k5*spbk2k1*spbk6k4-(t28/t1*t5*spak1k3*spak1k5*spbk2k1*spbk6k4+t28/t3*t&
      &4*spak3k5*spbk5k2*spbk6k4)))
      t7 = c1*i_
      t8 = t7*spak1k2
      t9 = t8*spak5k6
      t10 = TR*spbk6k2
      t10 = t10*t10
      t11 = c2*i_
      t12 = t11*spak1k2
      t13 = t12*spak5k6
      abb2n2 = ((4.0_ki)*(t10/t1*t13-t10/t3*t9))
      t10 = t7*spak1k5
      t14 = t10*spak3k5
      t15 = t11*spak1k5
      t16 = t15*spak3k5
      abb2n3 = ((4.0_ki)*(t28*t16/t1*spbk2k1*spbk5k4-t28*t14/t3*spbk2k1*spbk5k4)&
      &)
      t17 = t7*spak1k3
      t18 = t17*spak5k6
      t19 = t28*t18/t3*spbk6k2*spbk6k4
      t20 = t11*spak1k3
      t21 = t20*spak5k6
      t22 = t28*t21/t1*spbk6k2*spbk6k4
      abb2n4 = ((8.0_ki)*(t19-t22))
      t23 = t28*t17/t3*spbk6k4
      t24 = t28*t20/t1*spbk6k4
      t25 = t23-t24
      abb2n5 = ((8.0_ki)*t25)
      abb2n6 = ((4.0_ki)*t25)
      abb2n7 = ((8.0_ki)*(t24-t23))
      t23 = t7*spak3k5
      t24 = t11*spak3k5
      abb2n8 = ((4.0_ki)*(t28*t24/t1*spbk4k1-t28*t23/t3*spbk4k1))
      t25 = t28*t10/t3*spbk4k2
      t26 = t28*t15/t1*spbk4k2
      t27 = t25-t26
      abb2n9 = ((8.0_ki)*t27)
      abb2n10 = ((4.0_ki)*t27)
      abb2n11 = ((8.0_ki)*(t26-t25))
      t25 = t14*spbk5k2
      t26 = t16*spbk5k2
      abb2n12 = ((4.0_ki)*(t28*t26/t1*spbk5k4-t28*t25/t3*spbk5k4))
      abb2n13 = ((8.0_ki)*(t22+t28*t25/t3*spbk6k4+t28*t20/t1*spak1k5*spbk2k1*spb&
      &k6k4-(t28*t17/t3*spak1k5*spbk2k1*spbk6k4+t28*t26/t1*spbk6k4+t19)))
      abb2n14 = ((8.0_ki)*(t28*t15/t1*spbk5k2-t28*t10/t3*spbk5k2))
      abb2n15 = ((4.0_ki)*(t22+t28*t14/t3*spbk4k2*spbk6k5+t28*t14/t3*spbk5k4*spb&
      &k6k2+t28/t3*t8*spak3k5*spbk4k2*spbk6k2-(t28*t12/t1*spak3k5*spbk4k2*spbk6k&
      &2+t28*t16/t1*spbk5k4*spbk6k2+t28*t16/t1*spbk4k2*spbk6k5+t19)))
      t14 = TR*spak1k5
      t14 = t14*t14
      abb2n16 = ((4.0_ki)*(t28/t3*t4*spbk4k2+t14/t3*t7*spbk2k1*spbk5k4+t28/t3*t9&
      &*spbk4k2*spbk6k2+t28*t10/t3*spak5k6*spbk5k4*spbk6k2-(t28*t15/t1*spak5k6*s&
      &pbk5k4*spbk6k2+t28*t13/t1*spbk4k2*spbk6k2+t11/t1*t14*spbk2k1*spbk5k4+t28/&
      &t1*t6*spbk4k2)))
      abb2n17 = ((8.0_ki)*(t28*t10/t3*spbk6k2-t28*t15/t1*spbk6k2))
      abb2n18 = ((4.0_ki)*(t28*t15/t1*spbk6k5+t28/t3*t8*spbk6k2-(t28*t10/t3*spbk&
      &6k5+t28*t12/t1*spbk6k2)))
      t4 = t7*spak2k3
      t6 = t11*spak2k3
      abb2n19 = ((4.0_ki)*(t28*t21/t1*spbk6k1*spbk6k4+t28/t1*t5*spak3k5*spbk6k4+&
      &t28/t1*t6*spak5k6*spbk6k2*spbk6k4-(t28/t3*t4*spak5k6*spbk6k2*spbk6k4+t28*&
      &t2/t3*spak3k5*spbk6k4+t28*t18/t3*spbk6k1*spbk6k4)))
      abb2n20 = ((4.0_ki)*(t28/t3*t4*spbk6k4-t28/t1*t6*spbk6k4))
      t2 = t28*t23/t3*spbk4k2
      t4 = t28*t24/t1*spbk4k2
      abb2n21 = ((8.0_ki)*(t2-t4))
      t2 = t4-t2
      abb2n22 = ((4.0_ki)*t2)
      abb2n23 = ((8.0_ki)*t2)
      abb2n24 = ((4.0_ki)*(t28*t24/t1*spbk5k4-t28*t23/t3*spbk5k4))
      t2 = t28*t23/t3*spbk6k4-t28*t24/t1*spbk6k4
      abb2n25 = ((8.0_ki)*t2)
      abb2n26 = ((4.0_ki)*t2)
      abb2n27 = ((4.0_ki)*(t28*t10/t3*spbk4k1+t28/t3*t7*spak2k5*spbk4k2+t28/t3*t&
      &7*spak5k6*spbk6k4-(t28*t11/t1*spak5k6*spbk6k4+t28*t11/t1*spak2k5*spbk4k2+&
      &t28*t15/t1*spbk4k1)))
      abb2n28 = ((4.0_ki)*(t28*t11/t1-t28/t3*t7))
      rat2d2 = 0
      rat2 = rat2 + rat2d2
      abb2n30 = abb2n1
      abb2n31 = abb2n27
      abb2n32 = abb2n25
      abb2n33 = abb2n24
      abb2n34 = abb2n23
      abb2n35 = abb2n22
      abb2n36 = abb2n21
      abb2n37 = abb2n20
      abb2n38 = abb2n18
      abb2n39 = abb2n17
      abb2n40 = abb2n15
      abb2n41 = abb2n14
      abb2n42 = abb2n11
      abb2n43 = abb2n9
      abb2n44 = abb2n8
      abb2n45 = abb2n7
      abb2n46 = abb2n6
      abb2n47 = abb2n5
      abb2n48 = -(abb2n2)
      abb2n49 = -(abb2n3)
      abb2n50 = -(abb2n4)
      abb2n51 = -(abb2n6)
      abb2n52 = -(abb2n10)
      abb2n53 = -(abb2n12)
      abb2n54 = -(abb2n13)
      abb2n55 = -(abb2n16)
      abb2n56 = -(abb2n19)
      abb2n57 = -(abb2n22)
      abb2n58 = -(abb2n26)
      abb2n59 = -(abb2n28)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd2h0
