module     p1_ddbar_neepscbar_d28h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p1_ddbar_neepscbar/helicity0/d28h0l1d.f90
   ! generator: haggies (1.1)
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d28
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_abbrevd28h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      real(ki) :: t47
      real(ki) :: t48
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t44 = dotproduct(k1, qshift)
      t45 = dotproduct(k5, qshift)
      t2 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t3 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t4 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      t5 = (spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1k6(3)*qshift(3)-sp&
      &vak1k6(4)*qshift(4))
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t7 = (spvak1k4(1)*qshift(1)-spvak1k4(2)*qshift(2)-spvak1k4(3)*qshift(3)-sp&
      &vak1k4(4)*qshift(4))
      t8 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t9 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t46 = dotproduct(k2, qshift)
      t47 = dotproduct(k6, qshift)
      t48 = dotproduct(qshift, qshift)
      if(deg.eq.0) then
         numerator = (t1*abb28n30+t2*abb28n77+t44*abb28n62+t45*abb28n70+t1*t4*ab&
         &b28n50+t1*t5*abb28n56+t2*t3*abb28n33+t2*t8*abb28n43+t3*t44*abb28n49+t3&
         &*t6*abb28n57+t3*t7*abb28n45+t4*t45*abb28n34+t4*t6*abb28n42+t4*t9*abb28&
         &n46+t44*t8*abb28n55+t45*t5*abb28n44+t46*t7*abb28n38+t46*t9*abb28n51+t4&
         &7*t7*abb28n40+t47*t9*abb28n53+t48*t7*abb28n80+t48*t9*abb28n65+t5*t6*ab&
         &b28n35+t5*t9*abb28n37+t6*t8*abb28n47+t7*t8*abb28n36+t3*t5*t6*abb28n89+&
         &t4*t6*t8*abb28n88)
         return
      end if
      t10 = k1(iv1)
      t11 = k5(iv1)
      t12 = spvak1k5(iv1)
      t13 = spvak5k1(iv1)
      t14 = k2(iv1)
      t15 = k6(iv1)
      t16 = qshift(iv1)
      t17 = spvak1k2(iv1)
      t18 = spvak1k4(iv1)
      t19 = spvak1k6(iv1)
      t20 = spvak3k4(iv1)
      t21 = spvak5k2(iv1)
      t22 = spvak5k4(iv1)
      t23 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb28n54+t11*abb28n48+t12*abb28n41+t13*abb28n58+t1*t17&
         &*abb28n68+t1*t19*abb28n60+t10*t3*abb28n69+t10*t8*abb28n61+t11*t4*abb28&
         &n86+t11*t5*abb28n74+t12*t3*abb28n87+t12*t8*abb28n75+t13*t4*abb28n68+t1&
         &3*t5*abb28n60+t14*t7*abb28n82+t14*t9*abb28n67+t15*t7*abb28n78+t15*t9*a&
         &bb28n63+t16*t7*abb28n79+t16*t9*abb28n64+t17*t45*abb28n86+t17*t6*abb28n&
         &76+t17*t9*abb28n72+t18*t3*abb28n73+t18*t46*abb28n82+t18*t47*abb28n78+t&
         &18*t48*abb28n39+t18*t8*abb28n84+t19*t45*abb28n74+t19*t6*abb28n85+t19*t&
         &9*abb28n83+t2*t21*abb28n87+t2*t23*abb28n75+t20*t3*abb28n59+t20*t4*abb2&
         &8n76+t20*t5*abb28n85+t20*t8*abb28n71+t21*t44*abb28n69+t21*t6*abb28n59+&
         &t21*t7*abb28n73+t22*t4*abb28n72+t22*t46*abb28n67+t22*t47*abb28n63+t22*&
         &t48*abb28n52+t22*t5*abb28n83+t23*t44*abb28n61+t23*t6*abb28n71+t23*t7*a&
         &bb28n84+t17*t6*t8*abb28n32+t19*t3*t6*abb28n31+t20*t3*t5*abb28n31+t20*t&
         &4*t8*abb28n32+t21*t5*t6*abb28n31+t23*t4*t6*abb28n32)
         return
      end if
      t44 = d(iv1,iv2)
      t1 = spvak5k2(iv2)
      t2 = spvak5k6(iv2)
      t24 = k1(iv2)
      t25 = spvak1k4(iv2)
      t26 = spvak5k4(iv2)
      t27 = k2(iv2)
      t28 = spvak1k2(iv2)
      t29 = spvak1k6(iv2)
      t30 = k5(iv2)
      t31 = k6(iv2)
      t32 = qshift(iv2)
      t33 = spvak3k4(iv2)
      t34 = t17*t33
      t35 = spvak5k1(iv2)
      t36 = t20*t28
      t37 = spvak1k5(iv2)
      t38 = t19*t33
      t39 = t20*t29
      t40 = t1*t20
      t41 = t2*t20
      t42 = t21*t33
      t43 = t23*t33
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t44*t7*abb28n80+t44*t9*abb28n65)+t34*abb28n42+t3&
         &6*abb28n42+t38*abb28n35+t39*abb28n35+t40*abb28n57+t41*abb28n47+t42*abb&
         &28n57+t43*abb28n47+t1*t10*abb28n49+t1*t12*abb28n33+t1*t18*abb28n45+t10&
         &*t2*abb28n55+t11*t28*abb28n34+t11*t29*abb28n44+t12*t2*abb28n43+t13*t28&
         &*abb28n50+t13*t29*abb28n56+t14*t25*abb28n38+t14*t26*abb28n51+t15*t25*a&
         &bb28n40+t15*t26*abb28n53+t16*t25*abb28n81+t16*t26*abb28n66+t17*t26*abb&
         &28n46+t17*t30*abb28n34+t17*t35*abb28n50+t18*t2*abb28n36+t18*t27*abb28n&
         &38+t18*t31*abb28n40+t18*t32*abb28n81+t19*t26*abb28n37+t19*t30*abb28n44&
         &+t19*t35*abb28n56+t21*t24*abb28n49+t21*t25*abb28n45+t21*t37*abb28n33+t&
         &22*t27*abb28n51+t22*t28*abb28n46+t22*t29*abb28n37+t22*t31*abb28n53+t22&
         &*t32*abb28n66+t23*t24*abb28n55+t23*t25*abb28n36+t23*t37*abb28n43+t3*t3&
         &8*abb28n89+t3*t39*abb28n89+t34*t8*abb28n88+t36*t8*abb28n88+t4*t41*abb2&
         &8n88+t4*t43*abb28n88+t40*t5*abb28n89+t42*t5*abb28n89+t1*t19*t6*abb28n8&
         &9+t17*t2*t6*abb28n88+t21*t29*t6*abb28n89+t23*t28*t6*abb28n88)
         return
      end if
      t45 = d(iv2,iv3)
      t46 = d(iv1,iv3)
      t3 = spvak5k6(iv3)
      t4 = spvak3k4(iv3)
      t5 = spvak1k2(iv3)
      t6 = spvak5k2(iv3)
      t7 = spvak1k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k4(iv3)*t44*abb28n39+spvak5k4(iv3)*t44*abb&
         &28n52+t18*t45*abb28n39+t22*t45*abb28n52+t25*t46*abb28n39+t26*t46*abb28&
         &n52)+t3*t34*abb28n32+t3*t36*abb28n32+t38*t6*abb28n31+t39*t6*abb28n31+t&
         &1*t19*t4*abb28n31+t1*t20*t7*abb28n31+t17*t2*t4*abb28n32+t2*t20*t5*abb2&
         &8n32+t21*t29*t4*abb28n31+t21*t33*t7*abb28n31+t23*t28*t4*abb28n32+t23*t&
         &33*t5*abb28n32)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d28:
   subroutine     reconstruct_d28(coeffs)
      use p1_ddbar_neepscbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_28:
      coeffs%coeffs_28%c0 = derivative(czip)
      coeffs%coeffs_28%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_28%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_28%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_28%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_28%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_28%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_28%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_28%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_28%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_28%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_28%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_28%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_28%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_28%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_28%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_28%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_28%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_28%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_28%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_28%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_28%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_28%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_28%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_28%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_28%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_28%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_28%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_28%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_28%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_28%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_28%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_28:
   end subroutine reconstruct_d28
!---#] subroutine reconstruct_d28:
end module p1_ddbar_neepscbar_d28h0l1d
