module     p1_ddbar_neepscbar_abbrevd3h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb3n1
   complex(ki), public :: abb3n2
   complex(ki), public :: abb3n3
   complex(ki), public :: abb3n4
   complex(ki), public :: abb3n5
   complex(ki), public :: abb3n6
   complex(ki), public :: abb3n7
   complex(ki), public :: abb3n8
   complex(ki), public :: abb3n9
   complex(ki), public :: abb3n10
   complex(ki), public :: abb3n11
   complex(ki), public :: abb3n12
   complex(ki), public :: abb3n13
   complex(ki), public :: abb3n14
   complex(ki), public :: abb3n15
   complex(ki), public :: abb3n16
   complex(ki), public :: abb3n17
   complex(ki), public :: abb3n18
   complex(ki), public :: abb3n19
   complex(ki), public :: abb3n20
   complex(ki), public :: abb3n21
   complex(ki), public :: abb3n22
   complex(ki), public :: abb3n23
   complex(ki), public :: abb3n24
   complex(ki), public :: abb3n25
   complex(ki), public :: abb3n26
   complex(ki), public :: abb3n27
   complex(ki), public :: abb3n28
   complex(ki), public :: abb3n29
   complex(ki), public :: rat2d3
   complex(ki), public :: abb3n31
   complex(ki), public :: abb3n32
   complex(ki), public :: abb3n33
   complex(ki), public :: abb3n34
   complex(ki), public :: abb3n35
   complex(ki), public :: abb3n36
   complex(ki), public :: abb3n37
   complex(ki), public :: abb3n38
   complex(ki), public :: abb3n39
   complex(ki), public :: abb3n40
   complex(ki), public :: abb3n41
   complex(ki), public :: abb3n42
   complex(ki), public :: abb3n43
   complex(ki), public :: abb3n44
   complex(ki), public :: abb3n45
   complex(ki), public :: abb3n46
   complex(ki), public :: abb3n47
   complex(ki), public :: abb3n48
   complex(ki), public :: abb3n49
   complex(ki), public :: abb3n50
   complex(ki), public :: abb3n51
   complex(ki), public :: abb3n52
   complex(ki), public :: abb3n53
   complex(ki), public :: abb3n54
   complex(ki), public :: abb3n55
   complex(ki), public :: abb3n56
   complex(ki), public :: abb3n57
   complex(ki), public :: abb3n58
   complex(ki), public :: abb3n59
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   real(ki) :: t24
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = es56*c1*i_
      t24 = TR*TR
      t3 = es12*NC*NC*t1
      t4 = es56*c2*i_
      t1 = es12*NC*t1
      abb3n1 = ((4.0_ki)*(t24/t1*t4*spak1k2*spak3k5*spbk4k1*spbk6k1+t24*t2/t3*sp&
      &ak2k6*spak3k5*spbk6k1*spbk6k4-(t24*t2/t3*spak1k2*spak3k5*spbk4k1*spbk6k1+&
      &t24/t1*t4*spak2k6*spak3k5*spbk6k1*spbk6k4)))
      t5 = c1*i_
      t6 = t5*spak1k2
      t7 = TR*spbk6k1
      t7 = t7*t7
      t8 = c2*i_
      t9 = t8*spak1k2
      abb3n2 = ((4.0_ki)*(t7/t1*t9*spak5k6-t6/t3*t7*spak5k6))
      abb3n3 = ((4.0_ki)*(t24/t1*t9*spbk6k1-t24/t3*t6*spbk6k1))
      t7 = t5*spak2k5
      t10 = t7*spak3k5
      t11 = t10*spbk4k1
      t12 = t8*spak2k5
      t13 = t12*spak3k5
      t14 = t13*spbk4k1
      abb3n4 = ((4.0_ki)*(t24*t14/t1*spbk5k1-t24*t11/t3*spbk5k1))
      t15 = t24/t3*t7*spbk4k1
      t16 = t24*t12/t1*spbk4k1
      abb3n5 = ((8.0_ki)*(t15-t16))
      t15 = t16-t15
      abb3n6 = ((4.0_ki)*t15)
      abb3n7 = ((8.0_ki)*t15)
      t15 = t5*spak3k5
      t16 = t24*t15/t3*spbk4k1
      t17 = t8*spak3k5
      t18 = t24*t17/t1*spbk4k1
      t19 = t16-t18
      abb3n8 = ((8.0_ki)*t19)
      abb3n9 = ((4.0_ki)*t19)
      abb3n10 = ((8.0_ki)*(t18-t16))
      t16 = t5*spak2k3
      t18 = t16*spak5k6
      t19 = t24*t18/t3*spbk6k1*spbk6k4
      t20 = t8*spak2k3
      t21 = t20*spak5k6
      t22 = t24*t21/t1*spbk6k1*spbk6k4
      abb3n11 = ((8.0_ki)*(t19+t24*t13/t1*spbk5k1*spbk6k4-(t24*t10/t3*spbk5k1*sp&
      &bk6k4+t22)))
      abb3n12 = ((8.0_ki)*(t22-t19))
      t10 = t24*t16/t3*spbk6k1
      t13 = t24*t20/t1*spbk6k1
      t23 = t10-t13
      abb3n13 = ((8.0_ki)*t23)
      abb3n14 = ((4.0_ki)*t23)
      abb3n15 = ((8.0_ki)*(t13-t10))
      abb3n16 = ((4.0_ki)*(t19+t24*t14/t1*spbk6k5+t24*t12/t1*spak3k6*spbk6k1*spb&
      &k6k4+t24*t20/t1*spak2k5*spbk2k1*spbk6k4-(t24/t3*t7*spak3k6*spbk6k1*spbk6k&
      &4+t24*t16/t3*spak2k5*spbk2k1*spbk6k4+t24*t11/t3*spbk6k5+t22)))
      t10 = t24/t3*t7*spbk6k1
      t11 = t24*t12/t1*spbk6k1
      abb3n17 = ((8.0_ki)*(t10-t11))
      abb3n18 = ((4.0_ki)*(t11-t10))
      t10 = t5*spak2k6
      t11 = t8*spak2k6
      abb3n19 = ((8.0_ki)*(t24/t1*t9*spak3k5*spbk4k1*spbk6k1+t24*t10/t3*spak3k5*&
      &spbk6k1*spbk6k4-(t24/t3*t6*spak3k5*spbk4k1*spbk6k1+t24*t11/t1*spak3k5*spb&
      &k6k1*spbk6k4)))
      abb3n20 = ((4.0_ki)*(t24*t11/t1*spbk6k1-t24*t10/t3*spbk6k1))
      t2 = t2*spak3k5
      t4 = t4*spak3k5
      abb3n21 = ((8.0_ki)*(t24*t2/t3*spbk4k1-t24/t1*t4*spbk4k1)+(4.0_ki)*(t24*t1&
      &8/t3*spbk2k1*spbk6k4+t24*t17/t1*spak5k6*spbk5k1*spbk6k4+es234*t24/t1*c2*i&
      &_*spak3k5*spbk4k1+t24/t3*t5*spak3k6*spak5k6*spbk6k1*spbk6k4+es61*t24/t3*c&
      &1*i_*spak3k5*spbk4k1-(es234*t24/t3*c1*i_*spak3k5*spbk4k1+es61*t24/t1*c2*i&
      &_*spak3k5*spbk4k1+t24/t1*t8*spak3k6*spak5k6*spbk6k1*spbk6k4+t24*t15/t3*sp&
      &ak5k6*spbk5k1*spbk6k4+t24*t21/t1*spbk2k1*spbk6k4)))
      t6 = t5*spak5k6
      t9 = t8*spak5k6
      abb3n22 = ((8.0_ki)*(t24/t3*t6*spbk6k1-t24/t1*t9*spbk6k1))
      t10 = t5*spak1k3
      t11 = t8*spak1k3
      abb3n23 = ((4.0_ki)*(t24*t2/t3*spbk6k4+t24*t18/t3*spbk6k2*spbk6k4+t24*t10/&
      &t3*spak5k6*spbk6k1*spbk6k4-(t24*t11/t1*spak5k6*spbk6k1*spbk6k4+t24*t21/t1&
      &*spbk6k2*spbk6k4+t24/t1*t4*spbk6k4)))
      abb3n24 = ((4.0_ki)*(t24*t10/t3*spbk6k1+t24*t16/t3*spbk6k2-(t24*t20/t1*spb&
      &k6k2+t24*t11/t1*spbk6k1)))
      abb3n25 = ((4.0_ki)*(t24*t15/t3*spbk4k2-t24*t17/t1*spbk4k2))
      abb3n26 = ((4.0_ki)*(t24*t17/t1*spbk5k4-t24*t15/t3*spbk5k4))
      abb3n27 = ((8.0_ki)*(t24*t15/t3*spbk6k4-t24*t17/t1*spbk6k4))
      abb3n28 = ((4.0_ki)*(t24*t12/t1*spbk4k2+t24/t3*t6*spbk6k4+t24/t1*t8*spak1k&
      &5*spbk4k1-(t24/t3*t5*spak1k5*spbk4k1+t24/t3*t7*spbk4k2+t24/t1*t9*spbk6k4)&
      &))
      abb3n29 = ((4.0_ki)*(t24/t3*t5-t24/t1*t8))
      rat2d3 = 0
      rat2 = rat2 + rat2d3
      abb3n31 = abb3n1
      abb3n32 = abb3n29
      abb3n33 = abb3n28
      abb3n34 = abb3n27
      abb3n35 = abb3n26
      abb3n36 = abb3n25
      abb3n37 = abb3n24
      abb3n38 = abb3n23
      abb3n39 = abb3n22
      abb3n40 = abb3n21
      abb3n41 = abb3n20
      abb3n42 = abb3n19
      abb3n43 = abb3n18
      abb3n44 = abb3n17
      abb3n45 = abb3n16
      abb3n46 = abb3n15
      abb3n47 = abb3n14
      abb3n48 = abb3n13
      abb3n49 = abb3n12
      abb3n50 = abb3n11
      abb3n51 = abb3n10
      abb3n52 = abb3n9
      abb3n53 = abb3n8
      abb3n54 = abb3n7
      abb3n55 = abb3n6
      abb3n56 = abb3n5
      abb3n57 = abb3n4
      abb3n58 = abb3n3
      abb3n59 = abb3n2
   end subroutine
end module p1_ddbar_neepscbar_abbrevd3h1
