module     p9_udbar_neepgg_color
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/common/color.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_model, only: NC, Nf
   implicit none
   save

   private :: ki, NC, Nf

   real(ki), parameter :: TR = 0.5_ki

   complex(ki), parameter, private :: i_ = (0.0_ki, 1.0_ki)
   real(ki), parameter, private :: pi = &
   & 3.1415926535897932384626433832795028841971693993751058209749445920_ki
   real(ki), parameter, private :: pi6 = pi*pi/6.0_ki

   integer, parameter :: numcs = 3
   complex(ki), dimension(numcs, numcs) :: CC
   complex(ki), dimension(numcs, numcs) :: T1T1
   complex(ki), dimension(numcs, numcs) :: T1T2
   complex(ki), dimension(numcs, numcs) :: T1T5
   complex(ki), dimension(numcs, numcs) :: T1T6
   complex(ki), dimension(numcs, numcs) :: T2T2
   complex(ki), dimension(numcs, numcs) :: T2T5
   complex(ki), dimension(numcs, numcs) :: T2T6
   complex(ki), dimension(numcs, numcs) :: T5T5
   complex(ki), dimension(numcs, numcs) :: T5T6
   complex(ki), dimension(numcs, numcs) :: T6T6
   real(ki) :: incolors

   real(ki) :: CA, CF, KA, KF, gammaA, gammaF

   ! Basis vectors
   real(ki), dimension(numcs), parameter :: c1 = &
      & (/1.0_ki, 0.0_ki, 0.0_ki/)
   real(ki), dimension(numcs), parameter :: c2 = &
      & (/0.0_ki, 1.0_ki, 0.0_ki/)
   real(ki), dimension(numcs), parameter :: c3 = &
      & (/0.0_ki, 0.0_ki, 1.0_ki/)
contains
   subroutine     init_color()
      implicit none
      real(ki) :: NA
      real(ki) :: t1
      real(ki) :: t2
      real(ki) :: t3
      real(ki) :: t4
      real(ki) :: t5
      real(ki) :: t6
      real(ki) :: t7
      real(ki) :: t8
      real(ki) :: t9
      real(ki) :: t10
      real(ki) :: t11
      real(ki) :: t12
      real(ki) :: t13
      real(ki) :: t14
      
      t1 = NC*NC
      t2 = t1-1.0_ki
      NA = t2
      incolors = t1
      t3 = t1-2.0_ki
      t4 = 1.0_ki/NC+t3*NC
      t5 = TR*TR
      t6 = t4*t5
      CC(1, 1) = t6
      CC(1, 1) = t6
      t7 = (1.0_ki/NC-NC)*t5
      CC(1, 2) = t7
      CC(2, 1) = t7
      t8 = t2*t5
      CC(1, 3) = t8
      CC(3, 1) = t8
      CC(2, 1) = t7
      CC(1, 2) = t7
      CC(2, 2) = t6
      CC(2, 2) = t6
      CC(2, 3) = t8
      CC(3, 2) = t8
      CC(3, 1) = t8
      CC(1, 3) = t8
      CC(3, 2) = t8
      CC(2, 3) = t8
      t6 = t2*NC
      t7 = t5*t6
      CC(3, 3) = t7
      CC(3, 3) = t7
      t8 = (3.0_ki+(t1-3.0_ki)*t1-1.0_ki/t1)*t5*TR
      T1T1(1, 1) = t8
      T1T1(1, 1) = t8
      t9 = (2.0_ki-(t1+1.0_ki/t1))*t5*TR
      T1T1(1, 2) = t9
      T1T1(2, 1) = t9
      t4 = t4*t5*TR
      T1T1(1, 3) = t4
      T1T1(3, 1) = t4
      T1T1(2, 2) = t8
      T1T1(2, 2) = t8
      T1T1(2, 3) = t4
      T1T1(3, 2) = t4
      t3 = 1.0_ki+t1*t3
      t10 = t3*t5*TR
      T1T1(3, 3) = t10
      T1T1(3, 3) = t10
      t11 = (1.0_ki/t1-1.0_ki)*t5*TR
      T1T2(1, 1) = t11
      T1T2(1, 1) = t11
      T1T2(1, 2) = ((1.0_ki/t1-t1)*t5*TR)
      T1T2(2, 1) = ((1.0_ki/t1-t1)*t5*TR)
      t12 = 2.0_ki-t1
      t13 = (1.0_ki/NC-t12*NC)*t5*TR
      T1T2(1, 3) = -(t13)
      T1T2(3, 1) = -(t13)
      T1T2(2, 2) = t11
      T1T2(2, 2) = t11
      T1T2(2, 3) = -(t13)
      T1T2(3, 2) = -(t13)
      t11 = (1.0_ki-t1*t12)*t5*TR
      T1T2(3, 3) = -(t11)
      T1T2(3, 3) = -(t11)
      t12 = t2*t5*TR
      T1T5(1, 1) = t12
      T1T5(1, 1) = t12
      T1T5(1, 2) = t12
      T1T5(2, 1) = t12
      t6 = t5*t6*TR
      T1T5(1, 3) = t6
      T1T5(3, 1) = t6
      T1T5(2, 2) = -(t11)
      T1T5(2, 2) = -(t11)
      t13 = 1.0_ki-t1
      t14 = t13*t5*NC*TR
      T1T5(2, 3) = t14
      T1T5(3, 2) = t14
      T1T5(3, 3) = 0.0_ki
      T1T5(3, 3) = 0.0_ki
      T1T6(1, 1) = -(t11)
      T1T6(1, 1) = -(t11)
      T1T6(1, 2) = t12
      T1T6(2, 1) = t12
      T1T6(1, 3) = t14
      T1T6(3, 1) = t14
      T1T6(2, 2) = t12
      T1T6(2, 2) = t12
      T1T6(2, 3) = t6
      T1T6(3, 2) = t6
      T1T6(3, 3) = 0.0_ki
      T1T6(3, 3) = 0.0_ki
      T2T2(1, 1) = t8
      T2T2(1, 1) = t8
      T2T2(1, 2) = t9
      T2T2(2, 1) = t9
      T2T2(1, 3) = t4
      T2T2(3, 1) = t4
      T2T2(2, 2) = t8
      T2T2(2, 2) = t8
      T2T2(2, 3) = t4
      T2T2(3, 2) = t4
      T2T2(3, 3) = t10
      T2T2(3, 3) = t10
      T2T5(1, 1) = -(t11)
      T2T5(1, 1) = -(t11)
      T2T5(1, 2) = t12
      T2T5(2, 1) = t12
      T2T5(1, 3) = t14
      T2T5(3, 1) = t14
      T2T5(2, 2) = t12
      T2T5(2, 2) = t12
      T2T5(2, 3) = t6
      T2T5(3, 2) = t6
      T2T5(3, 3) = 0.0_ki
      T2T5(3, 3) = 0.0_ki
      T2T6(1, 1) = t12
      T2T6(1, 1) = t12
      T2T6(1, 2) = t12
      T2T6(2, 1) = t12
      T2T6(1, 3) = t6
      T2T6(3, 1) = t6
      T2T6(2, 2) = -(t11)
      T2T6(2, 2) = -(t11)
      T2T6(2, 3) = t14
      T2T6(3, 2) = t14
      T2T6(3, 3) = 0.0_ki
      T2T6(3, 3) = 0.0_ki
      t3 = t3*t5
      T5T5(1, 1) = t3
      T5T5(1, 1) = t3
      t4 = t13*t5
      T5T5(1, 2) = t4
      T5T5(2, 1) = t4
      T5T5(1, 3) = t7
      T5T5(3, 1) = t7
      T5T5(2, 2) = t3
      T5T5(2, 2) = t3
      T5T5(2, 3) = t7
      T5T5(3, 2) = t7
      t6 = NC*TR
      t6 = t6*t6
      t2 = t2*t6
      T5T5(3, 3) = t2
      T5T5(3, 3) = t2
      t8 = t13*t6*TR
      T5T6(1, 1) = t8
      T5T6(1, 1) = t8
      T5T6(1, 2) = 0.0_ki
      T5T6(2, 1) = 0.0_ki
      t1 = 2.0_ki-2.0_ki*t1
      t5 = t1*t5*NC*TR
      T5T6(1, 3) = t5
      T5T6(3, 1) = t5
      T5T6(2, 2) = t8
      T5T6(2, 2) = t8
      T5T6(2, 3) = t5
      T5T6(3, 2) = t5
      T5T6(3, 3) = (t1*t6*TR)
      T5T6(3, 3) = (t1*t6*TR)
      T6T6(1, 1) = t3
      T6T6(1, 1) = t3
      T6T6(1, 2) = t4
      T6T6(2, 1) = t4
      T6T6(1, 3) = t7
      T6T6(3, 1) = t7
      T6T6(2, 2) = t3
      T6T6(2, 2) = t3
      T6T6(2, 3) = t7
      T6T6(3, 2) = t7
      T6T6(3, 3) = t2
      T6T6(3, 3) = t2

      CA = NC
      CF = TR * NA / NC
      ! KA = Kg in (C.11) [Catani,Seymour]
      KA = (67.0_ki/18.0_ki - pi6) * CA &
         & - 10.0_ki/9.0_ki * TR * Nf
      ! KF = Kq in (C.11) [Catani,Seymour]
      KF = (3.5_ki - pi6) * CF
      ! gammaA = \gamma_g in (C.11) [Catani,Seymour]
      gammaA = 11.0_ki/6.0_ki * CA - 2.0_ki/3.0_ki * TR * Nf
      ! gammaF = \gamma_q in (C.11) [Catani,Seymour]
      gammaF = 1.5_ki * CF
   end subroutine init_color
   subroutine     inspect_color(unit)
      implicit none
      integer, intent(in) :: unit
      integer :: i, j
      character :: ch1, ch2, ch3

      ch3 = ","
      write (unit,'(A13)') "golem_color=["
      do i=1,numcs
         do j=1,numcs
            if (j==1) then
               ch1 = "["
            else
               ch1 = " "
            endif

            if (j == numcs) then
               ch2 = "]"
               if (i == numcs) then
                  ch3 = "]"
               end if
            else
               ch2 = ","
            end if

            if (j == numcs) then
               write (unit,'(3x,A1,A8,G23.16,A1,G23.16,A1,A1,A1)') &
               & ch1, "complex(", real(CC(i,j)), ",", aimag(CC(i,j)), ")", &
               & ch2, ch3
            else
               write (unit,'(3x,A1,A8,G23.16,A1,G23.16,A1,A1)') &
               & ch1, "complex(", real(CC(i,j)), ",", aimag(CC(i,j)), ")", &
               & ch2
            end if
         enddo
      enddo
   end subroutine inspect_color
end module p9_udbar_neepgg_color
