module     p9_udbar_neepgg_abbrevd27h0
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb27n1
   complex(ki), public :: abb27n2
   complex(ki), public :: abb27n3
   complex(ki), public :: abb27n4
   complex(ki), public :: abb27n5
   complex(ki), public :: abb27n6
   complex(ki), public :: abb27n7
   complex(ki), public :: abb27n8
   complex(ki), public :: abb27n9
   complex(ki), public :: abb27n10
   complex(ki), public :: abb27n11
   complex(ki), public :: abb27n12
   complex(ki), public :: abb27n13
   complex(ki), public :: abb27n14
   complex(ki), public :: abb27n15
   complex(ki), public :: abb27n16
   complex(ki), public :: abb27n17
   complex(ki), public :: abb27n18
   complex(ki), public :: abb27n19
   complex(ki), public :: abb27n20
   complex(ki), public :: abb27n21
   complex(ki), public :: abb27n22
   complex(ki), public :: rat2d27
   complex(ki), public :: abb27n24
   complex(ki), public :: abb27n25
   complex(ki), public :: abb27n26
   complex(ki), public :: abb27n27
   complex(ki), public :: abb27n28
   complex(ki), public :: abb27n29
   complex(ki), public :: abb27n30
   complex(ki), public :: abb27n31
   complex(ki), public :: abb27n32
   complex(ki), public :: abb27n33
   complex(ki), public :: abb27n34
   complex(ki), public :: abb27n35
   complex(ki), public :: abb27n36
   complex(ki), public :: abb27n37
   complex(ki), public :: abb27n38
   complex(ki), public :: abb27n39
   complex(ki), public :: abb27n40
   complex(ki), public :: abb27n41
   complex(ki), public :: abb27n42
   complex(ki), public :: abb27n43
   complex(ki), public :: abb27n44
   complex(ki), public :: abb27n45
   complex(ki), public :: abb27n46
   complex(ki), public :: abb27n47
   complex(ki), public :: abb27n48
   complex(ki), public :: abb27n49
   complex(ki), public :: abb27n50
   complex(ki), public :: abb27n51
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = TR*c2
      t2 = es234*t1
      t3 = NC*(es345-(es61+es12))*(es34+wW*mW*i_-mW*mW)
      t4 = t3*spak5k6*spak5k6
      t5 = es34*t1
      t6 = es345*t1
      t7 = t6*i_
      t8 = t7*spak2k3*spak2k5
      t9 = es61*t1*i_
      t10 = t9*spak2k3*spak2k5
      t11 = t1*i_
      t12 = t11*spak1k3
      t13 = spak2k5*spak2k5
      abb27n1 = ((4.0_ki)*(t10/t4*spbk5k4*spbk6k2+t11*t13/t4*spak3k6*spbk5k4*spb&
      &k6k2*spbk6k5+t5/t4*i_*spak2k3*spak2k5*spbk5k4*spbk6k2-(t2/t4*i_*spak2k3*s&
      &pak2k5*spbk5k4*spbk6k2+t12*t13/t4*spbk5k1*spbk5k4*spbk6k2+t8/t4*spbk5k4*s&
      &pbk6k2)))
      t1 = es12*t1
      t14 = t1*i_
      t15 = t14*spak2k5
      t16 = t7*spak2k5
      t17 = t9*spak2k5
      abb27n2 = ((4.0_ki)*(t15/t4*spbk5k1+t17/t4*spbk5k1-t16/t4*spbk5k1))
      t18 = t15*spak3k6*spbk5k4
      t19 = t16*spak3k6*spbk5k4
      t20 = t17*spak3k6*spbk5k4
      abb27n3 = ((4.0_ki)*(t18/t4*spbk6k1+t20/t4*spbk6k1+t10/t4*spbk2k1*spbk5k4+&
      &t14/t4*spak2k3*spak2k5*spbk2k1*spbk5k4-(t8/t4*spbk2k1*spbk5k4+t19/t4*spbk&
      &6k1)))
      t8 = t11*spak2k3
      t10 = t8*spbk5k4
      abb27n4 = ((4.0_ki)*(t19/t4*spbk6k5+es234*t1/t4*i_*spak2k3*spbk5k4+es345*t&
      &1/t4*i_*spak2k3*spbk5k4+t14/t4*spak1k3*spak2k5*spbk5k1*spbk5k4+es61*t2/t4&
      &*i_*spak2k3*spbk5k4+es345*t5/t4*i_*spak2k3*spbk5k4+es61*(2.0_ki)/t4*t6*i_&
      &*spak2k3*spbk5k4+t9/t4*spak1k3*spak2k5*spbk5k1*spbk5k4-(t7/t4*spak1k3*spa&
      &k2k5*spbk5k1*spbk5k4+es61*t5/t4*i_*spak2k3*spbk5k4+es345*t2/t4*i_*spak2k3&
      &*spbk5k4+es61*t1/t4*i_*spak2k3*spbk5k4+es34*t1/t4*i_*spak2k3*spbk5k4+t20/&
      &t4*spbk6k5+t18/t4*spbk6k5+es61*es61*t10/t4+es345*es345*t10/t4)))
      t1 = t15/t4*spbk5k4
      t2 = t16/t4*spbk5k4
      t5 = t17/t4*spbk5k4
      abb27n5 = ((4.0_ki)*(t1+t5-t2))
      abb27n6 = ((8.0_ki)*(t2-(t5+t1)))
      t1 = t12*spak2k5
      t2 = t3*spak5k6
      abb27n7 = (-4.0_ki)*t1/t2*spbk5k1*spbk5k4*spbk6k2
      t3 = t8*spak2k5
      t5 = (8.0_ki)*t3/t4*spbk4k1*spbk6k2
      abb27n8 = t5
      abb27n9 = -(t5)
      t5 = t11*spak2k5
      t6 = t5*spak3k6
      abb27n10 = (-4.0_ki)/t4*t6*spbk4k1*spbk6k2
      abb27n11 = (-8.0_ki)/t2*t3*spbk5k1*spbk5k4*spbk6k2
      abb27n12 = (-4.0_ki)/t4*t5*spak3k5*spbk5k1*spbk6k2
      t6 = t6*spbk5k1
      abb27n13 = (-4.0_ki)/t2*t6*spbk5k4*spbk6k2
      t6 = t6/t4*spbk6k2
      abb27n14 = ((8.0_ki)*t6)
      abb27n15 = (-4.0_ki)*t6
      abb27n16 = (-4.0_ki)/t2*t5*spbk5k1*spbk6k2
      abb27n17 = ((4.0_ki)*(t3/t4*spbk4k2*spbk6k2-t1/t4*spbk4k1*spbk6k2))
      t1 = t3/t4*spbk5k4*spbk6k2
      abb27n18 = ((8.0_ki)*t1)
      abb27n19 = (-4.0_ki)*t1
      abb27n20 = ((4.0_ki)*t3/t4*spbk6k2*spbk6k4)
      abb27n21 = ((4.0_ki)*(t16/t4*spbk6k4+t11*t13/t4*spbk5k4*spbk6k2+t11/t4*spa&
      &k1k2*spak2k5*spbk4k1*spbk6k2-(t17/t4*spbk6k4+t15/t4*spbk6k4)))
      abb27n22 = (-4.0_ki)/t4*t5*spbk6k2
      rat2d27 = 0
      rat2 = rat2 + rat2d27
      abb27n24 = -(abb27n1)
      abb27n25 = abb27n21
      abb27n26 = abb27n20
      abb27n27 = abb27n19
      abb27n28 = abb27n18
      abb27n29 = abb27n17
      abb27n30 = abb27n16
      abb27n31 = abb27n14
      abb27n32 = abb27n12
      abb27n33 = abb27n10
      abb27n34 = abb27n9
      abb27n35 = abb27n8
      abb27n36 = abb27n6
      abb27n37 = abb27n3
      abb27n38 = -(abb27n2)
      abb27n39 = (-2.0_ki)*abb27n2
      abb27n40 = ((2.0_ki)*abb27n3)
      abb27n41 = -(abb27n4)
      abb27n42 = -(abb27n5)
      abb27n43 = (-2.0_ki)*abb27n5
      abb27n44 = -(abb27n7)
      abb27n45 = -(abb27n11)
      abb27n46 = -(abb27n13)
      abb27n47 = -(abb27n15)
      abb27n48 = (-2.0_ki)*abb27n15
      abb27n49 = -(abb27n19)
      abb27n50 = (-2.0_ki)*abb27n19
      abb27n51 = -(abb27n22)
   end subroutine
end module p9_udbar_neepgg_abbrevd27h0
