module     p9_udbar_neepgg_d31h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d31h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d31
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd31h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      real(ki) :: t25
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t20 = dotproduct(k5, qshift)
      t21 = dotproduct(k2, qshift)
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t22 = dotproduct(k1, qshift)
      t23 = dotproduct(k3, qshift)
      t24 = dotproduct(k4, qshift)
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t25 = dotproduct(k6, qshift)
      t5 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t6 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb31n26+t1*abb31n38+t2*abb31n41+t20*abb31n39+t21*abb31n40&
         &+t22*abb31n42+t23*abb31n43+t24*abb31n43+t25*abb31n47+t3*abb31n44+t4*ab&
         &b31n45+t5*abb31n48+t6*abb31n49+abb31n34*dotproduct(qshift, qshift)+t1*&
         &t5*abb31n37+t2*t5*abb31n31+t20*t5*abb31n36+t21*t5*abb31n32+t22*t5*abb3&
         &1n29+t23*t5*abb31n30+t24*t5*abb31n30+t25*t5*abb31n33+t3*t5*abb31n28+t4&
         &*t5*abb31n27+t5*t6*abb31n35)
         return
      end if
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = k3(iv1)
      t10 = k4(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = spvak2k6(iv1)
      t14 = spvak3k1(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k6(iv1)
      t17 = spvak6k1(iv1)
      t18 = spvak6k5(iv1)
      t19 = t16*abb31n30
      if(deg.eq.1) then
         numerator = (qshift(iv1)*abb31n46+t10*abb31n43+t11*abb31n39+t12*abb31n4&
         &7+t13*abb31n49+t14*abb31n45+t15*abb31n44+t16*abb31n48+t17*abb31n38+t18&
         &*abb31n41+t19*t23+t19*t24+t7*abb31n42+t8*abb31n40+t9*abb31n43+t1*t16*a&
         &bb31n37+t10*t5*abb31n30+t11*t5*abb31n36+t12*t5*abb31n33+t13*t5*abb31n3&
         &5+t14*t5*abb31n27+t15*t5*abb31n28+t16*t2*abb31n31+t16*t20*abb31n36+t16&
         &*t21*abb31n32+t16*t22*abb31n29+t16*t25*abb31n33+t16*t3*abb31n28+t16*t4&
         &*abb31n27+t16*t6*abb31n35+t17*t5*abb31n37+t18*t5*abb31n31+t5*t7*abb31n&
         &29+t5*t8*abb31n32+t5*t9*abb31n30)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb31n34+k1(iv2)*t16*abb31n29+k2(iv2)*&
         &t16*abb31n32+k3(iv2)*t16*abb31n30+k4(iv2)*t16*abb31n30+k5(iv2)*t16*abb&
         &31n36+k6(iv2)*t16*abb31n33+spvak2k6(iv2)*t16*abb31n35+spvak3k1(iv2)*t1&
         &6*abb31n27+spvak3k4(iv2)*t16*abb31n28+spvak6k1(iv2)*t16*abb31n37+spvak&
         &6k5(iv2)*t16*abb31n31+t1*t10*abb31n30+t1*t11*abb31n36+t1*t12*abb31n33+&
         &t1*t13*abb31n35+t1*t14*abb31n27+t1*t15*abb31n28+t1*t17*abb31n37+t1*t18&
         &*abb31n31+t1*t7*abb31n29+t1*t8*abb31n32+t1*t9*abb31n30)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d31:
   subroutine     reconstruct_d31(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_31:
      coeffs%coeffs_31%c0 = derivative(czip)
      coeffs%coeffs_31%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_31%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_31%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_31%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_31%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_31%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_31%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_31%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_31%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_31%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_31%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_31%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_31%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_31%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_31:
   end subroutine reconstruct_d31
!---#] subroutine reconstruct_d31:
end module p9_udbar_neepgg_d31h0l1d
