module     p9_udbar_neepgg_d85h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d85h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d85
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd85h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      real(ki) :: t158
      real(ki) :: t159
      real(ki) :: t160
      real(ki) :: t161
      real(ki) :: t162
      real(ki) :: t163
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t158 = dotproduct(qshift, qshift)
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t159 = dotproduct(k2, qshift)
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t160 = dotproduct(k6, qshift)
      t161 = dotproduct(k5, qshift)
      t5 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t10 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-s&
      &pvak3k1(4)*qshift(4))
      t162 = dotproduct(k1, qshift)
      if(deg.eq.0) then
         numerator = (t1*abb85n55+t158*abb85n84+t158*t158*abb85n73+t159*abb85n87&
         &+t2*abb85n86+t3*abb85n90+t1*t158*abb85n91+t1*t160*abb85n63+t1*t161*abb&
         &85n78+t1*t4*abb85n62+t1*t5*abb85n66+t1*t6*abb85n80+t158*t159*abb85n103&
         &+t158*t160*abb85n99+t158*t161*abb85n99+t158*t2*abb85n93+t158*t3*abb85n&
         &114+t158*t4*abb85n101+t158*t6*abb85n88+t159*t161*abb85n71+t159*t4*abb8&
         &5n72+t159*t5*abb85n68+t160*t3*abb85n59+t160*t8*abb85n83+t161*t2*abb85n&
         &76+t161*t3*abb85n65+t2*t4*abb85n77+t2*t5*abb85n74+t3*t4*abb85n58+t3*t5&
         &*abb85n75+t3*t6*abb85n79+t4*t8*abb85n82+t6*t7*abb85n81+t1*t158*t6*abb8&
         &5n60+t1*t161*t6*abb85n122+t1*t4*t5*abb85n118+t10*t158*t5*abb85n61+t10*&
         &t160*t5*abb85n120+t10*t161*t5*abb85n120+t10*t4*t5*abb85n124+t158*t3*t5&
         &*abb85n64+t158*t3*t6*abb85n57+t158*t4*t6*abb85n70+t158*t5*t8*abb85n67+&
         &t158*t6*t7*abb85n69+t159*t4*t5*abb85n95+t160*t3*t5*abb85n119+t160*t5*t&
         &8*abb85n110+t161*t3*t5*abb85n119+t161*t3*t6*abb85n126+t161*t5*t8*abb85&
         &n110+t161*t6*t7*abb85n108+t162*t4*t5*abb85n96+t2*t4*t5*abb85n113+t3*t4&
         &*t5*abb85n116+t4*t5*t8*abb85n111+t4*t6*t9*abb85n107+t5*t6*t7*abb85n112&
         &+t2*t4*t5*t6*abb85n56)
         return
      end if
      t11 = k2(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak5k1(iv1)
      t15 = spvak6k1(iv1)
      t16 = k5(iv1)
      t17 = k6(iv1)
      t18 = t12*abb85n100
      t19 = spvak2k4(iv1)
      t20 = spvak2k6(iv1)
      t21 = spvak3k4(iv1)
      t22 = spvak5k6(iv1)
      t23 = spvak6k5(iv1)
      t24 = k1(iv1)
      t25 = t19*abb85n110
      t26 = spvak2k5(iv1)
      t27 = spvak3k1(iv1)
      t28 = t27*abb85n120
      t29 = t14*abb85n119
      t30 = t23*abb85n110
      t31 = t23*abb85n119
      t32 = t23*abb85n120
      if(deg.eq.1) then
         numerator = (t11*abb85n87+t12*abb85n85+t13*abb85n86+t14*abb85n90+t15*ab&
         &b85n55+t160*t18+t161*t18+t1*t12*abb85n92+t1*t16*abb85n78+t1*t17*abb85n&
         &63+t1*t21*abb85n80+t1*t22*abb85n62+t1*t23*abb85n66+t10*t160*t32+t10*t1&
         &61*t32+t11*t158*abb85n103+t11*t161*abb85n71+t11*t4*abb85n72+t11*t5*abb&
         &85n68+t12*t158*abb85n97+t12*t159*abb85n104+t12*t2*abb85n94+t12*t3*abb8&
         &5n115+t12*t4*abb85n102+t12*t6*abb85n89+t13*t158*abb85n93+t13*t161*abb8&
         &5n76+t13*t4*abb85n77+t13*t5*abb85n74+t14*t158*abb85n114+t14*t160*abb85&
         &n59+t14*t161*abb85n65+t14*t4*abb85n58+t14*t5*abb85n75+t14*t6*abb85n79+&
         &t15*t158*abb85n91+t15*t160*abb85n63+t15*t161*abb85n78+t15*t4*abb85n62+&
         &t15*t5*abb85n66+t15*t6*abb85n80+t158*t16*abb85n99+t158*t17*abb85n99+t1&
         &58*t21*abb85n88+t158*t22*abb85n101+t159*t16*abb85n71+t159*t22*abb85n72&
         &+t159*t23*abb85n68+t16*t2*abb85n76+t16*t3*abb85n65+t160*t19*abb85n83+t&
         &160*t25*t5+t160*t28*t5+t160*t29*t5+t160*t3*t31+t160*t30*t8+t161*t25*t5&
         &+t161*t28*t5+t161*t29*t5+t161*t3*t31+t161*t30*t8+t17*t3*abb85n59+t17*t&
         &8*abb85n83+t19*t4*abb85n82+t2*t22*abb85n77+t2*t23*abb85n74+t20*t6*abb8&
         &5n81+t21*t3*abb85n79+t21*t7*abb85n81+t22*t3*abb85n58+t22*t8*abb85n82+t&
         &23*t3*abb85n75+t1*t12*t6*abb85n123+t1*t158*t21*abb85n60+t1*t16*t6*abb8&
         &5n122+t1*t161*t21*abb85n122+t1*t22*t5*abb85n118+t1*t23*t4*abb85n118+t1&
         &0*t12*t5*abb85n121+t10*t158*t23*abb85n61+t10*t16*t5*abb85n120+t10*t17*&
         &t5*abb85n120+t10*t22*t5*abb85n124+t10*t23*t4*abb85n124+t11*t4*t5*abb85&
         &n95+t12*t3*t5*abb85n117+t12*t3*t6*abb85n125+t12*t4*t6*abb85n105+t12*t5&
         &*t8*abb85n109+t12*t6*t7*abb85n106+t13*t4*t5*abb85n113+t14*t158*t5*abb8&
         &5n64+t14*t158*t6*abb85n57+t14*t161*t6*abb85n126+t14*t4*t5*abb85n116+t1&
         &5*t158*t6*abb85n60+t15*t161*t6*abb85n122+t15*t4*t5*abb85n118+t158*t19*&
         &t5*abb85n67+t158*t20*t6*abb85n69+t158*t21*t3*abb85n57+t158*t21*t4*abb8&
         &5n70+t158*t21*t7*abb85n69+t158*t22*t6*abb85n70+t158*t23*t3*abb85n64+t1&
         &58*t23*t8*abb85n67+t158*t27*t5*abb85n61+t159*t22*t5*abb85n95+t159*t23*&
         &t4*abb85n95+t16*t3*t5*abb85n119+t16*t3*t6*abb85n126+t16*t5*t8*abb85n11&
         &0+t16*t6*t7*abb85n108+t161*t20*t6*abb85n108+t161*t21*t3*abb85n126+t161&
         &*t21*t7*abb85n108+t162*t22*t5*abb85n96+t162*t23*t4*abb85n96+t17*t3*t5*&
         &abb85n119+t17*t5*t8*abb85n110+t19*t4*t5*abb85n111+t2*t22*t5*abb85n113+&
         &t2*t23*t4*abb85n113+t20*t5*t6*abb85n112+t21*t4*t9*abb85n107+t21*t5*t7*&
         &abb85n112+t22*t3*t5*abb85n116+t22*t5*t8*abb85n111+t22*t6*t9*abb85n107+&
         &t23*t3*t4*abb85n116+t23*t4*t8*abb85n111+t23*t6*t7*abb85n112+t24*t4*t5*&
         &abb85n96+t26*t4*t6*abb85n107+t27*t4*t5*abb85n124+t13*t4*t5*t6*abb85n56&
         &+t2*t21*t4*t5*abb85n56+t2*t22*t5*t6*abb85n56+t2*t23*t4*t6*abb85n56)
         return
      end if
      t163 = d(iv1,iv2)
      t18 = qshift(iv2)
      t25 = t163*abb85n99
      t28 = k5(iv2)
      t29 = spvak5k6(iv2)
      t30 = t11*t29
      t31 = spvak6k5(iv2)
      t32 = t11*t31
      t33 = k2(iv2)
      t34 = t22*t33
      t35 = t23*t33
      t36 = spvak2k1(iv2)
      t37 = spvak5k1(iv2)
      t38 = t16*t37
      t39 = spvak6k1(iv2)
      t40 = t16*t39
      t41 = t14*t28
      t42 = t15*t28
      t43 = spvak2k4(iv2)
      t44 = t17*t43
      t45 = t17*t37
      t46 = k6(iv2)
      t47 = t19*t46
      t48 = t14*t46
      t49 = spvak3k4(iv2)
      t50 = t12*t49
      t51 = t12*t37
      t52 = t12*t29
      t53 = t12*t39
      t54 = t18*t21
      t55 = t14*t18
      t56 = t18*t22
      t57 = t15*t18
      t58 = t13*t29
      t59 = t13*t31
      t60 = t22*t36
      t61 = t23*t36
      t62 = t19*t29
      t63 = t22*t43
      t64 = t20*t49
      t65 = spvak2k6(iv2)
      t66 = t21*t65
      t67 = t21*t37
      t68 = t21*t39
      t69 = t14*t49
      t70 = t15*t49
      t71 = t14*t29
      t72 = t14*t31
      t73 = t22*t37
      t74 = t23*t37
      t75 = t22*t39
      t76 = t15*t29
      t77 = t15*t31
      t78 = t23*t39
      t79 = t24*t29
      t80 = k1(iv2)
      t81 = t22*t80
      t82 = t16*t43
      t83 = t16*t65
      t84 = spvak3k1(iv2)
      t85 = t16*t84
      t86 = t16*t49
      t87 = t16*t31
      t88 = t19*t28
      t89 = t20*t28
      t90 = t27*t28
      t91 = t21*t28
      t92 = t23*t28
      t93 = t17*t84
      t94 = t17*t31
      t95 = t27*t46
      t96 = t23*t46
      t97 = t12*t43
      t98 = t12*t65
      t99 = t12*t84
      t100 = t12*t31
      t101 = t18*t19
      t102 = t18*t20
      t103 = t18*t27
      t104 = t18*t23
      t105 = t19*t31
      t106 = t105*abb85n110
      t107 = t23*t43
      t108 = t107*abb85n110
      t109 = t26*t49
      t110 = spvak2k5(iv2)
      t111 = t110*t21
      t112 = t27*t29
      t113 = t27*t31
      t114 = t113*abb85n120
      t115 = t22*t84
      t116 = t23*t84
      t117 = t116*abb85n120
      t118 = t21*t29
      t119 = t21*t31
      t120 = t22*t49
      t121 = t23*t49
      t122 = t72*abb85n119
      t123 = t74*abb85n119
      t124 = t22*t31
      t125 = t23*t29
      t126 = t13*t49
      t127 = t21*t36
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t160*t25+t161*t25+t163*abb85n84+t1*t163*abb85n91&
         &+t12*t18*abb85n97+t158*t163*abb85n98+t159*t163*abb85n103+t163*t2*abb85&
         &n93+t163*t3*abb85n114+t163*t4*abb85n101+t163*t6*abb85n88+t1*t163*t6*ab&
         &b85n60+t10*t163*t5*abb85n61+t163*t3*t5*abb85n64+t163*t3*t6*abb85n57+t1&
         &63*t4*t6*abb85n70+t163*t5*t8*abb85n67+t163*t6*t7*abb85n69)+t106*t160+t&
         &106*t161+t108*t160+t108*t161+t114*t160+t114*t161+t117*t160+t117*t161+t&
         &122*t160+t122*t161+t123*t160+t123*t161+t30*abb85n72+t32*abb85n68+t34*a&
         &bb85n72+t35*abb85n68+t38*abb85n65+t40*abb85n78+t41*abb85n65+t42*abb85n&
         &78+t44*abb85n83+t45*abb85n59+t47*abb85n83+t48*abb85n59+t50*abb85n89+t5&
         &1*abb85n115+t52*abb85n102+t53*abb85n92+t54*abb85n89+t55*abb85n115+t56*&
         &abb85n102+t57*abb85n92+t58*abb85n77+t59*abb85n74+t60*abb85n77+t61*abb8&
         &5n74+t62*abb85n82+t63*abb85n82+t64*abb85n81+t66*abb85n81+t67*abb85n79+&
         &t68*abb85n80+t69*abb85n79+t70*abb85n80+t71*abb85n58+t72*abb85n75+t73*a&
         &bb85n58+t74*abb85n75+t75*abb85n62+t76*abb85n62+t77*abb85n66+t78*abb85n&
         &66+t1*t124*abb85n118+t1*t125*abb85n118+t1*t50*abb85n123+t1*t54*abb85n1&
         &23+t1*t86*abb85n122+t1*t91*abb85n122+t10*t100*abb85n121+t10*t104*abb85&
         &n121+t10*t124*abb85n124+t10*t125*abb85n124+t10*t87*abb85n120+t10*t92*a&
         &bb85n120+t10*t94*abb85n120+t10*t96*abb85n120+t100*t3*abb85n117+t100*t8&
         &*abb85n109+t101*t5*abb85n109+t102*t6*abb85n106+t103*t5*abb85n121+t104*&
         &t3*abb85n117+t104*t8*abb85n109+t105*t158*abb85n67+t105*t4*abb85n111+t1&
         &07*t158*abb85n67+t107*t4*abb85n111+t109*t4*abb85n107+t11*t18*abb85n104&
         &+t11*t28*abb85n71+t111*t4*abb85n107+t112*t5*abb85n124+t113*t158*abb85n&
         &61+t113*t4*abb85n124+t115*t5*abb85n124+t116*t158*abb85n61+t116*t4*abb8&
         &5n124+t118*t158*abb85n70+t118*t9*abb85n107+t119*t7*abb85n112+t12*t28*a&
         &bb85n100+t12*t33*abb85n104+t12*t36*abb85n94+t12*t46*abb85n100+t120*t15&
         &8*abb85n70+t120*t9*abb85n107+t121*t7*abb85n112+t124*t159*abb85n95+t124&
         &*t162*abb85n96+t124*t2*abb85n113+t124*t3*abb85n116+t124*t8*abb85n111+t&
         &125*t159*abb85n95+t125*t162*abb85n96+t125*t2*abb85n113+t125*t3*abb85n1&
         &16+t125*t8*abb85n111+t13*t18*abb85n94+t13*t28*abb85n76+t15*t46*abb85n6&
         &3+t158*t64*abb85n69+t158*t66*abb85n69+t158*t67*abb85n57+t158*t68*abb85&
         &n60+t158*t69*abb85n57+t158*t70*abb85n60+t158*t72*abb85n64+t158*t74*abb&
         &85n64+t16*t18*abb85n100+t16*t33*abb85n71+t16*t36*abb85n76+t161*t64*abb&
         &85n108+t161*t66*abb85n108+t161*t67*abb85n126+t161*t68*abb85n122+t161*t&
         &69*abb85n126+t161*t70*abb85n122+t17*t18*abb85n100+t17*t39*abb85n63+t3*&
         &t50*abb85n125+t3*t54*abb85n125+t3*t86*abb85n126+t3*t87*abb85n119+t3*t9&
         &1*abb85n126+t3*t92*abb85n119+t3*t94*abb85n119+t3*t96*abb85n119+t30*t5*&
         &abb85n95+t32*t4*abb85n95+t34*t5*abb85n95+t35*t4*abb85n95+t38*t5*abb85n&
         &119+t38*t6*abb85n126+t4*t50*abb85n105+t4*t54*abb85n105+t4*t59*abb85n11&
         &3+t4*t61*abb85n113+t4*t72*abb85n116+t4*t74*abb85n116+t4*t77*abb85n118+&
         &t4*t78*abb85n118+t40*t6*abb85n122+t41*t5*abb85n119+t41*t6*abb85n126+t4&
         &2*t6*abb85n122+t44*t5*abb85n110+t45*t5*abb85n119+t47*t5*abb85n110+t48*&
         &t5*abb85n119+t5*t51*abb85n117+t5*t55*abb85n117+t5*t58*abb85n113+t5*t60&
         &*abb85n113+t5*t62*abb85n111+t5*t63*abb85n111+t5*t64*abb85n112+t5*t66*a&
         &bb85n112+t5*t71*abb85n116+t5*t73*abb85n116+t5*t75*abb85n118+t5*t76*abb&
         &85n118+t5*t79*abb85n96+t5*t81*abb85n96+t5*t82*abb85n110+t5*t85*abb85n1&
         &20+t5*t88*abb85n110+t5*t90*abb85n120+t5*t93*abb85n120+t5*t95*abb85n120&
         &+t5*t97*abb85n109+t5*t99*abb85n121+t50*t7*abb85n106+t51*t6*abb85n125+t&
         &52*t6*abb85n105+t53*t6*abb85n123+t54*t7*abb85n106+t55*t6*abb85n125+t56&
         &*t6*abb85n105+t57*t6*abb85n123+t6*t83*abb85n108+t6*t89*abb85n108+t6*t9&
         &8*abb85n106+t7*t86*abb85n108+t7*t91*abb85n108+t8*t87*abb85n110+t8*t92*&
         &abb85n110+t8*t94*abb85n110+t8*t96*abb85n110+t110*t22*t6*abb85n107+t118&
         &*t2*t5*abb85n56+t119*t2*t4*abb85n56+t120*t2*t5*abb85n56+t121*t2*t4*abb&
         &85n56+t124*t2*t6*abb85n56+t125*t2*t6*abb85n56+t126*t4*t5*abb85n56+t127&
         &*t4*t5*abb85n56+t20*t31*t6*abb85n112+t23*t4*t80*abb85n96+t23*t6*t65*ab&
         &b85n112+t24*t31*t4*abb85n96+t26*t29*t6*abb85n107+t4*t59*t6*abb85n56+t4&
         &*t6*t61*abb85n56+t5*t58*t6*abb85n56+t5*t6*t60*abb85n56)
         return
      end if
      t158 = d(iv2,iv3)
      t159 = d(iv1,iv3)
      t9 = k2(iv3)
      t25 = k5(iv3)
      t32 = k6(iv3)
      t35 = qshift(iv3)
      t40 = spvak2k1(iv3)
      t42 = t158*t21
      t52 = t159*t49
      t53 = spvak3k4(iv3)
      t56 = t163*t53
      t57 = t14*t158
      t59 = t159*t37
      t61 = spvak5k1(iv3)
      t77 = t163*t61
      t78 = t158*t22
      t87 = t159*t29
      t92 = spvak5k6(iv3)
      t94 = t163*t92
      t96 = t15*t158
      t100 = t159*t39
      t104 = spvak6k1(iv3)
      t106 = t104*t163
      t108 = spvak2k4(iv3)
      t114 = spvak2k6(iv3)
      t117 = spvak3k1(iv3)
      t119 = t158*t23
      t121 = t159*t31
      t122 = spvak6k5(iv3)
      t123 = t122*t163
      t124 = k1(iv3)
      t125 = t16*t53
      t128 = t28*t53
      t129 = t21*t25
      t130 = t25*t49
      t131 = t12*t53
      t132 = t18*t53
      t133 = t21*t35
      t134 = t35*t49
      t58 = t122*t58
      t135 = t13*t31*t92
      t60 = t122*t60
      t136 = t23*t36*t92
      t137 = t22*t31*t40
      t138 = t23*t29*t40
      t139 = spvak2k5(iv3)
      t140 = t20*t53
      t141 = t53*t65
      t142 = t114*t21
      t143 = t114*t49
      t144 = t126*t92
      t145 = t13*t53
      t146 = t145*t29
      t147 = t127*t92
      t148 = t36*t53
      t149 = t148*t22
      t150 = t21*t40
      t151 = t150*t29
      t152 = t40*t49
      t153 = t152*t22
      t154 = t21*t92
      t155 = t49*t92
      t156 = t22*t53
      t157 = t29*t53
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t100*abb85n91+t106*abb85n91+t42*abb85n88+t52*abb&
         &85n88+t56*abb85n88+t57*abb85n114+t59*abb85n114+t77*abb85n114+t78*abb85&
         &n101+t87*abb85n101+t94*abb85n101+t96*abb85n91+t1*t42*abb85n60+t1*t52*a&
         &bb85n60+t1*t56*abb85n60+t10*t119*abb85n61+t10*t121*abb85n61+t10*t123*a&
         &bb85n61+t100*t6*abb85n60+t106*t6*abb85n60+t11*t158*abb85n103+t119*t3*a&
         &bb85n64+t119*t8*abb85n67+t12*t158*abb85n97+t121*t3*abb85n64+t121*t8*ab&
         &b85n67+t123*t3*abb85n64+t123*t8*abb85n67+t13*t158*abb85n93+t158*t16*ab&
         &b85n99+t158*t17*abb85n99+t159*t18*abb85n97+t159*t28*abb85n99+t159*t33*&
         &abb85n103+t159*t36*abb85n93+t159*t46*abb85n99+t163*t25*abb85n99+t163*t&
         &32*abb85n99+t163*t35*abb85n97+t163*t40*abb85n93+t163*t9*abb85n103+t3*t&
         &42*abb85n57+t3*t52*abb85n57+t3*t56*abb85n57+t4*t42*abb85n70+t4*t52*abb&
         &85n70+t4*t56*abb85n70+t42*t7*abb85n69+t5*t57*abb85n64+t5*t59*abb85n64+&
         &t5*t77*abb85n64+t52*t7*abb85n69+t56*t7*abb85n69+t57*t6*abb85n57+t59*t6&
         &*abb85n57+t6*t77*abb85n57+t6*t78*abb85n70+t6*t87*abb85n70+t6*t94*abb85&
         &n70+t6*t96*abb85n60+t108*t163*t5*abb85n67+t114*t163*t6*abb85n69+t117*t&
         &163*t5*abb85n61+t158*t19*t5*abb85n67+t158*t20*t6*abb85n69+t158*t27*t5*&
         &abb85n61+t159*t43*t5*abb85n67+t159*t5*t84*abb85n61+t159*t6*t65*abb85n6&
         &9)+t135*abb85n113+t136*abb85n113+t137*abb85n113+t138*abb85n113+t58*abb&
         &85n113+t60*abb85n113+t101*t122*abb85n109+t102*t53*abb85n106+t103*t122*&
         &abb85n121+t104*t50*abb85n123+t104*t54*abb85n123+t104*t86*abb85n122+t10&
         &4*t91*abb85n122+t109*t92*abb85n107+t111*t92*abb85n107+t112*t122*abb85n&
         &124+t115*t122*abb85n124+t122*t30*abb85n95+t122*t34*abb85n95+t122*t38*a&
         &bb85n119+t122*t41*abb85n119+t122*t44*abb85n110+t122*t45*abb85n119+t122&
         &*t47*abb85n110+t122*t48*abb85n119+t122*t51*abb85n117+t122*t55*abb85n11&
         &7+t122*t62*abb85n111+t122*t63*abb85n111+t122*t64*abb85n112+t122*t66*ab&
         &b85n112+t122*t71*abb85n116+t122*t73*abb85n116+t122*t75*abb85n118+t122*&
         &t76*abb85n118+t122*t79*abb85n96+t122*t81*abb85n96+t122*t82*abb85n110+t&
         &122*t85*abb85n120+t122*t88*abb85n110+t122*t90*abb85n120+t122*t93*abb85&
         &n120+t122*t95*abb85n120+t122*t97*abb85n109+t122*t99*abb85n121+t125*t37&
         &*abb85n126+t125*t39*abb85n122+t128*t14*abb85n126+t128*t15*abb85n122+t1&
         &29*t37*abb85n126+t129*t39*abb85n122+t130*t14*abb85n126+t130*t15*abb85n&
         &122+t131*t29*abb85n105+t131*t37*abb85n125+t131*t39*abb85n123+t132*t14*&
         &abb85n125+t132*t15*abb85n123+t132*t22*abb85n105+t133*t29*abb85n105+t13&
         &3*t37*abb85n125+t133*t39*abb85n123+t134*t14*abb85n125+t134*t15*abb85n1&
         &23+t134*t22*abb85n105+t135*t6*abb85n56+t136*t6*abb85n56+t137*t6*abb85n&
         &56+t138*t6*abb85n56+t140*t31*abb85n112+t141*t23*abb85n112+t142*t31*abb&
         &85n112+t143*t23*abb85n112+t144*t5*abb85n56+t146*t5*abb85n56+t147*t5*ab&
         &b85n56+t149*t5*abb85n56+t151*t5*abb85n56+t153*t5*abb85n56+t50*t61*abb8&
         &5n125+t50*t92*abb85n105+t53*t83*abb85n108+t53*t89*abb85n108+t53*t98*ab&
         &b85n106+t54*t61*abb85n125+t54*t92*abb85n105+t58*t6*abb85n56+t6*t60*abb&
         &85n56+t61*t86*abb85n126+t61*t91*abb85n126+t104*t22*t31*abb85n118+t104*&
         &t23*t29*abb85n118+t108*t12*t31*abb85n109+t108*t16*t31*abb85n110+t108*t&
         &17*t31*abb85n110+t108*t18*t23*abb85n109+t108*t22*t31*abb85n111+t108*t2&
         &3*t28*abb85n110+t108*t23*t29*abb85n111+t108*t23*t46*abb85n110+t11*t31*&
         &t92*abb85n95+t110*t22*t53*abb85n107+t114*t12*t49*abb85n106+t114*t16*t4&
         &9*abb85n108+t114*t18*t21*abb85n106+t114*t21*t28*abb85n108+t117*t12*t31&
         &*abb85n121+t117*t16*t31*abb85n120+t117*t17*t31*abb85n120+t117*t18*t23*&
         &abb85n121+t117*t22*t31*abb85n124+t117*t23*t28*abb85n120+t117*t23*t29*a&
         &bb85n124+t117*t23*t46*abb85n120+t118*t122*t2*abb85n56+t12*t31*t61*abb8&
         &5n117+t120*t122*t2*abb85n56+t122*t126*t4*abb85n56+t122*t127*t4*abb85n5&
         &6+t124*t22*t31*abb85n96+t124*t23*t29*abb85n96+t139*t21*t29*abb85n107+t&
         &139*t22*t49*abb85n107+t14*t25*t31*abb85n119+t14*t31*t32*abb85n119+t14*&
         &t31*t35*abb85n117+t14*t31*t92*abb85n116+t145*t31*t4*abb85n56+t148*t23*&
         &t4*abb85n56+t15*t31*t92*abb85n118+t150*t31*t4*abb85n56+t152*t23*t4*abb&
         &85n56+t154*t2*t31*abb85n56+t155*t2*t23*abb85n56+t156*t2*t31*abb85n56+t&
         &157*t2*t23*abb85n56+t16*t31*t61*abb85n119+t17*t31*t61*abb85n119+t18*t2&
         &3*t61*abb85n117+t19*t25*t31*abb85n110+t19*t31*t32*abb85n110+t19*t31*t3&
         &5*abb85n109+t19*t31*t92*abb85n111+t20*t25*t49*abb85n108+t20*t35*t49*ab&
         &b85n106+t21*t25*t65*abb85n108+t21*t35*t65*abb85n106+t22*t31*t61*abb85n&
         &116+t22*t31*t9*abb85n95+t23*t25*t37*abb85n119+t23*t25*t43*abb85n110+t2&
         &3*t25*t84*abb85n120+t23*t28*t61*abb85n119+t23*t29*t61*abb85n116+t23*t2&
         &9*t9*abb85n95+t23*t32*t37*abb85n119+t23*t32*t43*abb85n110+t23*t32*t84*&
         &abb85n120+t23*t33*t92*abb85n95+t23*t35*t37*abb85n117+t23*t35*t43*abb85&
         &n109+t23*t35*t84*abb85n121+t23*t37*t92*abb85n116+t23*t39*t92*abb85n118&
         &+t23*t43*t92*abb85n111+t23*t46*t61*abb85n119+t23*t80*t92*abb85n96+t23*&
         &t84*t92*abb85n124+t24*t31*t92*abb85n96+t25*t27*t31*abb85n120+t26*t29*t&
         &53*abb85n107+t27*t31*t32*abb85n120+t27*t31*t35*abb85n121+t27*t31*t92*a&
         &bb85n124)
         return
      end if
      t160 = d(iv3,iv4)
      t161 = d(iv2,iv4)
      t162 = d(iv1,iv4)
      t1 = spvak6k5(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak3k4(iv4)
      t4 = spvak2k6(iv4)
      t5 = spvak3k1(iv4)
      t6 = spvak5k1(iv4)
      t7 = spvak5k6(iv4)
      t8 = spvak6k1(iv4)
      t9 = t13*t3
      t10 = t3*t36
      t11 = t3*t40
      t12 = spvak2k1(iv4)
      t13 = t12*t21
      t16 = t12*t49
      t12 = t12*t53
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t158*t162*abb85n73+t159*t161*abb85n73+t160*t163*&
         &abb85n73)+(2.0_ki)*(t105*t160*abb85n67+t107*t160*abb85n67+t113*t160*ab&
         &b85n61+t116*t160*abb85n61+t118*t160*abb85n70+t120*t160*abb85n70+t140*t&
         &161*abb85n69+t141*t162*abb85n69+t142*t161*abb85n69+t143*t162*abb85n69+&
         &t154*t161*abb85n70+t155*t162*abb85n70+t156*t161*abb85n70+t157*t162*abb&
         &85n70+t160*t64*abb85n69+t160*t66*abb85n69+t160*t67*abb85n57+t160*t68*a&
         &bb85n60+t160*t69*abb85n57+t160*t70*abb85n60+t160*t72*abb85n64+t160*t74&
         &*abb85n64+t1*t108*t163*abb85n67+t1*t117*t163*abb85n61+t1*t14*t158*abb8&
         &5n64+t1*t158*t19*abb85n67+t1*t158*t27*abb85n61+t1*t159*t37*abb85n64+t1&
         &*t159*t43*abb85n67+t1*t159*t84*abb85n61+t1*t163*t61*abb85n64+t104*t161&
         &*t21*abb85n60+t104*t162*t49*abb85n60+t104*t163*t3*abb85n60+t108*t161*t&
         &23*abb85n67+t108*t162*t31*abb85n67+t114*t163*t3*abb85n69+t117*t161*t23&
         &*abb85n61+t117*t162*t31*abb85n61+t122*t14*t161*abb85n64+t122*t161*t19*&
         &abb85n67+t122*t161*t27*abb85n61+t122*t162*t37*abb85n64+t122*t162*t43*a&
         &bb85n67+t122*t162*t84*abb85n61+t122*t163*t2*abb85n67+t122*t163*t5*abb8&
         &5n61+t122*t163*t6*abb85n64+t14*t158*t3*abb85n57+t14*t161*t53*abb85n57+&
         &t15*t158*t3*abb85n60+t15*t161*t53*abb85n60+t158*t2*t23*abb85n67+t158*t&
         &20*t3*abb85n69+t158*t21*t4*abb85n69+t158*t21*t6*abb85n57+t158*t21*t7*a&
         &bb85n70+t158*t21*t8*abb85n60+t158*t22*t3*abb85n70+t158*t23*t5*abb85n61&
         &+t158*t23*t6*abb85n64+t159*t2*t31*abb85n67+t159*t29*t3*abb85n70+t159*t&
         &3*t37*abb85n57+t159*t3*t39*abb85n60+t159*t3*t65*abb85n69+t159*t31*t5*a&
         &bb85n61+t159*t31*t6*abb85n64+t159*t4*t49*abb85n69+t159*t49*t6*abb85n57&
         &+t159*t49*t7*abb85n70+t159*t49*t8*abb85n60+t161*t21*t61*abb85n57+t161*&
         &t23*t61*abb85n64+t162*t31*t61*abb85n64+t162*t37*t53*abb85n57+t162*t39*&
         &t53*abb85n60+t162*t49*t61*abb85n57+t163*t3*t61*abb85n57+t163*t3*t92*ab&
         &b85n70+t163*t4*t53*abb85n69+t163*t53*t6*abb85n57+t163*t53*t7*abb85n70+&
         &t163*t53*t8*abb85n60)+t1*t144*abb85n56+t1*t146*abb85n56+t1*t147*abb85n&
         &56+t1*t149*abb85n56+t1*t151*abb85n56+t1*t153*abb85n56+t10*t122*t22*abb&
         &85n56+t10*t23*t92*abb85n56+t11*t22*t31*abb85n56+t11*t23*t29*abb85n56+t&
         &12*t22*t31*abb85n56+t12*t23*t29*abb85n56+t122*t126*t7*abb85n56+t122*t1&
         &27*t7*abb85n56+t122*t13*t29*abb85n56+t122*t16*t22*abb85n56+t122*t29*t9&
         &*abb85n56+t13*t31*t92*abb85n56+t145*t31*t7*abb85n56+t148*t23*t7*abb85n&
         &56+t150*t31*t7*abb85n56+t152*t23*t7*abb85n56+t16*t23*t92*abb85n56+t31*&
         &t9*t92*abb85n56)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d85:
   subroutine     reconstruct_d85(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group12
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group12), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_85:
      coeffs%coeffs_85%c0 = derivative(czip)
      coeffs%coeffs_85%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_85%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_85%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_85%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_85%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_85%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_85%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_85%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_85%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_85%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_85%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_85%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_85%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_85%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_85%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_85%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_85%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_85%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_85%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_85%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_85%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_85%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_85%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_85%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_85%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_85%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_85%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_85%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_85%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_85%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_85%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_85%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_85%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_85%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_85%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_85%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_85%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_85%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_85%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_85%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_85%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_85%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_85%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_85%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_85%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_85%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_85%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_85%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_85%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_85%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_85%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_85%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_85%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_85%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_85%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_85%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_85%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_85%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_85%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_85%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_85%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_85%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_85%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_85%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_85%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_85%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_85:
   end subroutine reconstruct_d85
!---#] subroutine reconstruct_d85:
end module p9_udbar_neepgg_d85h0l1d
