module     p9_udbar_neepgg_abbrevd39h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb39n1
   complex(ki), public :: abb39n2
   complex(ki), public :: abb39n3
   complex(ki), public :: abb39n4
   complex(ki), public :: abb39n5
   complex(ki), public :: abb39n6
   complex(ki), public :: abb39n7
   complex(ki), public :: abb39n8
   complex(ki), public :: abb39n9
   complex(ki), public :: abb39n10
   complex(ki), public :: abb39n11
   complex(ki), public :: rat2d39
   complex(ki), public :: abb39n13
   complex(ki), public :: abb39n14
   complex(ki), public :: abb39n15
   complex(ki), public :: abb39n16
   complex(ki), public :: abb39n17
   complex(ki), public :: abb39n18
   complex(ki), public :: abb39n19
   complex(ki), public :: abb39n20
   complex(ki), public :: abb39n21
   complex(ki), public :: abb39n22
   complex(ki), public :: abb39n23
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   real(ki) :: t50
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c2
      t3 = t2*i_
      t4 = t3*spak1k5
      t5 = t4*spak2k3
      t6 = spbk6k1*spbk6k1
      t7 = (es234-(es61+es56))*t1
      t8 = NC*t7
      t9 = es234*t8
      t10 = t9*spbk6k5
      t11 = t5/t10*t6*spbk6k4
      t50 = NC*TR
      t12 = t50*c2
      t13 = t12*i_
      t14 = t13*spak1k5
      t15 = t14*spak2k3
      t16 = es234*t7
      t17 = t16*spbk6k5
      t18 = t15/t17*t6*spbk6k4
      t19 = TR*c1
      t20 = t19*i_
      t21 = t20*spak1k5
      t22 = t21*spak2k3
      t23 = NC*t1
      t24 = es234*t23
      t25 = es61*t24
      t26 = t25*spbk6k5
      t27 = t22/t26*t6*spbk6k4
      t28 = t50*c1
      t29 = t28*i_
      t30 = t29*spak1k5
      t31 = t30*spak2k3
      t32 = es234*t1
      t33 = es61*t32
      t34 = t33*spbk6k5
      t35 = t31/t34*t6*spbk6k4
      t36 = t3*spak2k3
      t37 = spak1k5*spbk6k1
      t37 = t37*t37
      t9 = t9*spak5k6
      t38 = t9*spbk6k5
      t39 = t36*t37/t38*spbk4k1
      t40 = t13*spak2k3
      t16 = t16*spak5k6
      t41 = t16*spbk6k5
      t42 = t37*t40/t41*spbk4k1
      t43 = t20*spak2k3
      t25 = t25*spak5k6
      t44 = t25*spbk6k5
      t45 = t37*t43/t44*spbk4k1
      t46 = t29*spak2k3
      t33 = t33*spak5k6
      t47 = t33*spbk6k5
      t48 = t37*t46/t47*spbk4k1
      t49 = t18+t35+t39+t45-(t48+t42+t27+t11)
      abb39n1 = ((2.0_ki)*t49)
      abb39n2 = ((4.0_ki)*(t13*t37/t41+t29*t37/t47-(t3*t37/t38+t20*t37/t44)))
      abb39n3 = ((4.0_ki)*(t11+t27+t42+t48-(t45+t39+t35+t18)))
      abb39n4 = ((8.0_ki)*t49)
      abb39n5 = ((4.0_ki)*(t5/t10*t6*spbk6k3+t22/t26*t6*spbk6k3+t37*t40/t41*spbk&
      &3k1+t37*t46/t47*spbk3k1+t4/t10*t6*spak2k4*spbk6k4+t13*t37/t41*spak2k4*spb&
      &k4k1+t21/t26*t6*spak2k4*spbk6k4+t29*t37/t47*spak2k4*spbk4k1-(t30/t34*t6*s&
      &pak2k4*spbk6k4+t3*t37/t38*spak2k4*spbk4k1+t20*t37/t44*spak2k4*spbk4k1+t14&
      &/t17*t6*spak2k4*spbk6k4+t37*t43/t44*spbk3k1+t36*t37/t38*spbk3k1+t31/t34*t&
      &6*spbk6k3+t15/t17*t6*spbk6k3)))
      t5 = t4*spak2k5
      t11 = t5/t38*t6
      t15 = t14*spak2k5
      t18 = t15/t41*t6
      t22 = t21*spak2k5
      t27 = t22/t44*t6
      t31 = t30*spak2k5
      t35 = t31/t47*t6
      abb39n6 = ((16.0_ki)*(t11+t27-(t35+t18)))
      abb39n7 = ((16.0_ki)*(t18+t35-(t27+t11)))
      t11 = t20*spak2k5*spbk6k1
      t18 = t29*spak2k5*spbk6k1
      abb39n8 = ((8.0_ki)*(t11/(t24*spak5k6*spbk6k5)+t18/(es61*t1*spak5k6*spbk6k&
      &5)+t13/(t7*spak5k6*spbk6k5)*spak2k5*spbk6k1+t21/t44*t6*spak2k6+t4/t38*t6*&
      &spak2k6+es56*t19/t44*i_*spak2k5*spbk6k1+es56*t2/t38*i_*spak2k5*spbk6k1+es&
      &61*t2/t38*i_*spak2k5*spbk6k1-(es56*t28/t47*i_*spak2k5*spbk6k1+es61*t12/t4&
      &1*i_*spak2k5*spbk6k1+es56*t12/t41*i_*spak2k5*spbk6k1+t30/t47*t6*spak2k6+t&
      &14/t41*t6*spak2k6+t3/(t8*spak5k6*spbk6k5)*spak2k5*spbk6k1+t11/(es61*t23*s&
      &pak5k6*spbk6k5)+t18/(t32*spak5k6*spbk6k5))))
      abb39n9 = ((4.0_ki)*(t14/t17*t6*spak3k4*spbk6k4+t20*t37/t44*spak3k4*spbk4k&
      &1+t3*t37/t38*spak3k4*spbk4k1+t30/t34*t6*spak3k4*spbk6k4-(t29*t37/t47*spak&
      &3k4*spbk4k1+t21/t26*t6*spak3k4*spbk6k4+t13*t37/t41*spak3k4*spbk4k1+t4/t10&
      &*t6*spak3k4*spbk6k4)))
      abb39n10 = ((4.0_ki)*(t14/t17*t6+t30/t34*t6-(t21/t26*t6+t4/t10*t6)))
      abb39n11 = ((8.0_ki)*(t22/t25*spbk6k1+t5/t9*spbk6k1+t20/t44*t6*spak1k2*spa&
      &k1k5+t3/t38*t6*spak1k2*spak1k5-(t29/t47*t6*spak1k2*spak1k5+t13/t41*t6*spa&
      &k1k2*spak1k5+t31/t33*spbk6k1+t15/t16*spbk6k1)))
      rat2d39 = abb39n1
      rat2 = rat2 + rat2d39
      abb39n13 = -(abb39n5)
      abb39n14 = abb39n11
      abb39n15 = abb39n10
      abb39n16 = abb39n8
      abb39n17 = abb39n7
      abb39n18 = abb39n6
      abb39n19 = abb39n3
      abb39n20 = abb39n2
      abb39n21 = ((2.0_ki)*abb39n3)
      abb39n22 = -(abb39n4)
      abb39n23 = -(abb39n9)
   end subroutine
end module p9_udbar_neepgg_abbrevd39h1
