module     p9_udbar_neepgg_d19h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d19h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d19
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd19h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2-k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t33 = dotproduct(qshift, qshift)
      t34 = dotproduct(k5, qshift)
      t35 = dotproduct(k6, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t36 = dotproduct(k2, qshift)
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t7 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t8 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb19n30+t1*abb19n59+t2*abb19n61+t3*abb19n75+t33*abb19n46+&
         &t34*abb19n58+t35*abb19n58+t36*abb19n66+t4*abb19n77+t5*abb19n84+t1*t2*a&
         &bb19n47+t1*t3*abb19n41+t1*t33*abb19n63+t1*t36*abb19n52+t1*t4*abb19n43+&
         &t1*t5*abb19n35+t1*t7*abb19n39+t1*t8*abb19n49+t2*t33*abb19n69+t2*t34*ab&
         &b19n50+t2*t35*abb19n50+t2*t36*abb19n48+t2*t6*abb19n55+t3*t33*abb19n81+&
         &t3*t34*abb19n38+t3*t35*abb19n38+t3*t36*abb19n40+t33*t5*abb19n89+t34*t5&
         &*abb19n34+t35*t5*abb19n34+t36*t5*abb19n32+t36*t6*abb19n45+t4*t6*abb19n&
         &36+t1*t4*t6*abb19n92)
         return
      end if
      t9 = k2(iv1)
      t10 = k5(iv1)
      t11 = k6(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak2k6(iv1)
      t15 = spvak3k1(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak2k5(iv1)
      t19 = t14*abb19n67
      t20 = t15*abb19n87
      t21 = spvak3k4(iv1)
      t22 = t16*abb19n83
      t23 = spvak6k1(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb19n57+t11*abb19n57+t12*abb19n73+t13*abb19n42+t14*ab&
         &b19n54+t15*abb19n37+t16*abb19n44+t17*abb19n56+t19*t34+t19*t35+t20*t34+&
         &t20*t35+t22*t34+t22*t35+t9*abb19n51+t1*t12*abb19n62+t1*t13*abb19n76+t1&
         &*t14*abb19n72+t1*t15*abb19n86+t1*t16*abb19n78+t1*t18*abb19n69+t1*t23*a&
         &bb19n81+t1*t9*abb19n65+t10*t2*abb19n67+t10*t3*abb19n83+t10*t5*abb19n87&
         &+t11*t2*abb19n67+t11*t3*abb19n83+t11*t5*abb19n87+t12*t2*abb19n68+t12*t&
         &3*abb19n80+t12*t5*abb19n88+t13*t6*abb19n85+t14*t33*abb19n49+t14*t36*ab&
         &b19n71+t14*t6*abb19n60+t15*t33*abb19n33+t15*t36*abb19n91+t16*t33*abb19&
         &n39+t16*t36*abb19n79+t17*t2*abb19n72+t17*t3*abb19n78+t17*t33*abb19n53+&
         &t17*t36*abb19n65+t17*t4*abb19n76+t17*t5*abb19n86+t17*t7*abb19n81+t17*t&
         &8*abb19n69+t2*t21*abb19n60+t2*t9*abb19n71+t21*t36*abb19n74+t21*t4*abb1&
         &9n85+t3*t9*abb19n79+t5*t9*abb19n91+t6*t9*abb19n74+t1*t13*t6*abb19n31+t&
         &1*t21*t4*abb19n31+t17*t4*t6*abb19n31)
         return
      end if
      t33 = d(iv1,iv2)
      t7 = spvak2k6(iv2)
      t8 = spvak3k1(iv2)
      t19 = spvak3k4(iv2)
      t20 = spvak5k1(iv2)
      t22 = spvak5k6(iv2)
      t24 = k2(iv2)
      t25 = k5(iv2)
      t26 = k6(iv2)
      t27 = qshift(iv2)
      t28 = t13*t19
      t29 = t13*t22
      t30 = spvak2k1(iv2)
      t31 = t21*t30
      t32 = t17*t30
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t33*abb19n46+t1*t33*abb19n63+t2*t33*abb19n69+t3*&
         &t33*abb19n81+t33*t5*abb19n89)+t28*abb19n36+t29*abb19n43+t31*abb19n36+t&
         &32*abb19n43+spvak2k5(iv2)*t17*abb19n49+spvak6k1(iv2)*t17*abb19n39+t1*t&
         &28*abb19n92+t1*t31*abb19n92+t10*t20*abb19n38+t10*t7*abb19n50+t10*t8*ab&
         &b19n34+t11*t20*abb19n38+t11*t7*abb19n50+t11*t8*abb19n34+t12*t20*abb19n&
         &82+t12*t22*abb19n64+t12*t7*abb19n70+t12*t8*abb19n90+t14*t19*abb19n55+t&
         &14*t22*abb19n47+t14*t24*abb19n48+t14*t25*abb19n50+t14*t26*abb19n50+t14&
         &*t27*abb19n70+t15*t22*abb19n35+t15*t24*abb19n32+t15*t25*abb19n34+t15*t&
         &26*abb19n34+t15*t27*abb19n90+t16*t22*abb19n41+t16*t24*abb19n40+t16*t25&
         &*abb19n38+t16*t26*abb19n38+t16*t27*abb19n82+t17*t20*abb19n41+t17*t24*a&
         &bb19n52+t17*t27*abb19n64+t17*t7*abb19n47+t17*t8*abb19n35+t18*t22*abb19&
         &n49+t19*t9*abb19n45+t20*t9*abb19n40+t21*t24*abb19n45+t21*t7*abb19n55+t&
         &22*t23*abb19n39+t22*t9*abb19n52+t29*t6*abb19n92+t32*t6*abb19n92+t7*t9*&
         &abb19n48+t8*t9*abb19n32+t17*t19*t4*abb19n92+t21*t22*t4*abb19n92)
         return
      end if
      t34 = d(iv2,iv3)
      t35 = d(iv1,iv3)
      t1 = spvak5k6(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k6(iv3)*t33*abb19n49+spvak3k1(iv3)*t33*abb&
         &19n33+spvak5k1(iv3)*t33*abb19n39+t1*t33*abb19n53+t14*t34*abb19n49+t15*&
         &t34*abb19n33+t16*t34*abb19n39+t17*t34*abb19n53+t20*t35*abb19n39+t22*t3&
         &5*abb19n53+t35*t7*abb19n49+t35*t8*abb19n33)+t1*t28*abb19n31+t1*t31*abb&
         &19n31+t13*t2*t22*abb19n31+t17*t19*t3*abb19n31+t17*t2*t30*abb19n31+t21*&
         &t22*t3*abb19n31)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d19:
   subroutine     reconstruct_d19(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_19:
      coeffs%coeffs_19%c0 = derivative(czip)
      coeffs%coeffs_19%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_19%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_19%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_19%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_19%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_19%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_19%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_19%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_19%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_19%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_19%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_19%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_19%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_19%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_19%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_19%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_19%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_19%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_19%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_19%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_19%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_19%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_19%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_19%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_19%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_19%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_19%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_19%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_19%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_19%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_19%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_19%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_19%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_19%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_19:
   end subroutine reconstruct_d19
!---#] subroutine reconstruct_d19:
end module p9_udbar_neepgg_d19h1l1d
