module     p9_udbar_neepgg_d28h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d28h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d28
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd28h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      real(ki) :: t39
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t35 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t36 = dotproduct(k2, qshift)
      t37 = dotproduct(k6, qshift)
      t38 = dotproduct(k5, qshift)
      t2 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t39 = dotproduct(k1, qshift)
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t5 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t8 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb28n29+t1*abb28n56+t2*abb28n64+t3*abb28n82+t35*abb28n45+&
         &t36*abb28n57+t37*abb28n58+t38*abb28n63+t39*abb28n69+t1*t2*abb28n46+t1*&
         &t3*abb28n31+t1*t35*abb28n71+t1*t38*abb28n41+t1*t39*abb28n42+t2*t3*abb2&
         &8n39+t2*t35*abb28n60+t2*t36*abb28n51+t2*t37*abb28n51+t2*t38*abb28n51+t&
         &2*t4*abb28n34+t2*t5*abb28n38+t2*t6*abb28n40+t2*t7*abb28n47+t2*t8*abb28&
         &n48+t3*t35*abb28n79+t3*t36*abb28n38+t3*t37*abb28n36+t3*t38*abb28n36+t3&
         &5*t4*abb28n86+t39*t4*abb28n33+t1*t2*t6*abb28n89)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak5k1(iv1)
      t16 = spvak5k6(iv1)
      t17 = spvak2k1(iv1)
      t18 = spvak2k5(iv1)
      t19 = spvak2k6(iv1)
      t20 = spvak3k1(iv1)
      t21 = t15*abb28n81
      t22 = t16*abb28n62
      t23 = spvak6k1(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb28n54+t11*abb28n50+t12*abb28n53+t13*abb28n68+t14*ab&
         &b28n55+t15*abb28n35+t16*abb28n49+t21*t37+t21*t38+t22*t36+t22*t37+t22*t&
         &38+t9*abb28n44+t1*t11*abb28n74+t1*t13*abb28n70+t1*t15*abb28n88+t1*t16*&
         &abb28n67+t1*t9*abb28n73+t10*t2*abb28n62+t10*t3*abb28n77+t11*t2*abb28n6&
         &2+t11*t3*abb28n81+t12*t2*abb28n62+t12*t3*abb28n81+t13*t2*abb28n59+t13*&
         &t3*abb28n78+t13*t4*abb28n85+t14*t2*abb28n67+t14*t3*abb28n88+t14*t35*ab&
         &b28n43+t14*t38*abb28n74+t14*t39*abb28n73+t15*t2*abb28n76+t15*t35*abb28&
         &n37+t15*t36*abb28n77+t16*t3*abb28n76+t16*t35*abb28n52+t16*t4*abb28n83+&
         &t16*t5*abb28n77+t16*t6*abb28n75+t16*t7*abb28n66+t16*t8*abb28n65+t17*t2&
         &*abb28n75+t18*t2*abb28n65+t19*t2*abb28n66+t2*t20*abb28n83+t2*t23*abb28&
         &n77+t20*t35*abb28n32+t20*t39*abb28n84+t4*t9*abb28n84+t1*t16*t6*abb28n3&
         &0+t1*t17*t2*abb28n30+t14*t2*t6*abb28n30)
         return
      end if
      t35 = d(iv1,iv2)
      t5 = spvak3k1(iv2)
      t7 = spvak3k4(iv2)
      t8 = k1(iv2)
      t21 = spvak5k1(iv2)
      t22 = spvak5k6(iv2)
      t24 = k2(iv2)
      t25 = k5(iv2)
      t26 = k6(iv2)
      t27 = qshift(iv2)
      t28 = t17*t22
      t29 = spvak2k1(iv2)
      t30 = t16*t29
      t31 = t14*t22
      t32 = t16*t7
      t33 = t17*t7
      t34 = t14*t29
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t35*abb28n45+t1*t35*abb28n71+t2*t35*abb28n60+t3*&
         &t35*abb28n79+t35*t4*abb28n86)+t28*abb28n40+t30*abb28n40+t31*abb28n46+t&
         &32*abb28n46+spvak2k5(iv2)*t16*abb28n48+spvak2k6(iv2)*t16*abb28n47+spva&
         &k6k1(iv2)*t16*abb28n38+t1*t28*abb28n89+t1*t30*abb28n89+t10*t21*abb28n3&
         &8+t10*t22*abb28n51+t11*t21*abb28n36+t11*t22*abb28n51+t11*t7*abb28n41+t&
         &12*t21*abb28n36+t12*t22*abb28n51+t13*t21*abb28n80+t13*t22*abb28n61+t13&
         &*t5*abb28n87+t13*t7*abb28n72+t14*t21*abb28n31+t14*t25*abb28n41+t14*t27&
         &*abb28n72+t14*t8*abb28n42+t15*t22*abb28n39+t15*t24*abb28n38+t15*t25*ab&
         &b28n36+t15*t26*abb28n36+t15*t27*abb28n80+t15*t7*abb28n31+t16*t21*abb28&
         &n39+t16*t24*abb28n51+t16*t25*abb28n51+t16*t26*abb28n51+t16*t27*abb28n6&
         &1+t16*t5*abb28n34+t18*t22*abb28n48+t19*t22*abb28n47+t2*t33*abb28n89+t2&
         &*t34*abb28n89+t20*t22*abb28n34+t20*t27*abb28n87+t20*t8*abb28n33+t22*t2&
         &3*abb28n38+t31*t6*abb28n89+t32*t6*abb28n89+t5*t9*abb28n33+t7*t9*abb28n&
         &42)
         return
      end if
      t36 = d(iv2,iv3)
      t37 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak5k6(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t35*abb28n32+spvak5k1(iv3)*t35*abb&
         &28n37+t1*t35*abb28n43+t14*t36*abb28n43+t15*t36*abb28n37+t16*t36*abb28n&
         &52+t2*t35*abb28n52+t20*t36*abb28n32+t21*t37*abb28n37+t22*t37*abb28n52+&
         &t37*t5*abb28n32+t37*t7*abb28n43)+t2*t33*abb28n30+t2*t34*abb28n30+t1*t1&
         &6*t29*abb28n30+t1*t17*t22*abb28n30+t14*t22*t3*abb28n30+t16*t3*t7*abb28&
         &n30)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d28:
   subroutine     reconstruct_d28(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_28:
      coeffs%coeffs_28%c0 = derivative(czip)
      coeffs%coeffs_28%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_28%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_28%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_28%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_28%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_28%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_28%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_28%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_28%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_28%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_28%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_28%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_28%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_28%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_28%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_28%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_28%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_28%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_28%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_28%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_28%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_28%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_28%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_28%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_28%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_28%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_28%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_28%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_28%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_28%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_28%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_28:
   end subroutine reconstruct_d28
!---#] subroutine reconstruct_d28:
end module p9_udbar_neepgg_d28h1l1d
