module     p9_udbar_neepgg_diagramsh1l0
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/diagramsl0.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_color, only: numcs
   use p9_udbar_neepgg_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_color
      use p9_udbar_neepgg_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p9_udbar_neepgg_accu, only: sorted_sum
      use p9_udbar_neepgg_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(8,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      real(ki) :: t6
      real(ki) :: t7
      real(ki) :: t8
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      t6 = es345-(es61+es12)
      t1 = es34+i_*mW*wW-mW*mW
      t7 = es34+es56-(es234+es12)
      t2 = spak3k5*spbk4k1*spbk6k2
      t3 = t1*t6*t7*spak5k6
      t4 = spak2k3*spbk4k1*spbk6k2*spbk6k2
      t5 = spak2k5*spak2k5
      diagrams(6, :) = (i_*(4.0_ki)*(t4/(t3*spbk6k5)+t2/t3)*t5*c2)
      t8 = es34+es61-(es345+es234)
      t3 = t1*t7*t8*spak5k6
      diagrams(5, :) = (i_*(4.0_ki)*(t4/(t3*spbk6k5)+t2/t3)*t5*c1)
      t2 = spbk6k1*spbk6k1
      t3 = t2*spbk6k4
      t4 = t1*es234*es61
      t5 = spak1k5*spbk4k1
      t2 = t2*t5
      diagrams(4, :) = (spak2k3*spak1k5*i_*(4.0_ki)*(t2/(t4*spak5k6*spbk6k5)-t3/&
      &(t4*spbk6k5))*c1)
      t7 = es234-(es61+es56)
      t4 = t1*t7*es234
      diagrams(3, :) = (spak2k3*spak1k5*i_*(4.0_ki)*(t2/(t4*spak5k6*spbk6k5)-t3/&
      &(t4*spbk6k5))*c2)
      t2 = t5*spbk6k1
      t3 = t1*t8*es61
      t4 = t3*spak5k6
      t5 = t4*spbk6k5
      diagrams(2, :) = (spak2k5*i_*(4.0_ki)*((es56/t5*spbk6k1*spbk6k4-t2/t4)*spa&
      &k3k5+(spbk6k1/(t3*spbk6k5)*spbk6k2*spbk6k4-t2/t5*spbk6k2)*spak2k3)*c1)
      diagrams(1, :) = spbk6k2*spbk6k1*spbk4k1*spak2k5*spak2k3*spak1k5*i_*(-4.0_&
      &ki)/(t1*t6*t7*spak5k6*spbk6k5)*c2
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 1, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 1, 19)
         call inspect_lo_diagram(diagrams(3,:), 3, 1, 19)
         call inspect_lo_diagram(diagrams(4,:), 4, 1, 19)
         call inspect_lo_diagram(diagrams(5,:), 5, 1, 19)
         call inspect_lo_diagram(diagrams(6,:), 6, 1, 19)
         call inspect_lo_diagram(diagrams(7,:), 7, 1, 19)
         call inspect_lo_diagram(diagrams(8,:), 8, 1, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p9_udbar_neepgg_diagramsh1l0
