module     p9_udbar_neepgg_d101h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d101h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d101
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd101h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      real(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t21 = dotproduct(qshift, qshift)
      t22 = dotproduct(k5, qshift)
      t23 = dotproduct(k6, qshift)
      t24 = dotproduct(k1, qshift)
      t1 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t2 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb101n22+t1*abb101n39+t2*abb101n40+t21*abb101n34+t22*abb1&
         &01n35+t23*abb101n37+t24*abb101n38+t3*abb101n41+t1*t21*abb101n44+t1*t22&
         &*abb101n29+t1*t24*abb101n29+t1*t3*abb101n28+t2*t21*abb101n42+t2*t23*ab&
         &b101n31+t2*t24*abb101n30+t2*t4*abb101n23+t2*t5*abb101n32+t2*t6*abb101n&
         &33+t22*t4*abb101n26+t23*t3*abb101n25+t24*t3*abb101n24+t24*t4*abb101n27&
         &)
         return
      end if
      t7 = k1(iv1)
      t8 = k5(iv1)
      t9 = k6(iv1)
      t10 = qshift(iv1)
      t11 = spvak5k1(iv1)
      t12 = spvak5k6(iv1)
      t13 = spvak6k5(iv1)
      t14 = spvak2k1(iv1)
      t15 = spvak3k1(iv1)
      t16 = spvak6k1(iv1)
      t17 = t13*abb101n29
      if(deg.eq.1) then
         numerator = (t10*abb101n36+t11*abb101n41+t12*abb101n40+t13*abb101n39+t1&
         &7*t22+t17*t24+t7*abb101n38+t8*abb101n35+t9*abb101n37+t1*t10*abb101n45+&
         &t1*t11*abb101n28+t1*t7*abb101n29+t1*t8*abb101n29+t10*t2*abb101n43+t11*&
         &t23*abb101n25+t11*t24*abb101n24+t12*t21*abb101n42+t12*t23*abb101n31+t1&
         &2*t24*abb101n30+t12*t4*abb101n23+t12*t5*abb101n32+t12*t6*abb101n33+t13&
         &*t21*abb101n44+t13*t3*abb101n28+t14*t2*abb101n33+t15*t2*abb101n32+t16*&
         &t2*abb101n23+t16*t22*abb101n26+t16*t24*abb101n27+t2*t7*abb101n30+t2*t9&
         &*abb101n31+t3*t7*abb101n24+t3*t9*abb101n25+t4*t7*abb101n27+t4*t8*abb10&
         &1n26)
         return
      end if
      t21 = d(iv1,iv2)
      t3 = spvak5k1(iv2)
      t4 = spvak5k6(iv2)
      t5 = spvak6k1(iv2)
      t6 = spvak6k5(iv2)
      t17 = k1(iv2)
      t18 = k5(iv2)
      t19 = k6(iv2)
      t20 = qshift(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t21*abb101n34+t1*t21*abb101n44+t2*t21*abb101n42)&
         &+spvak2k1(iv2)*t12*abb101n33+spvak3k1(iv2)*t12*abb101n32+t10*t4*abb101&
         &n43+t10*t6*abb101n45+t11*t17*abb101n24+t11*t19*abb101n25+t11*t6*abb101&
         &n28+t12*t17*abb101n30+t12*t19*abb101n31+t12*t20*abb101n43+t12*t5*abb10&
         &1n23+t13*t17*abb101n29+t13*t18*abb101n29+t13*t20*abb101n45+t13*t3*abb1&
         &01n28+t14*t4*abb101n33+t15*t4*abb101n32+t16*t17*abb101n27+t16*t18*abb1&
         &01n26+t16*t4*abb101n23+t3*t7*abb101n24+t3*t9*abb101n25+t4*t7*abb101n30&
         &+t4*t9*abb101n31+t5*t7*abb101n27+t5*t8*abb101n26+t6*t7*abb101n29+t6*t8&
         &*abb101n29)
         return
      end if
      t22 = d(iv2,iv3)
      t23 = d(iv1,iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak5k6(iv3)*t21*abb101n42+spvak6k5(iv3)*t21*ab&
         &b101n44+t12*t22*abb101n42+t13*t22*abb101n44+t23*t4*abb101n42+t23*t6*ab&
         &b101n44))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d101:
   subroutine     reconstruct_d101(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_101:
      coeffs%coeffs_101%c0 = derivative(czip)
      coeffs%coeffs_101%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_101%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_101%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_101%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_101%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_101%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_101%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_101%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_101%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_101%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_101%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_101%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_101%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_101%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_101%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_101%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_101%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_101%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_101%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_101%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_101%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_101%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_101%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_101%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_101%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_101%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_101%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_101%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_101%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_101%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_101%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_101%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_101%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_101%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_101:
   end subroutine reconstruct_d101
!---#] subroutine reconstruct_d101:
end module p9_udbar_neepgg_d101h3l1d
