module     p9_udbar_neepgg_d93h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d93h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d93
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd93h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      complex(ki) :: t181
      complex(ki) :: t182
      complex(ki) :: t183
      complex(ki) :: t184
      complex(ki) :: t185
      complex(ki) :: t186
      complex(ki) :: t187
      complex(ki) :: t188
      complex(ki) :: t189
      complex(ki) :: t190
      complex(ki) :: t191
      complex(ki) :: t192
      complex(ki) :: t193
      complex(ki) :: t194
      real(ki) :: t195
      real(ki) :: t196
      real(ki) :: t197
      real(ki) :: t198
      real(ki) :: t199
      real(ki) :: t200
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t195 = dotproduct(qshift, qshift)
      t196 = dotproduct(k2, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t197 = dotproduct(k1, qshift)
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t198 = dotproduct(k5, qshift)
      t199 = dotproduct(k6, qshift)
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb93n82+t1*abb93n123+t195*abb93n108+t195*t195*abb93n97+t1&
         &96*abb93n122+t197*abb93n126+t198*abb93n133+t198*t198*abb93n96+t199*abb&
         &93n135+t2*abb93n127+t3*abb93n132+t4*abb93n145+t1*t195*abb93n130+t1*t19&
         &7*abb93n120+t1*t198*abb93n112+t1*t199*abb93n113+t1*t2*abb93n116+t1*t3*&
         &abb93n114+t1*t4*abb93n115+t195*t196*abb93n124+t195*t197*abb93n150+t195&
         &*t198*abb93n155+t195*t199*abb93n150+t195*t2*abb93n172+t195*t3*abb93n14&
         &6+t195*t4*abb93n157+t195*t5*abb93n128+t196*t197*abb93n121+t196*t198*ab&
         &b93n121+t196*t2*abb93n119+t196*t3*abb93n110+t196*t4*abb93n106+t197*t19&
         &8*abb93n99+t197*t199*abb93n95+t197*t3*abb93n102+t197*t4*abb93n94+t197*&
         &t5*abb93n117+t198*t199*abb93n98+t198*t2*abb93n87+t198*t3*abb93n103+t19&
         &8*t4*abb93n93+t198*t5*abb93n118+t199*t2*abb93n88+t199*t3*abb93n109+t19&
         &9*t4*abb93n105+t2*t3*abb93n90+t2*t4*abb93n111+t3*t4*abb93n101+t4*t6*ab&
         &b93n86+t1*t195*t2*abb93n84+t1*t195*t3*abb93n100+t1*t195*t4*abb93n104+t&
         &1*t197*t3*abb93n148+t1*t197*t4*abb93n142+t1*t198*t2*abb93n179+t1*t198*&
         &t3*abb93n148+t1*t198*t4*abb93n142+t1*t199*t2*abb93n181+t1*t199*t4*abb9&
         &3n141+t1*t2*t3*abb93n171+t1*t3*t4*abb93n159+t1*t4*t6*abb93n178+t195*t2&
         &*t3*abb93n91+t195*t3*t4*abb93n107+t195*t3*t5*abb93n89+t195*t4*t5*abb93&
         &n85+t195*t4*t6*abb93n92+t196*t2*t3*abb93n166+t196*t3*t4*abb93n138+t196&
         &*t4*t6*abb93n163+t197*t3*t5*abb93n170+t197*t4*t5*abb93n176+t198*t3*t4*&
         &abb93n136+t198*t3*t5*abb93n168+t198*t4*t5*abb93n174+t199*t2*t3*abb93n1&
         &64+t199*t3*t4*abb93n137+t199*t4*t6*abb93n161+t2*t3*t4*abb93n161+t3*t4*&
         &t5*abb93n177+t3*t4*t6*abb93n167+t3*t4*t7*abb93n140+t3*t4*t8*abb93n144+&
         &t3*t4*t9*abb93n160+t1*t3*t4*t9*abb93n83)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak6k5(iv1)
      t19 = t11*abb93n121
      t20 = t14*abb93n151
      t21 = spvak3k1(iv1)
      t22 = spvak6k1(iv1)
      t23 = spvak2k1(iv1)
      t24 = spvak2k4(iv1)
      t25 = spvak2k6(iv1)
      t26 = t15*abb93n142
      t27 = t15*abb93n148
      t28 = t17*abb93n142
      t29 = t17*abb93n161
      t30 = t18*abb93n148
      if(deg.eq.1) then
         numerator = (t10*abb93n126+t11*abb93n122+t12*abb93n133+t13*abb93n135+t1&
         &4*abb93n134+t15*abb93n123+t16*abb93n127+t17*abb93n145+t18*abb93n132+t1&
         &9*t197+t19*t198+t197*t20+t199*t20+t1*t10*abb93n120+t1*t12*abb93n112+t1&
         &*t13*abb93n113+t1*t14*abb93n131+t1*t16*abb93n116+t1*t17*abb93n115+t1*t&
         &18*abb93n114+t1*t197*t28+t1*t197*t30+t1*t198*t28+t1*t198*t30+t10*t195*&
         &abb93n150+t10*t196*abb93n121+t10*t198*abb93n99+t10*t199*abb93n95+t10*t&
         &3*abb93n102+t10*t4*abb93n94+t10*t5*abb93n117+t11*t195*abb93n124+t11*t2&
         &*abb93n119+t11*t3*abb93n110+t11*t4*abb93n106+t12*t195*abb93n155+t12*t1&
         &96*abb93n121+t12*t197*abb93n99+t12*t198*abb93n154+t12*t199*abb93n98+t1&
         &2*t2*abb93n87+t12*t3*abb93n103+t12*t4*abb93n93+t12*t5*abb93n118+t13*t1&
         &95*abb93n150+t13*t197*abb93n95+t13*t198*abb93n98+t13*t2*abb93n88+t13*t&
         &3*abb93n109+t13*t4*abb93n105+t14*t195*abb93n152+t14*t196*abb93n125+t14&
         &*t198*abb93n156+t14*t2*abb93n173+t14*t3*abb93n147+t14*t4*abb93n158+t14&
         &*t5*abb93n129+t15*t195*abb93n130+t15*t197*abb93n120+t15*t198*abb93n112&
         &+t15*t199*abb93n113+t15*t2*abb93n116+t15*t3*abb93n114+t15*t4*abb93n115&
         &+t16*t195*abb93n172+t16*t196*abb93n119+t16*t198*abb93n87+t16*t199*abb9&
         &3n88+t16*t3*abb93n90+t16*t4*abb93n111+t17*t195*abb93n157+t17*t196*abb9&
         &3n106+t17*t197*abb93n94+t17*t198*abb93n93+t17*t199*abb93n105+t17*t2*ab&
         &b93n111+t17*t3*abb93n101+t17*t6*abb93n86+t18*t195*abb93n146+t18*t196*a&
         &bb93n110+t18*t197*abb93n102+t18*t198*abb93n103+t18*t199*abb93n109+t18*&
         &t2*abb93n90+t18*t4*abb93n101+t195*t21*abb93n128+t197*t21*abb93n117+t19&
         &7*t26*t4+t197*t27*t3+t198*t21*abb93n118+t198*t26*t4+t198*t27*t3+t199*t&
         &29*t6+t2*t29*t3+t22*t4*abb93n86+t1*t10*t3*abb93n148+t1*t10*t4*abb93n14&
         &2+t1*t12*t2*abb93n179+t1*t12*t3*abb93n148+t1*t12*t4*abb93n142+t1*t13*t&
         &2*abb93n181+t1*t13*t4*abb93n141+t1*t14*t2*abb93n180+t1*t14*t3*abb93n14&
         &9+t1*t14*t4*abb93n143+t1*t16*t195*abb93n84+t1*t16*t198*abb93n179+t1*t1&
         &6*t199*abb93n181+t1*t16*t3*abb93n171+t1*t17*t195*abb93n104+t1*t17*t199&
         &*abb93n141+t1*t17*t3*abb93n159+t1*t17*t6*abb93n178+t1*t18*t195*abb93n1&
         &00+t1*t18*t2*abb93n171+t1*t18*t4*abb93n159+t1*t22*t4*abb93n178+t10*t3*&
         &t5*abb93n170+t10*t4*t5*abb93n176+t11*t2*t3*abb93n166+t11*t3*t4*abb93n1&
         &38+t11*t4*t6*abb93n163+t12*t3*t4*abb93n136+t12*t3*t5*abb93n168+t12*t4*&
         &t5*abb93n174+t13*t2*t3*abb93n164+t13*t3*t4*abb93n137+t13*t4*t6*abb93n1&
         &61+t14*t2*t3*abb93n165+t14*t3*t4*abb93n139+t14*t3*t5*abb93n169+t14*t4*&
         &t5*abb93n175+t14*t4*t6*abb93n162+t15*t195*t2*abb93n84+t15*t195*t3*abb9&
         &3n100+t15*t195*t4*abb93n104+t15*t198*t2*abb93n179+t15*t199*t2*abb93n18&
         &1+t15*t199*t4*abb93n141+t15*t2*t3*abb93n171+t15*t3*t4*abb93n159+t15*t4&
         &*t6*abb93n178+t16*t195*t3*abb93n91+t16*t196*t3*abb93n166+t16*t199*t3*a&
         &bb93n164+t16*t3*t4*abb93n161+t17*t195*t3*abb93n107+t17*t195*t5*abb93n8&
         &5+t17*t195*t6*abb93n92+t17*t196*t3*abb93n138+t17*t196*t6*abb93n163+t17&
         &*t197*t5*abb93n176+t17*t198*t3*abb93n136+t17*t198*t5*abb93n174+t17*t19&
         &9*t3*abb93n137+t17*t3*t5*abb93n177+t17*t3*t6*abb93n167+t17*t3*t7*abb93&
         &n140+t17*t3*t8*abb93n144+t17*t3*t9*abb93n160+t18*t195*t2*abb93n91+t18*&
         &t195*t4*abb93n107+t18*t195*t5*abb93n89+t18*t196*t2*abb93n166+t18*t196*&
         &t4*abb93n138+t18*t197*t5*abb93n170+t18*t198*t4*abb93n136+t18*t198*t5*a&
         &bb93n168+t18*t199*t2*abb93n164+t18*t199*t4*abb93n137+t18*t2*t4*abb93n1&
         &61+t18*t4*t5*abb93n177+t18*t4*t6*abb93n167+t18*t4*t7*abb93n140+t18*t4*&
         &t8*abb93n144+t18*t4*t9*abb93n160+t195*t21*t3*abb93n89+t195*t21*t4*abb9&
         &3n85+t195*t22*t4*abb93n92+t196*t22*t4*abb93n163+t197*t21*t3*abb93n170+&
         &t197*t21*t4*abb93n176+t198*t21*t3*abb93n168+t198*t21*t4*abb93n174+t199&
         &*t22*t4*abb93n161+t21*t3*t4*abb93n177+t22*t3*t4*abb93n167+t23*t3*t4*ab&
         &b93n160+t24*t3*t4*abb93n144+t25*t3*t4*abb93n140+t1*t17*t3*t9*abb93n83+&
         &t1*t18*t4*t9*abb93n83+t1*t23*t3*t4*abb93n83+t15*t3*t4*t9*abb93n83)
         return
      end if
      t200 = d(iv1,iv2)
      t19 = k5(iv2)
      t20 = qshift(iv2)
      t26 = t200*abb93n150
      t27 = k2(iv2)
      t28 = k6(iv2)
      t29 = spvak3k1(iv2)
      t30 = t10*t29
      t31 = spvak3k4(iv2)
      t32 = t10*t31
      t33 = spvak5k6(iv2)
      t34 = t10*t33
      t35 = spvak6k5(iv2)
      t36 = t10*t35
      t37 = k1(iv2)
      t38 = t21*t37
      t39 = t15*t37
      t40 = t17*t37
      t41 = t18*t37
      t42 = spvak5k1(iv2)
      t43 = t11*t42
      t44 = t11*t33
      t45 = t11*t35
      t46 = t16*t27
      t47 = t17*t27
      t48 = t18*t27
      t49 = t12*t29
      t50 = t12*t31
      t51 = t12*t42
      t52 = t12*t33
      t53 = t12*t35
      t54 = t19*t21
      t55 = t15*t19
      t56 = t16*t19
      t57 = t17*t19
      t58 = t18*t19
      t59 = t13*t31
      t60 = t13*t42
      t61 = t13*t33
      t62 = t13*t35
      t63 = t15*t28
      t64 = t16*t28
      t65 = t17*t28
      t66 = t18*t28
      t67 = t14*t29
      t68 = t14*t31
      t69 = t14*t42
      t70 = t14*t33
      t71 = t14*t35
      t72 = t20*t21
      t73 = t15*t20
      t74 = t16*t20
      t75 = t17*t20
      t76 = t18*t20
      t77 = t15*t42
      t78 = t15*t33
      t79 = t15*t35
      t80 = t16*t31
      t81 = t17*t31
      t82 = t18*t31
      t83 = t16*t33
      t84 = t16*t35
      t85 = t17*t42
      t86 = t18*t42
      t87 = spvak6k1(iv2)
      t88 = t17*t87
      t89 = t17*t35
      t90 = t22*t33
      t91 = t18*t33
      t92 = t23*t33
      t93 = t23*t35
      t94 = spvak2k1(iv2)
      t95 = t17*t94
      t96 = t18*t94
      t97 = t24*t33
      t98 = spvak2k4(iv2)
      t99 = t17*t98
      t100 = t25*t33
      t101 = spvak2k6(iv2)
      t102 = t101*t17
      t103 = t21*t33
      t104 = t21*t35
      t105 = t17*t29
      t106 = t18*t29
      t107 = t78*abb93n142
      t108 = t79*abb93n148
      t109 = t81*abb93n142
      t110 = t82*abb93n148
      t111 = t23*t31
      t112 = t15*t94
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t197*t26+t199*t26+t200*abb93n108+t1*t200*abb93n1&
         &30+t12*t19*abb93n96+t14*t20*abb93n152+t195*t200*abb93n153+t196*t200*ab&
         &b93n124+t198*t200*abb93n155+t2*t200*abb93n172+t200*t3*abb93n146+t200*t&
         &4*abb93n157+t200*t5*abb93n128+t1*t2*t200*abb93n84+t1*t200*t3*abb93n100&
         &+t1*t200*t4*abb93n104+t2*t200*t3*abb93n91+t200*t3*t4*abb93n107+t200*t3&
         &*t5*abb93n89+t200*t4*t5*abb93n85+t200*t4*t6*abb93n92)+t107*t197+t107*t&
         &198+t108*t197+t108*t198+t109*t197+t109*t198+t110*t197+t110*t198+t30*ab&
         &b93n117+t32*abb93n120+t34*abb93n94+t36*abb93n102+t38*abb93n117+t39*abb&
         &93n120+t40*abb93n94+t41*abb93n102+t43*abb93n119+t44*abb93n106+t45*abb9&
         &3n110+t46*abb93n119+t47*abb93n106+t48*abb93n110+t49*abb93n118+t50*abb9&
         &3n112+t51*abb93n87+t52*abb93n93+t53*abb93n103+t54*abb93n118+t55*abb93n&
         &112+t56*abb93n87+t57*abb93n93+t58*abb93n103+t59*abb93n113+t60*abb93n88&
         &+t61*abb93n105+t62*abb93n109+t63*abb93n113+t64*abb93n88+t65*abb93n105+&
         &t66*abb93n109+t67*abb93n129+t68*abb93n131+t69*abb93n173+t70*abb93n158+&
         &t71*abb93n147+t72*abb93n129+t73*abb93n131+t74*abb93n173+t75*abb93n158+&
         &t76*abb93n147+t77*abb93n116+t78*abb93n115+t79*abb93n114+t80*abb93n116+&
         &t81*abb93n115+t82*abb93n114+t83*abb93n111+t84*abb93n90+t85*abb93n111+t&
         &86*abb93n90+t88*abb93n86+t89*abb93n101+t90*abb93n86+t91*abb93n101+t1*t&
         &34*abb93n142+t1*t36*abb93n148+t1*t40*abb93n142+t1*t41*abb93n148+t1*t51&
         &*abb93n179+t1*t52*abb93n142+t1*t53*abb93n148+t1*t56*abb93n179+t1*t57*a&
         &bb93n142+t1*t58*abb93n148+t1*t60*abb93n181+t1*t61*abb93n141+t1*t64*abb&
         &93n181+t1*t65*abb93n141+t1*t69*abb93n180+t1*t70*abb93n143+t1*t71*abb93&
         &n149+t1*t74*abb93n180+t1*t75*abb93n143+t1*t76*abb93n149+t1*t84*abb93n1&
         &71+t1*t86*abb93n171+t1*t88*abb93n178+t1*t89*abb93n159+t1*t90*abb93n178&
         &+t1*t91*abb93n159+t10*t19*abb93n99+t10*t20*abb93n151+t10*t27*abb93n121&
         &+t10*t28*abb93n95+t100*t3*abb93n140+t102*t3*abb93n140+t103*t195*abb93n&
         &85+t103*t197*abb93n176+t103*t198*abb93n174+t103*t3*abb93n177+t104*t195&
         &*abb93n89+t104*t197*abb93n170+t104*t198*abb93n168+t104*t4*abb93n177+t1&
         &05*t195*abb93n85+t105*t197*abb93n176+t105*t198*abb93n174+t105*t3*abb93&
         &n177+t106*t195*abb93n89+t106*t197*abb93n170+t106*t198*abb93n168+t106*t&
         &4*abb93n177+t11*t19*abb93n121+t11*t20*abb93n125+t11*t37*abb93n121+t12*&
         &t20*abb93n156+t12*t27*abb93n121+t12*t28*abb93n98+t12*t37*abb93n99+t13*&
         &t19*abb93n98+t13*t20*abb93n151+t13*t37*abb93n95+t14*t19*abb93n156+t14*&
         &t27*abb93n125+t14*t28*abb93n151+t14*t37*abb93n151+t195*t77*abb93n84+t1&
         &95*t78*abb93n104+t195*t79*abb93n100+t195*t80*abb93n84+t195*t81*abb93n1&
         &04+t195*t82*abb93n100+t195*t84*abb93n91+t195*t86*abb93n91+t195*t88*abb&
         &93n92+t195*t89*abb93n107+t195*t90*abb93n92+t195*t91*abb93n107+t196*t84&
         &*abb93n166+t196*t86*abb93n166+t196*t88*abb93n163+t196*t89*abb93n138+t1&
         &96*t90*abb93n163+t196*t91*abb93n138+t198*t77*abb93n179+t198*t80*abb93n&
         &179+t198*t89*abb93n136+t198*t91*abb93n136+t199*t77*abb93n181+t199*t78*&
         &abb93n141+t199*t80*abb93n181+t199*t81*abb93n141+t199*t84*abb93n164+t19&
         &9*t86*abb93n164+t199*t88*abb93n161+t199*t89*abb93n137+t199*t90*abb93n1&
         &61+t199*t91*abb93n137+t2*t45*abb93n166+t2*t48*abb93n166+t2*t50*abb93n1&
         &79+t2*t55*abb93n179+t2*t59*abb93n181+t2*t62*abb93n164+t2*t63*abb93n181&
         &+t2*t66*abb93n164+t2*t68*abb93n180+t2*t71*abb93n165+t2*t73*abb93n180+t&
         &2*t76*abb93n165+t2*t79*abb93n171+t2*t82*abb93n171+t2*t89*abb93n161+t2*&
         &t91*abb93n161+t3*t30*abb93n170+t3*t32*abb93n148+t3*t38*abb93n170+t3*t3&
         &9*abb93n148+t3*t43*abb93n166+t3*t44*abb93n138+t3*t46*abb93n166+t3*t47*&
         &abb93n138+t3*t49*abb93n168+t3*t50*abb93n148+t3*t52*abb93n136+t3*t54*ab&
         &b93n168+t3*t55*abb93n148+t3*t57*abb93n136+t3*t60*abb93n164+t3*t61*abb9&
         &3n137+t3*t64*abb93n164+t3*t65*abb93n137+t3*t67*abb93n169+t3*t68*abb93n&
         &149+t3*t69*abb93n165+t3*t70*abb93n139+t3*t72*abb93n169+t3*t73*abb93n14&
         &9+t3*t74*abb93n165+t3*t75*abb93n139+t3*t77*abb93n171+t3*t78*abb93n159+&
         &t3*t80*abb93n171+t3*t81*abb93n159+t3*t83*abb93n161+t3*t85*abb93n161+t3&
         &*t88*abb93n167+t3*t90*abb93n167+t3*t92*abb93n160+t3*t95*abb93n160+t3*t&
         &97*abb93n144+t3*t99*abb93n144+t30*t4*abb93n176+t32*t4*abb93n142+t34*t5&
         &*abb93n176+t36*t5*abb93n170+t38*t4*abb93n176+t39*t4*abb93n142+t4*t45*a&
         &bb93n138+t4*t48*abb93n138+t4*t49*abb93n174+t4*t50*abb93n142+t4*t53*abb&
         &93n136+t4*t54*abb93n174+t4*t55*abb93n142+t4*t58*abb93n136+t4*t59*abb93&
         &n141+t4*t62*abb93n137+t4*t63*abb93n141+t4*t66*abb93n137+t4*t67*abb93n1&
         &75+t4*t68*abb93n143+t4*t71*abb93n139+t4*t72*abb93n175+t4*t73*abb93n143&
         &+t4*t76*abb93n139+t4*t79*abb93n159+t4*t82*abb93n159+t4*t84*abb93n161+t&
         &4*t86*abb93n161+t4*t93*abb93n160+t4*t96*abb93n160+t40*t5*abb93n176+t41&
         &*t5*abb93n170+t44*t6*abb93n163+t47*t6*abb93n163+t5*t52*abb93n174+t5*t5&
         &3*abb93n168+t5*t57*abb93n174+t5*t58*abb93n168+t5*t70*abb93n175+t5*t71*&
         &abb93n169+t5*t75*abb93n175+t5*t76*abb93n169+t5*t89*abb93n177+t5*t91*ab&
         &b93n177+t6*t61*abb93n161+t6*t65*abb93n161+t6*t70*abb93n162+t6*t75*abb9&
         &3n162+t6*t78*abb93n178+t6*t81*abb93n178+t6*t89*abb93n167+t6*t91*abb93n&
         &167+t7*t89*abb93n140+t7*t91*abb93n140+t8*t89*abb93n144+t8*t91*abb93n14&
         &4+t89*t9*abb93n160+t9*t91*abb93n160+t1*t3*t92*abb93n83+t1*t3*t95*abb93&
         &n83+t1*t4*t93*abb93n83+t1*t4*t96*abb93n83+t1*t89*t9*abb93n83+t1*t9*t91&
         &*abb93n83+t101*t18*t4*abb93n140+t11*t4*t87*abb93n163+t111*t3*t4*abb93n&
         &83+t112*t3*t4*abb93n83+t13*t4*t87*abb93n161+t14*t4*t87*abb93n162+t15*t&
         &4*t87*abb93n178+t18*t4*t87*abb93n167+t18*t4*t98*abb93n144+t20*t22*t4*a&
         &bb93n162+t22*t27*t4*abb93n163+t22*t28*t4*abb93n161+t22*t31*t4*abb93n17&
         &8+t22*t35*t4*abb93n167+t24*t35*t4*abb93n144+t25*t35*t4*abb93n140+t3*t7&
         &8*t9*abb93n83+t3*t81*t9*abb93n83+t4*t79*t9*abb93n83+t4*t82*t9*abb93n83&
         &)
         return
      end if
      t195 = d(iv2,iv3)
      t196 = d(iv1,iv3)
      t7 = k1(iv3)
      t8 = k2(iv3)
      t26 = k5(iv3)
      t34 = k6(iv3)
      t36 = qshift(iv3)
      t40 = t195*t21
      t41 = t196*t29
      t45 = spvak3k1(iv3)
      t48 = t200*t45
      t51 = t15*t195
      t53 = t196*t31
      t56 = spvak3k4(iv3)
      t58 = t200*t56
      t62 = t16*t195
      t66 = t196*t42
      t71 = spvak5k1(iv3)
      t76 = t200*t71
      t93 = t17*t195
      t96 = t196*t33
      t107 = spvak5k6(iv3)
      t108 = t107*t200
      t109 = t18*t195
      t110 = t196*t35
      t113 = spvak6k5(iv3)
      t114 = t113*t200
      t115 = spvak6k1(iv3)
      t116 = t10*t45
      t117 = t10*t56
      t118 = t37*t45
      t119 = t37*t56
      t120 = t21*t7
      t121 = t29*t7
      t122 = t15*t7
      t123 = t31*t7
      t124 = t107*t11
      t125 = t107*t27
      t126 = t17*t8
      t127 = t33*t8
      t128 = t12*t45
      t129 = t12*t56
      t130 = t19*t45
      t131 = t19*t56
      t132 = t21*t26
      t133 = t26*t29
      t134 = t15*t26
      t135 = t26*t31
      t136 = t13*t56
      t137 = t107*t13
      t138 = t28*t56
      t139 = t107*t28
      t140 = t15*t34
      t141 = t31*t34
      t142 = t17*t34
      t143 = t33*t34
      t144 = t14*t45
      t145 = t14*t56
      t146 = t107*t14
      t147 = t20*t45
      t148 = t20*t56
      t149 = t107*t20
      t150 = t21*t36
      t151 = t29*t36
      t152 = t15*t36
      t153 = t31*t36
      t154 = t17*t36
      t155 = t33*t36
      t92 = t113*t92
      t156 = t107*t23*t35
      t95 = t113*t95
      t157 = t107*t18*t94
      t158 = spvak2k1(iv3)
      t159 = t158*t17*t35
      t160 = t158*t18*t33
      t161 = spvak2k4(iv3)
      t162 = spvak2k6(iv3)
      t163 = t107*t21
      t164 = t107*t29
      t165 = t17*t45
      t166 = t33*t45
      t167 = t15*t71
      t168 = t113*t78
      t169 = t107*t15
      t170 = t169*t35
      t171 = t31*t71
      t172 = t113*t81
      t173 = t107*t31
      t174 = t173*t18
      t175 = t16*t56
      t176 = t42*t56
      t177 = t17*t56
      t178 = t177*t35
      t179 = t33*t56
      t180 = t179*t18
      t181 = t115*t17
      t182 = t115*t33
      t183 = t107*t22
      t184 = t107*t87
      t185 = t107*t111
      t186 = t23*t56
      t187 = t186*t33
      t188 = t107*t112
      t189 = t56*t94
      t190 = t17*t189
      t191 = t15*t158
      t192 = t191*t33
      t193 = t158*t31
      t194 = t17*t193
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t108*abb93n157+t109*abb93n146+t110*abb93n146+t11&
         &4*abb93n146+t40*abb93n128+t41*abb93n128+t48*abb93n128+t51*abb93n130+t5&
         &3*abb93n130+t58*abb93n130+t62*abb93n172+t66*abb93n172+t76*abb93n172+t9&
         &3*abb93n157+t96*abb93n157+t1*t108*abb93n104+t1*t109*abb93n100+t1*t110*&
         &abb93n100+t1*t114*abb93n100+t1*t62*abb93n84+t1*t66*abb93n84+t1*t76*abb&
         &93n84+t1*t93*abb93n104+t1*t96*abb93n104+t10*t195*abb93n150+t108*t3*abb&
         &93n107+t108*t5*abb93n85+t108*t6*abb93n92+t109*t2*abb93n91+t109*t4*abb9&
         &3n107+t109*t5*abb93n89+t11*t195*abb93n124+t110*t2*abb93n91+t110*t4*abb&
         &93n107+t110*t5*abb93n89+t114*t2*abb93n91+t114*t4*abb93n107+t114*t5*abb&
         &93n89+t12*t195*abb93n155+t13*t195*abb93n150+t14*t195*abb93n152+t19*t19&
         &6*abb93n155+t196*t20*abb93n152+t196*t27*abb93n124+t196*t28*abb93n150+t&
         &196*t37*abb93n150+t2*t51*abb93n84+t2*t53*abb93n84+t2*t58*abb93n84+t200&
         &*t26*abb93n155+t200*t34*abb93n150+t200*t36*abb93n152+t200*t7*abb93n150&
         &+t200*t8*abb93n124+t3*t40*abb93n89+t3*t41*abb93n89+t3*t48*abb93n89+t3*&
         &t51*abb93n100+t3*t53*abb93n100+t3*t58*abb93n100+t3*t62*abb93n91+t3*t66&
         &*abb93n91+t3*t76*abb93n91+t3*t93*abb93n107+t3*t96*abb93n107+t4*t40*abb&
         &93n85+t4*t41*abb93n85+t4*t48*abb93n85+t4*t51*abb93n104+t4*t53*abb93n10&
         &4+t4*t58*abb93n104+t5*t93*abb93n85+t5*t96*abb93n85+t6*t93*abb93n92+t6*&
         &t96*abb93n92+t115*t200*t4*abb93n92+t195*t22*t4*abb93n92+t196*t4*t87*ab&
         &b93n92)+t156*abb93n160+t157*abb93n160+t159*abb93n160+t160*abb93n160+t1&
         &68*abb93n159+t170*abb93n159+t172*abb93n159+t174*abb93n159+t178*abb93n1&
         &59+t180*abb93n159+t92*abb93n160+t95*abb93n160+t1*t156*abb93n83+t1*t157&
         &*abb93n83+t1*t159*abb93n83+t1*t160*abb93n83+t1*t92*abb93n83+t1*t95*abb&
         &93n83+t100*t113*abb93n140+t102*t113*abb93n140+t103*t113*abb93n177+t105&
         &*t113*abb93n177+t107*t30*abb93n176+t107*t32*abb93n142+t107*t38*abb93n1&
         &76+t107*t39*abb93n142+t107*t49*abb93n174+t107*t50*abb93n142+t107*t54*a&
         &bb93n174+t107*t55*abb93n142+t107*t59*abb93n141+t107*t63*abb93n141+t107&
         &*t67*abb93n175+t107*t68*abb93n143+t107*t72*abb93n175+t107*t73*abb93n14&
         &3+t113*t30*abb93n170+t113*t32*abb93n148+t113*t38*abb93n170+t113*t39*ab&
         &b93n148+t113*t43*abb93n166+t113*t44*abb93n138+t113*t46*abb93n166+t113*&
         &t47*abb93n138+t113*t49*abb93n168+t113*t50*abb93n148+t113*t52*abb93n136&
         &+t113*t54*abb93n168+t113*t55*abb93n148+t113*t57*abb93n136+t113*t60*abb&
         &93n164+t113*t61*abb93n137+t113*t64*abb93n164+t113*t65*abb93n137+t113*t&
         &67*abb93n169+t113*t68*abb93n149+t113*t69*abb93n165+t113*t70*abb93n139+&
         &t113*t72*abb93n169+t113*t73*abb93n149+t113*t74*abb93n165+t113*t75*abb9&
         &3n139+t113*t77*abb93n171+t113*t80*abb93n171+t113*t83*abb93n161+t113*t8&
         &5*abb93n161+t113*t88*abb93n167+t113*t90*abb93n167+t113*t97*abb93n144+t&
         &113*t99*abb93n144+t115*t44*abb93n163+t115*t47*abb93n163+t115*t61*abb93&
         &n161+t115*t65*abb93n161+t115*t70*abb93n162+t115*t75*abb93n162+t115*t78&
         &*abb93n178+t115*t81*abb93n178+t116*t33*abb93n176+t116*t35*abb93n170+t1&
         &17*t33*abb93n142+t117*t35*abb93n148+t118*t17*abb93n176+t118*t18*abb93n&
         &170+t119*t17*abb93n142+t119*t18*abb93n148+t120*t33*abb93n176+t120*t35*&
         &abb93n170+t121*t17*abb93n176+t121*t18*abb93n170+t122*t33*abb93n142+t12&
         &2*t35*abb93n148+t123*t17*abb93n142+t123*t18*abb93n148+t124*t35*abb93n1&
         &38+t124*t87*abb93n163+t125*t18*abb93n138+t125*t22*abb93n163+t126*t35*a&
         &bb93n138+t126*t87*abb93n163+t127*t18*abb93n138+t127*t22*abb93n163+t128&
         &*t33*abb93n174+t128*t35*abb93n168+t129*t33*abb93n142+t129*t35*abb93n14&
         &8+t129*t42*abb93n179+t130*t17*abb93n174+t130*t18*abb93n168+t131*t16*ab&
         &b93n179+t131*t17*abb93n142+t131*t18*abb93n148+t132*t33*abb93n174+t132*&
         &t35*abb93n168+t133*t17*abb93n174+t133*t18*abb93n168+t134*t33*abb93n142&
         &+t134*t35*abb93n148+t134*t42*abb93n179+t135*t16*abb93n179+t135*t17*abb&
         &93n142+t135*t18*abb93n148+t136*t33*abb93n141+t136*t42*abb93n181+t137*t&
         &35*abb93n137+t137*t87*abb93n161+t138*t16*abb93n181+t138*t17*abb93n141+&
         &t139*t18*abb93n137+t139*t22*abb93n161+t140*t33*abb93n141+t140*t42*abb9&
         &3n181+t141*t16*abb93n181+t141*t17*abb93n141+t142*t35*abb93n137+t142*t8&
         &7*abb93n161+t143*t18*abb93n137+t143*t22*abb93n161+t144*t33*abb93n175+t&
         &144*t35*abb93n169+t145*t33*abb93n143+t145*t35*abb93n149+t145*t42*abb93&
         &n180+t146*t35*abb93n139+t146*t87*abb93n162+t147*t17*abb93n175+t147*t18&
         &*abb93n169+t148*t16*abb93n180+t148*t17*abb93n143+t148*t18*abb93n149+t1&
         &49*t18*abb93n139+t149*t22*abb93n162+t150*t33*abb93n175+t150*t35*abb93n&
         &169+t151*t17*abb93n175+t151*t18*abb93n169+t152*t33*abb93n143+t152*t35*&
         &abb93n149+t152*t42*abb93n180+t153*t16*abb93n180+t153*t17*abb93n143+t15&
         &3*t18*abb93n149+t154*t35*abb93n139+t154*t87*abb93n162+t155*t18*abb93n1&
         &39+t155*t22*abb93n162+t163*t35*abb93n177+t164*t18*abb93n177+t165*t35*a&
         &bb93n177+t166*t18*abb93n177+t167*t35*abb93n171+t168*t9*abb93n83+t169*t&
         &87*abb93n178+t170*t9*abb93n83+t171*t18*abb93n171+t172*t9*abb93n83+t173&
         &*t22*abb93n178+t174*t9*abb93n83+t175*t35*abb93n171+t176*t18*abb93n171+&
         &t177*t87*abb93n178+t178*t9*abb93n83+t179*t22*abb93n178+t18*t182*abb93n&
         &167+t18*t184*abb93n167+t180*t9*abb93n83+t181*t35*abb93n167+t183*t35*ab&
         &b93n167+t185*t3*abb93n83+t187*t3*abb93n83+t188*t3*abb93n83+t190*t3*abb&
         &93n83+t192*t3*abb93n83+t194*t3*abb93n83+t50*t71*abb93n179+t55*t71*abb9&
         &3n179+t59*t71*abb93n181+t63*t71*abb93n181+t68*t71*abb93n180+t71*t73*ab&
         &b93n180+t101*t107*t18*abb93n140+t107*t12*t35*abb93n136+t107*t16*t35*ab&
         &b93n161+t107*t18*t19*abb93n136+t107*t18*t42*abb93n161+t107*t18*t98*abb&
         &93n144+t107*t24*t35*abb93n144+t107*t25*t35*abb93n140+t11*t35*t71*abb93&
         &n166+t111*t113*t4*abb93n83+t112*t113*t4*abb93n83+t13*t35*t71*abb93n164&
         &+t14*t35*t71*abb93n165+t16*t34*t35*abb93n164+t16*t35*t36*abb93n165+t16&
         &*t35*t8*abb93n166+t161*t17*t35*abb93n144+t161*t18*t33*abb93n144+t162*t&
         &17*t35*abb93n140+t162*t18*t33*abb93n140+t17*t26*t35*abb93n136+t17*t35*&
         &t71*abb93n161+t18*t189*t4*abb93n83+t18*t193*t4*abb93n83+t18*t20*t71*ab&
         &b93n165+t18*t26*t33*abb93n136+t18*t27*t71*abb93n166+t18*t28*t71*abb93n&
         &164+t18*t33*t71*abb93n161+t18*t34*t42*abb93n164+t18*t36*t42*abb93n165+&
         &t18*t42*t8*abb93n166+t186*t35*t4*abb93n83+t191*t35*t4*abb93n83)
         return
      end if
      t197 = d(iv3,iv4)
      t198 = d(iv2,iv4)
      t199 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak6k5(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak5k1(iv4)
      t5 = spvak3k4(iv4)
      t6 = spvak6k1(iv4)
      t7 = t23*t5
      t8 = t5*t94
      t9 = t158*t5
      t10 = spvak2k1(iv4)
      t11 = t10*t15
      t12 = t10*t31
      t10 = t10*t56
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t195*t199*abb93n97+t196*t198*abb93n97+t197*t200*&
         &abb93n97)+(2.0_ki)*(t103*t197*abb93n85+t104*t197*abb93n89+t105*t197*ab&
         &b93n85+t106*t197*abb93n89+t163*t198*abb93n85+t164*t199*abb93n85+t165*t&
         &198*abb93n85+t166*t199*abb93n85+t167*t198*abb93n84+t169*t198*abb93n104&
         &+t171*t199*abb93n84+t173*t199*abb93n104+t175*t198*abb93n84+t176*t199*a&
         &bb93n84+t177*t198*abb93n104+t179*t199*abb93n104+t181*t198*abb93n92+t18&
         &2*t199*abb93n92+t183*t198*abb93n92+t184*t199*abb93n92+t197*t77*abb93n8&
         &4+t197*t78*abb93n104+t197*t79*abb93n100+t197*t80*abb93n84+t197*t81*abb&
         &93n104+t197*t82*abb93n100+t197*t84*abb93n91+t197*t86*abb93n91+t197*t88&
         &*abb93n92+t197*t89*abb93n107+t197*t90*abb93n92+t197*t91*abb93n107+t1*t&
         &113*t200*abb93n107+t1*t115*t200*abb93n92+t1*t15*t195*abb93n104+t1*t18*&
         &t195*abb93n107+t1*t195*t21*abb93n85+t1*t195*t22*abb93n92+t1*t196*t29*a&
         &bb93n85+t1*t196*t31*abb93n104+t1*t196*t35*abb93n107+t1*t196*t87*abb93n&
         &92+t1*t200*t45*abb93n85+t1*t200*t56*abb93n104+t107*t18*t198*abb93n107+&
         &t107*t199*t35*abb93n107+t107*t2*t200*abb93n107+t107*t200*t3*abb93n85+t&
         &107*t200*t5*abb93n104+t107*t200*t6*abb93n92+t113*t15*t198*abb93n100+t1&
         &13*t16*t198*abb93n91+t113*t17*t198*abb93n107+t113*t198*t21*abb93n89+t1&
         &13*t199*t29*abb93n89+t113*t199*t31*abb93n100+t113*t199*t33*abb93n107+t&
         &113*t199*t42*abb93n91+t113*t200*t3*abb93n89+t113*t200*t4*abb93n91+t113&
         &*t200*t5*abb93n100+t15*t195*t2*abb93n100+t15*t195*t4*abb93n84+t16*t195&
         &*t2*abb93n91+t16*t195*t5*abb93n84+t17*t195*t2*abb93n107+t17*t195*t3*ab&
         &b93n85+t17*t195*t5*abb93n104+t17*t195*t6*abb93n92+t18*t195*t3*abb93n89&
         &+t18*t195*t4*abb93n91+t18*t195*t5*abb93n100+t18*t198*t45*abb93n89+t18*&
         &t198*t56*abb93n100+t18*t198*t71*abb93n91+t195*t2*t21*abb93n89+t196*t2*&
         &t29*abb93n89+t196*t2*t31*abb93n100+t196*t2*t33*abb93n107+t196*t2*t42*a&
         &bb93n91+t196*t3*t33*abb93n85+t196*t3*t35*abb93n89+t196*t31*t4*abb93n84&
         &+t196*t33*t5*abb93n104+t196*t33*t6*abb93n92+t196*t35*t4*abb93n91+t196*&
         &t35*t5*abb93n100+t196*t42*t5*abb93n84+t199*t35*t45*abb93n89+t199*t35*t&
         &56*abb93n100+t199*t35*t71*abb93n91+t2*t200*t45*abb93n89+t2*t200*t56*ab&
         &b93n100+t2*t200*t71*abb93n91+t200*t4*t56*abb93n84+t200*t5*t71*abb93n84&
         &)+t185*t2*abb93n83+t187*t2*abb93n83+t188*t2*abb93n83+t190*t2*abb93n83+&
         &t192*t2*abb93n83+t194*t2*abb93n83+t1*t111*t113*abb93n83+t1*t112*t113*a&
         &bb93n83+t1*t18*t189*abb93n83+t1*t18*t193*abb93n83+t1*t186*t35*abb93n83&
         &+t1*t191*t35*abb93n83+t10*t17*t35*abb93n83+t10*t18*t33*abb93n83+t107*t&
         &11*t35*abb93n83+t107*t12*t18*abb93n83+t107*t18*t8*abb93n83+t107*t35*t7&
         &*abb93n83+t11*t113*t33*abb93n83+t113*t12*t17*abb93n83+t113*t17*t8*abb9&
         &3n83+t113*t33*t7*abb93n83+t17*t35*t9*abb93n83+t18*t33*t9*abb93n83)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d93:
   subroutine     reconstruct_d93(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_93:
      coeffs%coeffs_93%c0 = derivative(czip)
      coeffs%coeffs_93%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_93%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_93%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_93%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_93%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_93%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_93%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_93%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_93%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_93%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_93%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_93%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_93%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_93%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_93%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_93%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_93%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_93%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_93%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_93%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_93%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_93%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_93%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_93%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_93%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_93%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_93%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_93%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_93%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_93%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_93%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_93%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_93%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_93%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_93%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_93%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_93%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_93%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_93%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_93%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_93%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_93%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_93%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_93%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_93%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_93%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_93%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_93%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_93:
   end subroutine reconstruct_d93
!---#] subroutine reconstruct_d93:
end module p9_udbar_neepgg_d93h3l1d
