module     p0_ddbar_neepdubar_d56h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity0/d56h0l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d56
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd56h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      real(ki) :: t25
      real(ki) :: t26
      real(ki) :: t27
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1k6(3)*qshift(3)-sp&
      &vak1k6(4)*qshift(4))
      t25 = dotproduct(k6, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t3 = (spvak1k4(1)*qshift(1)-spvak1k4(2)*qshift(2)-spvak1k4(3)*qshift(3)-sp&
      &vak1k4(4)*qshift(4))
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t26 = dotproduct(k1, qshift)
      t5 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t27 = dotproduct(qshift, qshift)
      t6 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-sp&
      &vak1k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb56n16+t25*abb56n37+t1*t2*abb56n18+t1*t25*abb56n23+t1&
         &*t26*abb56n21+t1*t27*abb56n41+t1*t4*abb56n20+t2*t25*abb56n24+t25*t5*ab&
         &b56n26+t26*t4*abb56n29+t26*t5*abb56n28+t27*t5*abb56n34+t3*t4*abb56n19+&
         &t2*t4*t6*abb56n47)
         return
      end if
      t7 = k6(iv1)
      t8 = spvak1k6(iv1)
      t9 = k1(iv1)
      t10 = qshift(iv1)
      t11 = spvak1k4(iv1)
      t12 = spvak3k4(iv1)
      t13 = spvak3k6(iv1)
      t14 = spvak5k6(iv1)
      t15 = spvak1k2(iv1)
      if(deg.eq.1) then
         numerator = (t7*abb56n25+t8*abb56n30+t1*t10*abb56n40+t1*t12*abb56n46+t1&
         &*t14*abb56n44+t1*t7*abb56n39+t1*t9*abb56n43+t10*t5*abb56n33+t11*t4*abb&
         &56n45+t12*t25*abb56n38+t13*t25*abb56n36+t13*t26*abb56n32+t13*t27*abb56&
         &n27+t14*t26*abb56n31+t14*t3*abb56n45+t2*t7*abb56n38+t2*t8*abb56n46+t25&
         &*t8*abb56n39+t26*t8*abb56n43+t27*t8*abb56n22+t4*t8*abb56n44+t4*t9*abb5&
         &6n31+t5*t7*abb56n36+t5*t9*abb56n32+t12*t4*t6*abb56n17+t14*t2*t6*abb56n&
         &17+t15*t2*t4*abb56n17)
         return
      end if
      t25 = d(iv1,iv2)
      t3 = spvak1k6(iv2)
      t16 = spvak3k6(iv2)
      t17 = spvak5k6(iv2)
      t18 = k1(iv2)
      t19 = spvak3k4(iv2)
      t20 = k6(iv2)
      t21 = qshift(iv2)
      t22 = t15*t19
      t23 = spvak1k2(iv2)
      t24 = t12*t23
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t1*t25*abb56n41+t25*t5*abb56n34)+spvak1k4(iv2)*t&
         &14*abb56n19+t10*t16*abb56n35+t10*t3*abb56n42+t11*t17*abb56n19+t12*t20*&
         &abb56n24+t12*t3*abb56n18+t13*t18*abb56n28+t13*t20*abb56n26+t13*t21*abb&
         &56n35+t14*t18*abb56n29+t14*t3*abb56n20+t16*t7*abb56n26+t16*t9*abb56n28&
         &+t17*t8*abb56n20+t17*t9*abb56n29+t18*t8*abb56n21+t19*t7*abb56n24+t19*t&
         &8*abb56n18+t20*t8*abb56n23+t21*t8*abb56n42+t22*t4*abb56n47+t24*t4*abb5&
         &6n47+t3*t7*abb56n23+t3*t9*abb56n21+t12*t17*t6*abb56n47+t14*t19*t6*abb5&
         &6n47+t14*t2*t23*abb56n47+t15*t17*t2*abb56n47)
         return
      end if
      t26 = d(iv2,iv3)
      t27 = d(iv1,iv3)
      t1 = spvak5k6(iv3)
      t2 = spvak3k4(iv3)
      t4 = spvak1k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k6(iv3)*t25*abb56n22+spvak3k6(iv3)*t25*abb&
         &56n27+t13*t26*abb56n27+t16*t27*abb56n27+t26*t8*abb56n22+t27*t3*abb56n2&
         &2)+t1*t22*abb56n17+t1*t24*abb56n17+t12*t17*t4*abb56n17+t14*t19*t4*abb5&
         &6n17+t14*t2*t23*abb56n17+t15*t17*t2*abb56n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d56:
   subroutine     reconstruct_d56(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_56:
      coeffs%coeffs_56%c0 = derivative(czip)
      coeffs%coeffs_56%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_56%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_56%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_56%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_56%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_56%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_56%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_56%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_56%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_56%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_56%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_56%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_56%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_56%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_56%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_56%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_56%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_56%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_56%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_56%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_56%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_56%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_56%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_56%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_56%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_56%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_56%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_56%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_56%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_56%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_56%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_56%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_56%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_56%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_56:
   end subroutine reconstruct_d56
!---#] subroutine reconstruct_d56:
end module p0_ddbar_neepdubar_d56h0l1d
