module     p0_ddbar_neepdubar_abbrevd57h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb57n1
   complex(ki), public :: abb57n2
   complex(ki), public :: abb57n3
   complex(ki), public :: abb57n4
   complex(ki), public :: abb57n5
   complex(ki), public :: abb57n6
   complex(ki), public :: abb57n7
   complex(ki), public :: abb57n8
   complex(ki), public :: abb57n9
   complex(ki), public :: abb57n10
   complex(ki), public :: abb57n11
   complex(ki), public :: abb57n12
   complex(ki), public :: abb57n13
   complex(ki), public :: abb57n14
   complex(ki), public :: abb57n15
   complex(ki), public :: abb57n16
   complex(ki), public :: abb57n17
   complex(ki), public :: abb57n18
   complex(ki), public :: abb57n19
   complex(ki), public :: rat2d57
   complex(ki), public :: abb57n21
   complex(ki), public :: abb57n22
   complex(ki), public :: abb57n23
   complex(ki), public :: abb57n24
   complex(ki), public :: abb57n25
   complex(ki), public :: abb57n26
   complex(ki), public :: abb57n27
   complex(ki), public :: abb57n28
   complex(ki), public :: abb57n29
   complex(ki), public :: abb57n30
   complex(ki), public :: abb57n31
   complex(ki), public :: abb57n32
   complex(ki), public :: abb57n33
   complex(ki), public :: abb57n34
   complex(ki), public :: abb57n35
   complex(ki), public :: abb57n36
   complex(ki), public :: abb57n37
   complex(ki), public :: abb57n38
   complex(ki), public :: abb57n39
   complex(ki), public :: abb57n40
   complex(ki), public :: abb57n41
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   real(ki) :: t23
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak2k3
      t23 = TR*TR
      t4 = NC*NC*t1
      t5 = t23*t3/t4*spbk6k4
      t6 = c1*i_
      t7 = t6*spak2k3
      t8 = NC*t1
      t9 = (2.0_ki)*t23*t7/t8*spbk6k4
      t10 = NC*c1*i_
      t11 = t10*spak2k3
      t12 = t23*t11/t1*spbk6k4
      t13 = t9-(t5+t12)
      abb57n1 = ((4.0_ki)*t13)
      t14 = t23*t3/t4*spbk4k1
      t15 = (2.0_ki)*t23*t7/t8*spbk4k1
      t16 = t23*t11/t1*spbk4k1
      abb57n2 = ((8.0_ki)*(t14+t16-t15))
      abb57n3 = ((8.0_ki)*(t15-(t16+t14)))
      t14 = t3*spak5k6
      t15 = t7*spak5k6
      t16 = t11*spak5k6
      abb57n4 = ((8.0_ki)*(t23*t16/t1*spbk6k1*spbk6k4+t23*t14/t4*spbk6k1*spbk6k4&
      &-t23*(2.0_ki)*t15/t8*spbk6k1*spbk6k4))
      t17 = t2*spak3k5
      t18 = t23*t17/t4*spbk6k1
      t19 = t6*spak3k5
      t20 = t23*(2.0_ki)*t19/t8*spbk6k1
      t21 = t10*spak3k5
      t22 = t23*t21/t1*spbk6k1
      abb57n5 = ((8.0_ki)*(t18+t22-t20))
      abb57n6 = ((4.0_ki)*(t20-(t22+t18)))
      abb57n7 = ((8.0_ki)*(t23*t19/t8*spbk5k1+t23*t6/t8*spak3k6*spbk6k1)+(4.0_ki&
      &)*(-(t23*t2/t4*spak3k6*spbk6k1+t23*t10/t1*spak3k6*spbk6k1+t23*t17/t4*spbk&
      &5k1+t23*t21/t1*spbk5k1)))
      abb57n8 = ((4.0_ki)*(t23*t10/t1*spak5k6*spbk6k1+t23*t2/t4*spak5k6*spbk6k1-&
      &(2.0_ki)*t23*t6/t8*spak5k6*spbk6k1))
      abb57n9 = ((8.0_ki)*(t23*t6/t8*spak1k3*spbk4k1-t23*t7/t8*spbk4k2)+(4.0_ki)&
      &*(t23*t11/t1*spbk4k2+t23*t3/t4*spbk4k2-(t23*t2/t4*spak1k3*spbk4k1+t23*t10&
      &/t1*spak1k3*spbk4k1)))
      abb57n10 = ((4.0_ki)*(t23*(2.0_ki)*t15/t8*spbk6k2*spbk6k4-(t23*t14/t4*spbk&
      &6k2*spbk6k4+t23*t16/t1*spbk6k2*spbk6k4)))
      abb57n11 = ((4.0_ki)*((2.0_ki)*t23*t7/t8*spbk5k4-(t23*t3/t4*spbk5k4+t23*t1&
      &1/t1*spbk5k4)))
      abb57n12 = ((4.0_ki)*(t12+t5-t9))
      abb57n13 = ((8.0_ki)*t13)
      abb57n14 = ((8.0_ki)*(-(t23*t6/t8*spak2k6*spbk6k4+t23*t6/t8*spak2k5*spbk5k&
      &4+t23*t6/t8*spak1k2*spbk4k1))+(4.0_ki)*(t23*t10/t1*spak1k2*spbk4k1+t23*t1&
      &0/t1*spak2k5*spbk5k4+t23*t10/t1*spak2k6*spbk6k4+t23*t2/t4*spak1k2*spbk4k1&
      &+t23*t2/t4*spak2k5*spbk5k4+t23*t2/t4*spak2k6*spbk6k4))
      t3 = t23*t17/t4*spbk6k4
      t5 = t23*(2.0_ki)*t19/t8*spbk6k4
      t7 = t23*t21/t1*spbk6k4
      abb57n15 = ((4.0_ki)*(t3+t7-t5))
      abb57n16 = ((8.0_ki)*(t5-(t7+t3)))
      t3 = t23*t17/t4*spbk6k5
      t5 = t23*(2.0_ki)*t19/t8*spbk6k5
      t7 = t23*t21/t1*spbk6k5
      abb57n17 = ((4.0_ki)*(t3+t7-t5))
      abb57n18 = ((4.0_ki)*(t5-(t7+t3)))
      abb57n19 = ((4.0_ki)*((2.0_ki)*t23*t6/t8-(t23*t2/t4+t23*t10/t1)))
      rat2d57 = 0
      rat2 = rat2 + rat2d57
      abb57n21 = abb57n1
      abb57n22 = abb57n18
      abb57n23 = abb57n17
      abb57n24 = abb57n16
      abb57n25 = abb57n14
      abb57n26 = abb57n13
      abb57n27 = abb57n12
      abb57n28 = abb57n11
      abb57n29 = abb57n9
      abb57n30 = abb57n8
      abb57n31 = abb57n7
      abb57n32 = abb57n5
      abb57n33 = abb57n3
      abb57n34 = abb57n2
      abb57n35 = -(abb57n4)
      abb57n36 = -(abb57n6)
      abb57n37 = (-2.0_ki)*abb57n6
      abb57n38 = -(abb57n10)
      abb57n39 = -(abb57n15)
      abb57n40 = (-2.0_ki)*abb57n15
      abb57n41 = -(abb57n19)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd57h1
