module     p0_ddbar_neepdubar_abbrevd58h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb58n1
   complex(ki), public :: abb58n2
   complex(ki), public :: abb58n3
   complex(ki), public :: abb58n4
   complex(ki), public :: abb58n5
   complex(ki), public :: abb58n6
   complex(ki), public :: abb58n7
   complex(ki), public :: abb58n8
   complex(ki), public :: abb58n9
   complex(ki), public :: abb58n10
   complex(ki), public :: abb58n11
   complex(ki), public :: abb58n12
   complex(ki), public :: abb58n13
   complex(ki), public :: rat2d58
   complex(ki), public :: abb58n15
   complex(ki), public :: abb58n16
   complex(ki), public :: abb58n17
   complex(ki), public :: abb58n18
   complex(ki), public :: abb58n19
   complex(ki), public :: abb58n20
   complex(ki), public :: abb58n21
   complex(ki), public :: abb58n22
   complex(ki), public :: abb58n23
   complex(ki), public :: abb58n24
   complex(ki), public :: abb58n25
   complex(ki), public :: abb58n26
   complex(ki), public :: abb58n27
   complex(ki), public :: abb58n28
   complex(ki), public :: abb58n29
   complex(ki), public :: abb58n30
   complex(ki), public :: abb58n31
   complex(ki), public :: abb58n32
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   real(ki) :: t20
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k3
      t4 = t3*spak2k5
      t20 = TR*TR
      t5 = NC*t1
      t6 = t2*spak2k5
      t7 = t6*spak3k5
      t8 = c2*i_
      t9 = t8*spak2k3
      t10 = t9*spak2k5
      t11 = t20*t10*spbk6k2*spbk6k4
      t12 = t8*spak2k5
      t13 = t12*spak3k5
      t14 = t20*t13*spbk6k4*spbk6k5
      t15 = NC*NC*t1
      abb58n1 = ((8.0_ki)*(t20*t4/t5*spbk6k2*spbk6k4+t20/t5*t7*spbk6k4*spbk6k5)+&
      &(4.0_ki)*(-(t14/t15+t11/t15+t14/t1+t11/t1)))
      t11 = t4*spbk2k1
      t14 = t7*spbk4k1
      t16 = t10*spbk2k1
      t17 = t20*t16*spbk4k1
      t18 = t13*spbk4k1
      t19 = t20*t18*spbk5k1
      abb58n2 = ((8.0_ki)*(t20*t11/t5*spbk4k1+t20*t14/t5*spbk5k1)+(4.0_ki)*(-(t1&
      &9/t15+t17/t15+t19/t1+t17/t1)))
      t17 = t20*t10*spbk4k1*spbk6k2
      t18 = t20*t18*spbk6k5
      abb58n3 = ((16.0_ki)*(t20*t14/t5*spbk6k5+t20*t4/t5*spbk4k1*spbk6k2)+(8.0_k&
      &i)*(-(t18/t15+t17/t15+t18/t1+t17/t1)))
      t14 = t20*t12*spbk4k1
      t17 = t14/t1
      t14 = t14/t15
      t18 = (2.0_ki)*t20/t5*t6*spbk4k1
      abb58n4 = ((8.0_ki)*(t14+t17-t18))
      t14 = t18-(t17+t14)
      abb58n5 = ((4.0_ki)*t14)
      abb58n6 = ((8.0_ki)*t14)
      t14 = t20*t16*spbk6k4
      t16 = t20*t13*spbk5k1*spbk6k4
      abb58n7 = ((16.0_ki)*(t20*t11/t5*spbk6k4+t20/t5*t7*spbk5k1*spbk6k4)+(8.0_k&
      &i)*(-(t16/t15+t14/t15+t16/t1+t14/t1)))
      t11 = t20*t12*spbk6k1
      t14 = t11/t1
      t11 = t11/t15
      t16 = (2.0_ki)*t20/t5*t6*spbk6k1
      abb58n8 = ((8.0_ki)*(t11+t14-t16))
      abb58n9 = ((8.0_ki)*(t16-(t14+t11)))
      t11 = t20*t8*spak1k2*spak3k5*spbk4k1*spbk6k1
      t14 = t20*t8*spak1k5*spak2k3*spbk4k1*spbk6k1
      t10 = t20*t10*spbk4k2*spbk6k1
      t9 = t20*t9*spak5k6*spbk6k1*spbk6k4
      t13 = t20*t13*spbk5k4*spbk6k1
      t8 = t20*t8*spak2k6*spak3k5*spbk6k1*spbk6k4
      abb58n10 = ((8.0_ki)*(t20/t5*t7*spbk5k4*spbk6k1+t20*t2/t5*spak1k2*spak3k5*&
      &spbk4k1*spbk6k1+t20*t2/t5*spak1k5*spak2k3*spbk4k1*spbk6k1-(t20*t2/t5*spak&
      &2k6*spak3k5*spbk6k1*spbk6k4+t20*t3/t5*spak5k6*spbk6k1*spbk6k4+t20*t4/t5*s&
      &pbk4k2*spbk6k1))+(4.0_ki)*(t10/t1+t8/t1+t9/t1+t10/t15+t8/t15+t9/t15-(t14/&
      &t15+t13/t15+t11/t15+t14/t1+t13/t1+t11/t1)))
      t2 = t20*t12*spbk6k4
      t1 = t2/t1
      t2 = t2/t15
      t3 = (2.0_ki)*t20/t5*t6*spbk6k4
      abb58n11 = ((8.0_ki)*(t1+t2-t3))
      t1 = t3-(t2+t1)
      abb58n12 = ((4.0_ki)*t1)
      abb58n13 = ((8.0_ki)*t1)
      rat2d58 = 0
      rat2 = rat2 + rat2d58
      abb58n15 = -(abb58n1)
      abb58n16 = abb58n13
      abb58n17 = abb58n11
      abb58n18 = abb58n10
      abb58n19 = abb58n9
      abb58n20 = abb58n8
      abb58n21 = abb58n6
      abb58n22 = abb58n4
      abb58n23 = -(abb58n2)
      abb58n24 = -(abb58n3)
      abb58n25 = -(abb58n5)
      abb58n26 = (-2.0_ki)*abb58n5
      abb58n27 = -(abb58n7)
      abb58n28 = -(abb58n8)
      abb58n29 = (-2.0_ki)*abb58n8
      abb58n30 = ((2.0_ki)*abb58n10)
      abb58n31 = -(abb58n12)
      abb58n32 = (-2.0_ki)*abb58n12
   end subroutine
end module p0_ddbar_neepdubar_abbrevd58h1
