module     p0_ddbar_neepdubar_abbrevd7h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb7n1
   complex(ki), public :: abb7n2
   complex(ki), public :: abb7n3
   complex(ki), public :: abb7n4
   complex(ki), public :: abb7n5
   complex(ki), public :: abb7n6
   complex(ki), public :: rat2d7
   complex(ki), public :: abb7n8
   complex(ki), public :: abb7n9
   complex(ki), public :: abb7n10
   complex(ki), public :: abb7n11
   complex(ki), public :: abb7n12
   complex(ki), public :: abb7n13
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   real(ki) :: t33
   real(ki) :: t34
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t33 = es12+es34-(es56+es345)
      t2 = c2*i_
      t34 = TR*TR
      t3 = t34*t2*spak2k3*spak2k5*spbk2k1*spbk6k4
      t4 = t33*(es234-(es61+es56))*t1
      t5 = t3/t4
      t2 = t2*spak2k5
      t6 = t34*t2*spak3k5*spbk5k1*spbk6k4
      t7 = t6/t4
      t8 = c1*i_
      t9 = t34*t8*spak2k3*spak2k5*spbk2k1*spbk6k4
      t1 = t33*t1
      t10 = es12*t1
      t11 = t9/t10
      t8 = t8*spak2k5
      t12 = t34*t8*spak3k5*spbk5k1*spbk6k4
      t13 = t12/t10
      t33 = NC*NC
      t14 = t33*t4
      t15 = t3/t14
      t16 = t6/t14
      t17 = NC*t4
      t18 = t9/t17
      t19 = t12/t17
      t20 = NC*c1*i_
      t21 = t34*t20/t4*spak2k3*spak2k5*spbk2k1*spbk6k4
      t20 = t20*spak2k5
      t22 = t34*t20/t4*spak3k5*spbk5k1*spbk6k4
      t23 = t33*t10
      t9 = t9/t23
      t12 = t12/t23
      t1 = es12*NC*t1
      t3 = t3/t1
      t6 = t6/t1
      t24 = NC*c2*i_
      t25 = t34*t24/t10*spak2k3*spak2k5*spbk2k1*spbk6k4
      t24 = t24*spak2k5
      t26 = t34*t24/t10*spak3k5*spbk5k1*spbk6k4
      abb7n1 = ((2.0_ki)*(t11+t13+t18+t19+t3+t5+t6+t7-(t9+t26+t25+t22+t21+t16+t1&
      &5+t12)))
      t27 = t2*spak3k4
      t28 = t34*t27*spbk2k1*spbk6k4
      t29 = t8*spak3k4
      t30 = t34*t29*spbk2k1*spbk6k4
      t31 = t20*spak3k4
      t32 = t24*spak3k4
      abb7n2 = ((4.0_ki)*(t28/t14+t30/t23+t34*t32/t10*spbk2k1*spbk6k4+t34*t31/t4&
      &*spbk2k1*spbk6k4-(t28/t4+t30/t17+t30/t10+t28/t1)))
      t28 = t34*t2*spbk2k1
      t30 = t34*t8*spbk2k1
      abb7n3 = ((4.0_ki)*(t28/t14+t30/t23+t34*t24/t10*spbk2k1+t34*t20/t4*spbk2k1&
      &-(t28/t4+t30/t17+t30/t10+t28/t1)))
      t27 = t34*t27*spbk5k1*spbk6k4
      t28 = t34*t29*spbk5k1*spbk6k4
      abb7n4 = ((4.0_ki)*(t27/t1+t28/t10+t28/t17+t27/t4-(t34*t31/t4*spbk5k1*spbk&
      &6k4+t34*t32/t10*spbk5k1*spbk6k4+t28/t23+t27/t14)))
      abb7n5 = ((4.0_ki)*(t12+t15+t16+t21+t22+t25+t26+t9-(t7+t6+t5+t3+t19+t18+t1&
      &3+t11)))
      t2 = t34*t2*spbk5k1
      t3 = t34*t8*spbk5k1
      abb7n6 = ((4.0_ki)*(t2/t1+t3/t10+t3/t17+t2/t4-(t34*t20/t4*spbk5k1+t34*t24/&
      &t10*spbk5k1+t3/t23+t2/t14)))
      rat2d7 = abb7n1
      rat2 = rat2 + rat2d7
      abb7n8 = -(abb7n4)
      abb7n9 = abb7n6
      abb7n10 = abb7n5
      abb7n11 = abb7n3
      abb7n12 = -(abb7n2)
      abb7n13 = ((2.0_ki)*abb7n5)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd7h1
