module     p1_ddbar_neepscbar_abbrevd30h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb30n1
   complex(ki), public :: abb30n2
   complex(ki), public :: rat2d30
   complex(ki), public :: abb30n4
   complex(ki), public :: abb30n5
   complex(ki), public :: abb30n6
   complex(ki), public :: abb30n7
   complex(ki), public :: abb30n8
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   real(ki) :: t8
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t8 = TR*TR
      t3 = es345*NC*t1
      t4 = t8*t2/t3*spak2k3*spak3k5*spbk4k3*spbk6k1
      t2 = t8*t2/t3*spak2k5*spak3k5*spbk5k4*spbk6k1
      t3 = c1*i_
      t5 = t8*t3*spak2k3*spak3k5*spbk4k3*spbk6k1
      t1 = es345*t1
      t6 = t5/t1
      t3 = t8*t3*spak2k5*spak3k5*spbk5k4*spbk6k1
      t7 = t3/t1
      t1 = NC*NC*t1
      t5 = t5/t1
      t1 = t3/t1
      abb30n1 = ((16.0_ki)*(t2-t4)+(8.0_ki)*(t5+t6-(t7+t1)))
      abb30n2 = ((16.0_ki)*(t4-t2)+(8.0_ki)*(t1+t7-(t6+t5)))
      rat2d30 = 0
      rat2 = rat2 + rat2d30
      abb30n4 = -(abb30n1)
      abb30n5 = abb30n2
      abb30n6 = abb30n1
      abb30n7 = (-2.0_ki)*abb30n1
      abb30n8 = -(abb30n2)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd30h1
