module     p7_udbar_neepuubar_abbrevd57h0
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb57n1
   complex(ki), public :: abb57n2
   complex(ki), public :: abb57n3
   complex(ki), public :: abb57n4
   complex(ki), public :: abb57n5
   complex(ki), public :: abb57n6
   complex(ki), public :: abb57n7
   complex(ki), public :: abb57n8
   complex(ki), public :: abb57n9
   complex(ki), public :: abb57n10
   complex(ki), public :: abb57n11
   complex(ki), public :: abb57n12
   complex(ki), public :: abb57n13
   complex(ki), public :: abb57n14
   complex(ki), public :: abb57n15
   complex(ki), public :: abb57n16
   complex(ki), public :: abb57n17
   complex(ki), public :: abb57n18
   complex(ki), public :: abb57n19
   complex(ki), public :: abb57n20
   complex(ki), public :: abb57n21
   complex(ki), public :: abb57n22
   complex(ki), public :: abb57n23
   complex(ki), public :: abb57n24
   complex(ki), public :: abb57n25
   complex(ki), public :: abb57n26
   complex(ki), public :: abb57n27
   complex(ki), public :: abb57n28
   complex(ki), public :: rat2d57
   complex(ki), public :: abb57n30
   complex(ki), public :: abb57n31
   complex(ki), public :: abb57n32
   complex(ki), public :: abb57n33
   complex(ki), public :: abb57n34
   complex(ki), public :: abb57n35
   complex(ki), public :: abb57n36
   complex(ki), public :: abb57n37
   complex(ki), public :: abb57n38
   complex(ki), public :: abb57n39
   complex(ki), public :: abb57n40
   complex(ki), public :: abb57n41
   complex(ki), public :: abb57n42
   complex(ki), public :: abb57n43
   complex(ki), public :: abb57n44
   complex(ki), public :: abb57n45
   complex(ki), public :: abb57n46
   complex(ki), public :: abb57n47
   complex(ki), public :: abb57n48
   complex(ki), public :: abb57n49
   complex(ki), public :: abb57n50
   complex(ki), public :: abb57n51
   complex(ki), public :: abb57n52
   complex(ki), public :: abb57n53
   complex(ki), public :: abb57n54
   complex(ki), public :: abb57n55
   complex(ki), public :: abb57n56
   complex(ki), public :: abb57n57
   complex(ki), public :: abb57n58
   complex(ki), public :: abb57n59
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   real(ki) :: t23
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k2
      t23 = TR*TR
      t4 = NC*t1
      t5 = t2*spak2k3
      t6 = c1*i_
      t7 = t6*spak1k2
      t8 = NC*NC*t1
      t9 = t6*spak2k3
      t10 = NC*c2*i_
      t11 = t10*spak1k2
      t12 = t10*spak2k3
      abb57n1 = ((8.0_ki)*(t23*t3/t4*spak2k3*spbk4k1*spbk5k1-t23/t4*t5*spak2k5*s&
      &pbk5k1*spbk5k4)+(4.0_ki)*(t23*t12/t1*spak2k5*spbk5k1*spbk5k4+t23/t8*t9*sp&
      &ak2k5*spbk5k1*spbk5k4-(t23*t7/t8*spak2k3*spbk4k1*spbk5k1+t23*t11/t1*spak2&
      &k3*spbk4k1*spbk5k1)))
      abb57n2 = ((4.0_ki)*((2.0_ki)*t23*t3/t4*spbk5k1-(t23*t7/t8*spbk5k1+t23*t11&
      &/t1*spbk5k1)))
      t13 = t23*t6/t8*spak1k3*spbk5k1
      t14 = t23*(2.0_ki)*t2/t4*spak1k3*spbk5k1
      t15 = t23*t10/t1*spak1k3*spbk5k1
      abb57n3 = ((4.0_ki)*(t13+t15-t14))
      abb57n4 = ((4.0_ki)*(t14-(t15+t13)))
      t13 = t23/t8*t9*spbk4k1
      t14 = (2.0_ki)*t23/t4*t5*spbk4k1
      t15 = t23*t12/t1*spbk4k1
      abb57n5 = ((4.0_ki)*(t13+t15-t14))
      abb57n6 = ((8.0_ki)*(t14-(t15+t13)))
      t13 = t6*spak3k6
      t14 = t23*t13/t8*spbk4k1
      t15 = t2*spak3k6
      t16 = t23*(2.0_ki)*t15/t4*spbk4k1
      t17 = t10*spak3k6
      t18 = t23*t17/t1*spbk4k1
      abb57n7 = ((8.0_ki)*(t14+t18-t16))
      abb57n8 = ((4.0_ki)*(t16-(t18+t14)))
      t14 = t6*spak1k6
      t16 = t2*spak1k6
      t18 = t10*spak1k6
      abb57n9 = ((4.0_ki)*(t23*t18/t1*spbk5k1+t23*t14/t8*spbk5k1-t23*(2.0_ki)*t1&
      &6/t4*spbk5k1))
      abb57n10 = ((16.0_ki)*(-(t23/t4*t5*spak5k6*spbk5k1*spbk5k4+t23*t16/t4*spak&
      &2k3*spbk4k1*spbk5k1))+(8.0_ki)*(t23*t12/t1*spak5k6*spbk5k1*spbk5k4+t23*t1&
      &8/t1*spak2k3*spbk4k1*spbk5k1+t23*t14/t8*spak2k3*spbk4k1*spbk5k1+t23/t8*t9&
      &*spak5k6*spbk5k1*spbk5k4))
      t19 = t23/t8*t9*spbk5k1
      t20 = (2.0_ki)*t23/t4*t5*spbk5k1
      t21 = t23*t12/t1*spbk5k1
      t22 = t19+t21-t20
      abb57n11 = ((8.0_ki)*t22)
      abb57n12 = ((4.0_ki)*t22)
      abb57n13 = ((8.0_ki)*(t20-(t21+t19)))
      t19 = t2*spak2k5
      t20 = t6*spak2k5
      t21 = t10*spak2k5
      abb57n14 = ((16.0_ki)*(t23*t3/t4*spak3k6*spbk4k1*spbk5k1-t23*t19/t4*spak3k&
      &6*spbk5k1*spbk5k4)+(8.0_ki)*(t23*t21/t1*spak3k6*spbk5k1*spbk5k4+t23*t20/t&
      &8*spak3k6*spbk5k1*spbk5k4-(t23*t7/t8*spak3k6*spbk4k1*spbk5k1+t23*t11/t1*s&
      &pak3k6*spbk4k1*spbk5k1)))
      abb57n15 = ((4.0_ki)*(t23*(2.0_ki)*t19/t4*spbk5k1-(t23*t20/t8*spbk5k1+t23*&
      &t21/t1*spbk5k1)))
      t3 = t23*t6/t8*spak3k5*spbk5k1
      t7 = t23*(2.0_ki)*t2/t4*spak3k5*spbk5k1
      t11 = t23*t10/t1*spak3k5*spbk5k1
      abb57n16 = ((4.0_ki)*(t11+t3-t7))
      abb57n17 = ((4.0_ki)*(t7-(t3+t11)))
      abb57n18 = ((8.0_ki)*(-(t23*t16/t4*spak3k6*spbk4k1*spbk5k1+t23*t15/t4*spak&
      &5k6*spbk5k1*spbk5k4))+(4.0_ki)*(t23*t17/t1*spak5k6*spbk5k1*spbk5k4+t23*t1&
      &8/t1*spak3k6*spbk4k1*spbk5k1+t23*t13/t8*spak5k6*spbk5k1*spbk5k4+t23*t14/t&
      &8*spak3k6*spbk4k1*spbk5k1))
      t3 = t23*t13/t8*spbk5k1
      t7 = t23*(2.0_ki)*t15/t4*spbk5k1
      t11 = t23*t17/t1*spbk5k1
      t14 = t11+t3-t7
      abb57n19 = ((8.0_ki)*t14)
      abb57n20 = ((4.0_ki)*t14)
      abb57n21 = ((8.0_ki)*(t7-(t3+t11)))
      abb57n22 = ((4.0_ki)*(t23*(2.0_ki)*t2/t4*spak5k6*spbk5k1-(t23*t6/t8*spak5k&
      &6*spbk5k1+t23*t10/t1*spak5k6*spbk5k1)))
      t3 = t23/t8*t9*spbk5k4
      t5 = (2.0_ki)*t23/t4*t5*spbk5k4
      t7 = t23*t12/t1*spbk5k4
      abb57n23 = ((4.0_ki)*(t3+t7-t5))
      abb57n24 = ((8.0_ki)*(t5-(t7+t3)))
      t3 = t23*t13/t8*spbk5k4
      t5 = t23*(2.0_ki)*t15/t4*spbk5k4
      t7 = t23*t17/t1*spbk5k4
      abb57n25 = ((8.0_ki)*(t3+t7-t5))
      abb57n26 = ((4.0_ki)*(t5-(t7+t3)))
      t3 = t23*t6/t8
      t2 = t23*(2.0_ki)*t2/t4
      t1 = t23*t10/t1
      abb57n27 = ((8.0_ki)*(t1+t3-t2))
      abb57n28 = ((8.0_ki)*(t2-(t3+t1)))
      rat2d57 = 0
      rat2 = rat2 + rat2d57
      abb57n30 = -(abb57n1)
      abb57n31 = abb57n26
      abb57n32 = abb57n25
      abb57n33 = abb57n24
      abb57n34 = abb57n23
      abb57n35 = abb57n22
      abb57n36 = abb57n21
      abb57n37 = abb57n19
      abb57n38 = abb57n17
      abb57n39 = abb57n16
      abb57n40 = abb57n15
      abb57n41 = abb57n13
      abb57n42 = abb57n11
      abb57n43 = abb57n9
      abb57n44 = abb57n8
      abb57n45 = abb57n7
      abb57n46 = abb57n6
      abb57n47 = abb57n5
      abb57n48 = abb57n4
      abb57n49 = abb57n3
      abb57n50 = abb57n2
      abb57n51 = -(abb57n10)
      abb57n52 = -(abb57n12)
      abb57n53 = (-2.0_ki)*abb57n12
      abb57n54 = -(abb57n14)
      abb57n55 = -(abb57n18)
      abb57n56 = -(abb57n20)
      abb57n57 = (-2.0_ki)*abb57n20
      abb57n58 = -(abb57n27)
      abb57n59 = -(abb57n28)
   end subroutine
end module p7_udbar_neepuubar_abbrevd57h0
