module     p7_udbar_neepuubar_abbrevd3h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb3n1
   complex(ki), public :: abb3n2
   complex(ki), public :: abb3n3
   complex(ki), public :: abb3n4
   complex(ki), public :: abb3n5
   complex(ki), public :: abb3n6
   complex(ki), public :: abb3n7
   complex(ki), public :: abb3n8
   complex(ki), public :: abb3n9
   complex(ki), public :: abb3n10
   complex(ki), public :: abb3n11
   complex(ki), public :: abb3n12
   complex(ki), public :: abb3n13
   complex(ki), public :: abb3n14
   complex(ki), public :: abb3n15
   complex(ki), public :: abb3n16
   complex(ki), public :: abb3n17
   complex(ki), public :: abb3n18
   complex(ki), public :: abb3n19
   complex(ki), public :: abb3n20
   complex(ki), public :: abb3n21
   complex(ki), public :: abb3n22
   complex(ki), public :: abb3n23
   complex(ki), public :: abb3n24
   complex(ki), public :: abb3n25
   complex(ki), public :: abb3n26
   complex(ki), public :: abb3n27
   complex(ki), public :: abb3n28
   complex(ki), public :: abb3n29
   complex(ki), public :: abb3n30
   complex(ki), public :: rat2d3
   complex(ki), public :: abb3n32
   complex(ki), public :: abb3n33
   complex(ki), public :: abb3n34
   complex(ki), public :: abb3n35
   complex(ki), public :: abb3n36
   complex(ki), public :: abb3n37
   complex(ki), public :: abb3n38
   complex(ki), public :: abb3n39
   complex(ki), public :: abb3n40
   complex(ki), public :: abb3n41
   complex(ki), public :: abb3n42
   complex(ki), public :: abb3n43
   complex(ki), public :: abb3n44
   complex(ki), public :: abb3n45
   complex(ki), public :: abb3n46
   complex(ki), public :: abb3n47
   complex(ki), public :: abb3n48
   complex(ki), public :: abb3n49
   complex(ki), public :: abb3n50
   complex(ki), public :: abb3n51
   complex(ki), public :: abb3n52
   complex(ki), public :: abb3n53
   complex(ki), public :: abb3n54
   complex(ki), public :: abb3n55
   complex(ki), public :: abb3n56
   complex(ki), public :: abb3n57
   complex(ki), public :: abb3n58
   complex(ki), public :: abb3n59
   complex(ki), public :: abb3n60
   complex(ki), public :: abb3n61
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   real(ki) :: t34
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es12*c2*i_
      t2 = t1*spak2k3
      t34 = TR*TR
      t3 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t4 = NC*NC*t3
      t1 = t1*spak2k5
      t5 = es345*c2*i_
      t6 = t5*spak2k3
      t5 = t5*spak2k5
      t7 = es61*c2*i_
      t8 = t7*spak2k3
      t7 = t7*spak2k5
      t9 = es12*c1*i_
      t10 = t9*spak2k3
      t3 = NC*t3
      t9 = t9*spak2k5
      t11 = es345*c1*i_
      t12 = t11*spak2k3
      t11 = t11*spak2k5
      t13 = es61*c1*i_
      t14 = t13*spak2k3
      t13 = t13*spak2k5
      abb3n1 = ((4.0_ki)*(t34*t1/t4*spak3k5*spbk5k1*spbk6k4+t34*t11/t3*spak3k5*s&
      &pbk5k1*spbk6k4+t34*t12/t3*spak2k5*spbk2k1*spbk6k4+t34*t2/t4*spak2k5*spbk2&
      &k1*spbk6k4+t34/t4*t7*spak3k5*spbk5k1*spbk6k4+t34/t4*t8*spak2k5*spbk2k1*sp&
      &bk6k4-(t34/t4*t6*spak2k5*spbk2k1*spbk6k4+t34/t4*t5*spak3k5*spbk5k1*spbk6k&
      &4+t34/t3*t9*spak3k5*spbk5k1*spbk6k4+t34*t14/t3*spak2k5*spbk2k1*spbk6k4+t3&
      &4*t13/t3*spak3k5*spbk5k1*spbk6k4+t34*t10/t3*spak2k5*spbk2k1*spbk6k4)))
      t15 = c2*i_
      t16 = t15*spak2k3
      t17 = t16*spak2k5
      t18 = t17*spbk2k1
      t19 = c1*i_
      t20 = t19*spak2k3
      t21 = t20*spak2k5
      t22 = t21*spbk2k1
      abb3n2 = ((4.0_ki)*(t34*t22/t3*spbk4k2-t34*t18/t4*spbk4k2))
      t23 = t15*spak2k5
      t24 = t19*spak2k5
      abb3n3 = ((8.0_ki)*(t34*t23/t4*spbk2k1-t34*t24/t3*spbk2k1))
      t25 = t15*spak1k3
      t26 = t19*spak1k3
      abb3n4 = ((4.0_ki)*(t34*t26/t3*spbk6k4-t34*t25/t4*spbk6k4))
      t27 = t34*t16/t4*spbk4k1
      t28 = t34*t20/t3*spbk4k1
      abb3n5 = ((8.0_ki)*(t27-t28))
      t27 = t28-t27
      abb3n6 = ((4.0_ki)*t27)
      abb3n7 = ((8.0_ki)*t27)
      t27 = t34*t23/t4*spbk4k1
      t28 = t34*t24/t3*spbk4k1
      t29 = t27-t28
      abb3n8 = ((8.0_ki)*t29)
      abb3n9 = ((4.0_ki)*t29)
      abb3n10 = ((8.0_ki)*(t28-t27))
      t27 = t15*spak1k5
      t28 = t27*spak2k6
      t29 = TR*spbk6k1
      t29 = t29*t29
      t30 = t19*spak1k5
      t31 = t30*spak2k6
      abb3n11 = ((4.0_ki)*(t29/t3*t31-t28*t29/t4))
      t29 = t17*spbk4k2
      t32 = t21*spbk4k2
      abb3n12 = ((4.0_ki)*(t34*t29/t4*spbk5k1-t34*t32/t3*spbk5k1))
      t33 = TR*spak2k5
      t33 = t33*t33
      abb3n13 = ((4.0_ki)*(t34*t13/t3*spbk4k1+t34/t3*t9*spbk4k1+t34/t4*t5*spbk4k&
      &1+t19/t3*t33*spbk4k2*spbk5k1+t34*t28/t4*spbk4k1*spbk6k1+t34*t23/t4*spak2k&
      &6*spbk4k2*spbk6k1-(t34*t24/t3*spak2k6*spbk4k2*spbk6k1+t34*t31/t3*spbk4k1*&
      &spbk6k1+t15*t33/t4*spbk4k2*spbk5k1+t34/t4*t7*spbk4k1+t34*t11/t3*spbk4k1+t&
      &34*t1/t4*spbk4k1)))
      abb3n14 = ((8.0_ki)*(t34*t24/t3*spbk6k1-t34*t23/t4*spbk6k1))
      t1 = t15*spak2k6
      t5 = t1*spak3k5
      t7 = t34/t4*t5*spbk6k1*spbk6k4
      t9 = t19*spak2k6
      t11 = t9*spak3k5
      t13 = t34*t11/t3*spbk6k1*spbk6k4
      abb3n15 = ((8.0_ki)*(t7-t13))
      abb3n16 = ((8.0_ki)*(t7+t34*t22/t3*spbk6k4+t34*t24/t3*spak3k5*spbk5k1*spbk&
      &6k4-(t34*t23/t4*spak3k5*spbk5k1*spbk6k4+t34*t18/t4*spbk6k4+t13)))
      abb3n17 = ((4.0_ki)*(t13+t34*t32/t3*spbk6k1+t34*t17/t4*spbk4k1*spbk6k2+t34&
      &*t30/t3*spak2k3*spbk4k1*spbk6k1-(t34*t27/t4*spak2k3*spbk4k1*spbk6k1+t34*t&
      &21/t3*spbk4k1*spbk6k2+t34*t29/t4*spbk6k1+t7)))
      abb3n18 = ((8.0_ki)*(t13-t7))
      abb3n19 = ((4.0_ki)*(t34*t20/t3*spbk4k2-t34*t16/t4*spbk4k2))
      abb3n20 = ((4.0_ki)*(t34*t20/t3*spbk5k4-t34*t16/t4*spbk5k4))
      t7 = t34*t16/t4*spbk6k4
      t13 = t34*t20/t3*spbk6k4
      abb3n21 = ((4.0_ki)*(t7-t13))
      abb3n22 = ((8.0_ki)*(t13-t7))
      abb3n23 = ((4.0_ki)*(t34*t23/t4*spbk6k2+t34*t27/t4*spbk6k1-(t34*t30/t3*spb&
      &k6k1+t34*t24/t3*spbk6k2)))
      abb3n24 = ((4.0_ki)*(t34*t12/t3*spbk6k4+t34*t2/t4*spbk6k4+t34/t4*t8*spbk6k&
      &4+t34/t4*t5*spbk6k4*spbk6k5+t34*t25/t4*spak2k6*spbk6k1*spbk6k4-(t34*t26/t&
      &3*spak2k6*spbk6k1*spbk6k4+t34*t11/t3*spbk6k4*spbk6k5+t34/t4*t6*spbk6k4+t3&
      &4*t14/t3*spbk6k4+t34*t10/t3*spbk6k4)))
      abb3n25 = ((4.0_ki)*(t34*t23/t4*spbk5k4+t34/t3*t9*spbk6k4+t34*t19/t3*spak1&
      &k2*spbk4k1-(t34*t15/t4*spak1k2*spbk4k1+t34*t24/t3*spbk5k4+t34*t1/t4*spbk6&
      &k4)))
      t1 = t34*t15/t4*spak3k5*spbk6k4
      t2 = t34*t19/t3*spak3k5*spbk6k4
      t5 = t1-t2
      abb3n26 = ((8.0_ki)*t5)
      abb3n27 = ((4.0_ki)*t5)
      t1 = t2-t1
      abb3n28 = ((4.0_ki)*t1)
      abb3n29 = ((8.0_ki)*t1)
      abb3n30 = ((4.0_ki)*(t34*t15/t4-t34*t19/t3))
      rat2d3 = 0
      rat2 = rat2 + rat2d3
      abb3n32 = abb3n1
      abb3n33 = abb3n30
      abb3n34 = abb3n29
      abb3n35 = abb3n28
      abb3n36 = abb3n27
      abb3n37 = abb3n26
      abb3n38 = abb3n25
      abb3n39 = abb3n24
      abb3n40 = abb3n23
      abb3n41 = abb3n22
      abb3n42 = abb3n21
      abb3n43 = abb3n20
      abb3n44 = abb3n19
      abb3n45 = abb3n18
      abb3n46 = abb3n17
      abb3n47 = abb3n16
      abb3n48 = abb3n15
      abb3n49 = abb3n14
      abb3n50 = abb3n13
      abb3n51 = abb3n12
      abb3n52 = abb3n11
      abb3n53 = abb3n10
      abb3n54 = abb3n9
      abb3n55 = abb3n8
      abb3n56 = abb3n7
      abb3n57 = abb3n6
      abb3n58 = abb3n5
      abb3n59 = abb3n4
      abb3n60 = abb3n3
      abb3n61 = abb3n2
   end subroutine
end module p7_udbar_neepuubar_abbrevd3h1
