module     p7_udbar_neepuubar_abbrevd71h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb71n1
   complex(ki), public :: abb71n2
   complex(ki), public :: abb71n3
   complex(ki), public :: abb71n4
   complex(ki), public :: abb71n5
   complex(ki), public :: abb71n6
   complex(ki), public :: abb71n7
   complex(ki), public :: abb71n8
   complex(ki), public :: abb71n9
   complex(ki), public :: abb71n10
   complex(ki), public :: abb71n11
   complex(ki), public :: abb71n12
   complex(ki), public :: rat2d71
   complex(ki), public :: abb71n14
   complex(ki), public :: abb71n15
   complex(ki), public :: abb71n16
   complex(ki), public :: abb71n17
   complex(ki), public :: abb71n18
   complex(ki), public :: abb71n19
   complex(ki), public :: abb71n20
   complex(ki), public :: abb71n21
   complex(ki), public :: abb71n22
   complex(ki), public :: abb71n23
   complex(ki), public :: abb71n24
   complex(ki), public :: abb71n25
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   complex(ki) :: t52
   complex(ki) :: t53
   complex(ki) :: t54
   complex(ki) :: t55
   complex(ki) :: t56
   complex(ki) :: t57
   real(ki) :: t58
   real(ki) :: t59
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = c2*i_
      t2 = t1*spak2k5
      t3 = t2*spak3k4
      t58 = TR*TR
      t4 = t58*t3*spbk4k1*spbk6k4
      t5 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = (es12+es34-(es56+es345))*t5
      t7 = t4/t6
      t2 = t2*spak3k6
      t8 = t58*t2*spbk6k1*spbk6k4
      t9 = t8/t6
      t10 = t1*spak2k3
      t11 = t10*spak2k5*spbk4k2
      t12 = t58*t11*spbk6k1
      t13 = es234*t5
      t14 = t12/t13
      t15 = t10*spak3k5*spbk4k3
      t16 = t58*t15*spbk6k1
      t17 = t16/t13
      t59 = NC*NC
      t18 = t59*t6
      t4 = t4/t18
      t8 = t8/t18
      t19 = c1*i_
      t20 = t19*spak2k5
      t21 = t20*spak3k4
      t22 = NC*t6
      t23 = t58*t21/t22*spbk4k1*spbk6k4
      t20 = t20*spak3k6
      t24 = t58*t20/t22*spbk6k1*spbk6k4
      t25 = NC*c1*i_
      t26 = t25*spak2k5
      t27 = t26*spak3k4
      t28 = t58*t27/t6*spbk4k1*spbk6k4
      t26 = t26*spak3k6
      t29 = t58*t26/t6*spbk6k1*spbk6k4
      t30 = t59*t13
      t31 = t12/t30
      t32 = t16/t30
      t33 = t19*spak2k3
      t34 = t33*spak2k5*spbk4k2
      t35 = t58*t34*spbk6k1
      t36 = NC*t5
      t37 = es234*t36
      t38 = t35/t37
      t39 = t33*spak3k5*spbk4k3
      t40 = t58*t39*spbk6k1
      t41 = t40/t37
      t42 = t25*spak2k3
      t43 = t42*spak2k5*spbk4k2
      t44 = t58*t43/t13*spbk6k1
      t45 = t42*spak3k5*spbk4k3
      t46 = t58*t45/t13*spbk6k1
      t47 = t17+t28+t29+t31+t4+t41+t44+t8-(t9+t7+t46+t38+t32+t24+t23+t14)
      abb71n1 = ((2.0_ki)*t47)
      abb71n2 = ((8.0_ki)*(t58*t10/t6*spbk6k4-t58*t42/t6*spbk6k4))
      abb71n3 = ((4.0_ki)*(t58*t42/t6*spbk6k3+t58*t25/t6*spak2k4*spbk6k4-(t58*t1&
      &/t6*spak2k4*spbk6k4+t58*t10/t6*spbk6k3)))
      abb71n4 = ((4.0_ki)*(t58*t19/t22*spak3k4*spbk6k4-t58*t1/t18*spak3k4*spbk6k&
      &4))
      t5 = t59*t5
      t48 = es234*c2*i_*spak2k5
      t49 = es56*c2*i_
      t50 = t49*spak2k5
      t51 = es61*c2*i_
      t52 = t51*spak2k5
      t53 = es234*c1*i_*spak2k5
      t54 = es56*c1*i_
      t55 = t54*spak2k5
      t56 = es61*c1*i_
      t57 = t56*spak2k5
      t49 = t49*spak2k3
      t51 = t51*spak2k3
      t54 = t54*spak2k3
      t56 = t56*spak2k3
      abb71n5 = ((4.0_ki)*(t12/t5+t40/t36+t58*t48/t18*spak3k4*spbk4k1*spbk6k4+t5&
      &8*t48/t18*spak3k6*spbk6k1*spbk6k4+t58*t55/t22*spak3k4*spbk4k1*spbk6k4+t58&
      &*t55/t22*spak3k6*spbk6k1*spbk6k4+t58*t57/t22*spak3k4*spbk4k1*spbk6k4+t58*&
      &t57/t22*spak3k6*spbk6k1*spbk6k4+t58*t49/t30*spak3k5*spbk4k3*spbk6k1+t58*t&
      &51/t30*spak3k5*spbk4k3*spbk6k1+t58*t54/t37*spak2k5*spbk4k2*spbk6k1+t58*t5&
      &6/t37*spak2k5*spbk4k2*spbk6k1-(t58*t56/t37*spak3k5*spbk4k3*spbk6k1+t58*t5&
      &4/t37*spak3k5*spbk4k3*spbk6k1+t58*t51/t30*spak2k5*spbk4k2*spbk6k1+t58*t49&
      &/t30*spak2k5*spbk4k2*spbk6k1+t58*t53/t22*spak3k6*spbk6k1*spbk6k4+t58*t53/&
      &t22*spak3k4*spbk4k1*spbk6k4+t58*t52/t18*spak3k6*spbk6k1*spbk6k4+t58*t52/t&
      &18*spak3k4*spbk4k1*spbk6k4+t58*t50/t18*spak3k6*spbk6k1*spbk6k4+t58*t50/t1&
      &8*spak3k4*spbk4k1*spbk6k4+t35/t36+t16/t5)))
      t5 = t1*spak1k5
      t12 = t58*t5*spak3k4*spbk4k1*spbk6k4
      t16 = t58*t5*spak3k6*spbk6k1*spbk6k4
      t5 = t5*spak2k3
      t35 = t58*t5*spbk4k2*spbk6k1
      t36 = t19*spak1k5
      t40 = t25*spak1k5
      t48 = t36*spak2k3
      t49 = t40*spak2k3
      abb71n6 = ((4.0_ki)*(t12/t18+t16/t18+t35/t30+t58*t49/t13*spbk4k2*spbk6k1+t&
      &58*t40/t6*spak3k4*spbk4k1*spbk6k4+t58*t40/t6*spak3k6*spbk6k1*spbk6k4-(t58&
      &*t36/t22*spak3k6*spbk6k1*spbk6k4+t58*t36/t22*spak3k4*spbk4k1*spbk6k4+t58*&
      &t48/t37*spbk4k2*spbk6k1+t16/t6+t35/t13+t12/t6)))
      t5 = t58*t5*spbk4k3*spbk6k1
      abb71n7 = ((4.0_ki)*(t5/t13+t58*t48/t37*spbk4k3*spbk6k1-(t58*t49/t13*spbk4&
      &k3*spbk6k1+t5/t30)))
      abb71n8 = ((4.0_ki)*(t14+t23+t24+t32+t38+t46+t7+t9-(t8+t44+t41+t4+t31+t29+&
      &t28+t17)))
      abb71n9 = ((8.0_ki)*t47)
      t4 = t58*t10*spbk4k2
      abb71n10 = ((4.0_ki)*(t58*t42/t13*spbk4k2+t58*t33/t37*spbk4k2+t58*t19/t22*&
      &spak3k6*spbk6k4-(t58*t1/t18*spak3k6*spbk6k4+t4/t30+t4/t13)))
      t3 = t58*t3*spbk5k4*spbk6k4
      t2 = t58*t2*spbk6k4*spbk6k5
      t4 = t58*t11*spbk6k5
      t5 = t58*t15*spbk6k5
      t7 = t1*spak1k2
      t8 = t25*spak1k2
      abb71n11 = ((4.0_ki)*(t3/t18+t5/t30+t58*t34/t37*spbk6k5+t58*t20/t22*spbk6k&
      &4*spbk6k5-(t58*t21/t22*spbk5k4*spbk6k4+t58*t39/t37*spbk6k5+t4/t30+t2/t18)&
      &)+(2.0_ki)*(t4/t13+t2/t6+t58*t45/t13*spbk6k5+t58*t27/t6*spbk5k4*spbk6k4+t&
      &58/t13*t7*spak2k3*spbk4k2*spbk6k1+t58/t6*t7*spak3k4*spbk4k1*spbk6k4+t58/t&
      &6*t7*spak3k6*spbk6k1*spbk6k4+t58*t25/t13*spak1k3*spak2k3*spbk4k3*spbk6k1-&
      &(t58*t1/t13*spak1k3*spak2k3*spbk4k3*spbk6k1+t58/t6*t8*spak3k6*spbk6k1*spb&
      &k6k4+t58/t6*t8*spak3k4*spbk4k1*spbk6k4+t58/t13*t8*spak2k3*spbk4k2*spbk6k1&
      &+t58*t26/t6*spbk6k4*spbk6k5+t58*t43/t13*spbk6k5+t3/t6+t5/t13)))
      t2 = t58*t10*spbk4k3
      t3 = t58*t42*spbk4k3
      abb71n12 = ((4.0_ki)*(t2/t13+t2/t30+t2/t6+t58*t25/t6*spak2k6*spbk6k4-(t58*&
      &t1/t6*spak2k6*spbk6k4+t58*t33/t37*spbk4k3+t3/t6+t3/t13)))
      rat2d71 = abb71n1
      rat2 = rat2 + rat2d71
      abb71n14 = abb71n5
      abb71n15 = abb71n12
      abb71n16 = abb71n10
      abb71n17 = abb71n8
      abb71n18 = abb71n4
      abb71n19 = abb71n3
      abb71n20 = abb71n2
      abb71n21 = -(abb71n6)
      abb71n22 = -(abb71n7)
      abb71n23 = ((2.0_ki)*abb71n8)
      abb71n24 = -(abb71n9)
      abb71n25 = -(abb71n11)
   end subroutine
end module p7_udbar_neepuubar_abbrevd71h1
