module     p8_udbar_neepssbar_abbrevd30h0
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb30n1
   complex(ki), public :: abb30n2
   complex(ki), public :: abb30n3
   complex(ki), public :: abb30n4
   complex(ki), public :: abb30n5
   complex(ki), public :: abb30n6
   complex(ki), public :: abb30n7
   complex(ki), public :: abb30n8
   complex(ki), public :: abb30n9
   complex(ki), public :: abb30n10
   complex(ki), public :: abb30n11
   complex(ki), public :: abb30n12
   complex(ki), public :: abb30n13
   complex(ki), public :: abb30n14
   complex(ki), public :: abb30n15
   complex(ki), public :: rat2d30
   complex(ki), public :: abb30n17
   complex(ki), public :: abb30n18
   complex(ki), public :: abb30n19
   complex(ki), public :: abb30n20
   complex(ki), public :: abb30n21
   complex(ki), public :: abb30n22
   complex(ki), public :: abb30n23
   complex(ki), public :: abb30n24
   complex(ki), public :: abb30n25
   complex(ki), public :: abb30n26
   complex(ki), public :: abb30n27
   complex(ki), public :: abb30n28
   complex(ki), public :: abb30n29
   complex(ki), public :: abb30n30
   complex(ki), public :: abb30n31
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   real(ki) :: t17
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p8_udbar_neepssbar_config, only: deltaOS
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_model
      use p8_udbar_neepssbar_color, only: TR
      use p8_udbar_neepssbar_globalsl1, only: epspow
      implicit none
      t1 = es234*c2*i_
      t17 = TR*TR
      t2 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t3 = NC*t2
      t4 = es34*c2*i_
      t5 = es345*c2*i_
      t6 = es61*c2*i_
      t7 = es234*c1*i_
      t8 = t17*t7*spak1k3*spak2k6*spbk4k1*spbk5k1
      t7 = t17*t7*spak2k6*spak3k4*spbk4k1*spbk5k4
      t9 = es34*c1*i_
      t10 = t17*t9*spak1k3*spak2k6*spbk4k1*spbk5k1
      t9 = t17*t9*spak2k6*spak3k4*spbk4k1*spbk5k4
      t11 = es345*c1*i_
      t12 = t17*t11*spak1k3*spak2k6*spbk4k1*spbk5k1
      t11 = t17*t11*spak2k6*spak3k4*spbk4k1*spbk5k4
      t13 = es61*c1*i_
      t14 = t17*t13*spak1k3*spak2k6*spbk4k1*spbk5k1
      t13 = t17*t13*spak2k6*spak3k4*spbk4k1*spbk5k4
      t15 = NC*NC*t2
      abb30n1 = ((8.0_ki)*(t17*t1/t3*spak1k3*spak2k6*spbk4k1*spbk5k1+t17*t1/t3*s&
      &pak2k6*spak3k4*spbk4k1*spbk5k4+t17/t3*t5*spak1k3*spak2k6*spbk4k1*spbk5k1+&
      &t17/t3*t5*spak2k6*spak3k4*spbk4k1*spbk5k4-(t17/t3*t6*spak2k6*spak3k4*spbk&
      &4k1*spbk5k4+t17/t3*t6*spak1k3*spak2k6*spbk4k1*spbk5k1+t17/t3*t4*spak2k6*s&
      &pak3k4*spbk4k1*spbk5k4+t17/t3*t4*spak1k3*spak2k6*spbk4k1*spbk5k1))+(4.0_k&
      &i)*(t10/t15+t10/t2+t13/t15+t13/t2+t14/t15+t14/t2+t9/t15+t9/t2-(t8/t2+t7/t&
      &2+t8/t15+t7/t15+t12/t2+t12/t15+t11/t2+t11/t15)))
      t1 = c1*i_
      t4 = t1*spak1k3
      t5 = t4*spak2k6*spbk4k1
      t6 = t17*t5*spbk5k2
      t7 = c2*i_
      t8 = t7*spak1k3
      t9 = t8*spak2k6*spbk4k1
      abb30n2 = ((4.0_ki)*((2.0_ki)*t17/t3*t9*spbk5k2-(t6/t2+t6/t15)))
      t6 = t1*spak2k6
      t10 = t17*t6*spbk3k1
      t11 = t7*spak2k6
      abb30n3 = ((4.0_ki)*(t10/t15+t10/t2-t17*(2.0_ki)*t11/t3*spbk3k1))
      t10 = t1*spak2k3
      t12 = t17*t10*spbk4k1
      t13 = t12/t2
      t12 = t12/t15
      t14 = t7*spak2k3
      t16 = t17*(2.0_ki)*t14/t3*spbk4k1
      abb30n4 = ((8.0_ki)*(t12+t13-t16))
      abb30n5 = ((8.0_ki)*(t16-(t13+t12)))
      t12 = t17*t10*spbk3k1
      t13 = t17*t1*spak2k4*spbk4k1
      abb30n6 = ((8.0_ki)*(t17*t14/t3*spbk3k1+t17/t3*t7*spak2k4*spbk4k1)+(4.0_ki&
      &)*(-(t13/t2+t13/t15+t12/t2+t12/t15)))
      t4 = t17*t4*spak2k5*spbk4k1*spbk5k1
      t12 = t17*t1*spak2k5*spak3k4*spbk4k1*spbk5k4
      abb30n7 = ((8.0_ki)*(t17/t3*t8*spak2k5*spbk4k1*spbk5k1+t17/t3*t7*spak2k5*s&
      &pak3k4*spbk4k1*spbk5k4)+(4.0_ki)*(-(t4/t2+t4/t15+t12/t2+t12/t15)))
      t4 = t6*spak3k4*spbk4k1
      t8 = t17*t4*spbk5k2
      t12 = t11*spak3k4*spbk4k1
      abb30n8 = ((4.0_ki)*(t17*(2.0_ki)*t12/t3*spbk5k2-(t8/t2+t8/t15)))
      t5 = t17*t5*spbk5k1
      t4 = t17*t4*spbk5k4
      abb30n9 = ((8.0_ki)*(t17*t12/t3*spbk5k4+t17/t3*t9*spbk5k1)+(4.0_ki)*(-(t5/&
      &t2+t4/t2+t5/t15+t4/t15)))
      t4 = t17*t6*spbk4k1
      t5 = t4/t2
      t4 = t4/t15
      t8 = t17*(2.0_ki)*t11/t3*spbk4k1
      t9 = t4+t5-t8
      abb30n10 = ((8.0_ki)*t9)
      abb30n11 = ((4.0_ki)*t9)
      t4 = t8-(t5+t4)
      abb30n12 = ((4.0_ki)*t4)
      abb30n13 = ((8.0_ki)*t4)
      t1 = t17*t1*spak1k2*spbk4k1
      t4 = t17*t10*spbk4k3
      abb30n14 = ((8.0_ki)*(t17*t14/t3*spbk4k3+t17/t3*t7*spak1k2*spbk4k1)+(4.0_k&
      &i)*(-(t4/t2+t4/t15+t1/t2+t1/t15)))
      t1 = t17*t6*spbk4k3
      abb30n15 = ((4.0_ki)*(t1/t15+t1/t2-t17*(2.0_ki)*t11/t3*spbk4k3))
      rat2d30 = 0
      rat2 = rat2 + rat2d30
      abb30n17 = abb30n1
      abb30n18 = abb30n15
      abb30n19 = abb30n14
      abb30n20 = abb30n13
      abb30n21 = abb30n12
      abb30n22 = abb30n11
      abb30n23 = abb30n10
      abb30n24 = abb30n9
      abb30n25 = abb30n6
      abb30n26 = abb30n5
      abb30n27 = abb30n4
      abb30n28 = abb30n3
      abb30n29 = -(abb30n2)
      abb30n30 = -(abb30n7)
      abb30n31 = -(abb30n8)
   end subroutine
end module p8_udbar_neepssbar_abbrevd30h0
