module     p8_udbar_neepssbar_abbrevd8h1
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb8n1
   complex(ki), public :: abb8n2
   complex(ki), public :: abb8n3
   complex(ki), public :: abb8n4
   complex(ki), public :: abb8n5
   complex(ki), public :: abb8n6
   complex(ki), public :: abb8n7
   complex(ki), public :: abb8n8
   complex(ki), public :: abb8n9
   complex(ki), public :: abb8n10
   complex(ki), public :: abb8n11
   complex(ki), public :: rat2d8
   complex(ki), public :: abb8n13
   complex(ki), public :: abb8n14
   complex(ki), public :: abb8n15
   complex(ki), public :: abb8n16
   complex(ki), public :: abb8n17
   complex(ki), public :: abb8n18
   complex(ki), public :: abb8n19
   complex(ki), public :: abb8n20
   complex(ki), public :: abb8n21
   complex(ki), public :: abb8n22
   complex(ki), public :: abb8n23
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   real(ki) :: t26
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p8_udbar_neepssbar_config, only: deltaOS
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_model
      use p8_udbar_neepssbar_color, only: TR
      use p8_udbar_neepssbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak1k5
      t4 = t3*spak2k3
      t26 = TR*TR
      t5 = t26*t4*spbk4k1*spbk6k1
      t6 = es56*es234*t1
      t7 = t5/t6
      t8 = t2*spak2k3*spak5k6*spbk6k1
      t9 = t26*t8*spbk6k4
      t10 = t9/t6
      t11 = NC*NC*t6
      t5 = t5/t11
      t9 = t9/t11
      t12 = c2*i_
      t13 = t12*spak1k5
      t14 = t13*spak2k3
      t1 = es56*es234*NC*t1
      t15 = t26*t14/t1*spbk4k1*spbk6k1
      t16 = t12*spak2k3*spak5k6*spbk6k1
      t17 = t26*t16/t1*spbk6k4
      t18 = NC*c2*i_
      t19 = t18*spak1k5
      t20 = t19*spak2k3
      t21 = t26*t20/t6*spbk4k1*spbk6k1
      t22 = t18*spak2k3*spak5k6*spbk6k1
      t23 = t26*t22/t6*spbk6k4
      t24 = t15+t23+t7+t9-(t5+t21+t17+t10)
      abb8n1 = ((2.0_ki)*t24)
      t25 = t26*t3*spbk6k1
      abb8n2 = ((4.0_ki)*(t25/t11+t26*t19/t6*spbk6k1-(t26*t13/t1*spbk6k1+t25/t6)&
      &))
      abb8n3 = ((8.0_ki)*t24)
      abb8n4 = ((4.0_ki)*(t10+t17+t21+t5-(t9+t7+t23+t15)))
      t4 = t26*t4*spbk3k1*spbk6k1
      t5 = t26*t3*spak2k4*spbk4k1*spbk6k1
      t7 = t26*t8*spbk6k3
      t8 = t26*t2*spak2k4*spak5k6*spbk6k1*spbk6k4
      abb8n5 = ((4.0_ki)*(t4/t11+t5/t11+t7/t6+t8/t6+t26*t16/t1*spbk6k3+t26*t20/t&
      &6*spbk3k1*spbk6k1+t26*t19/t6*spak2k4*spbk4k1*spbk6k1+t26*t12/t1*spak2k4*s&
      &pak5k6*spbk6k1*spbk6k4-(t26*t18/t6*spak2k4*spak5k6*spbk6k1*spbk6k4+t26*t1&
      &3/t1*spak2k4*spbk4k1*spbk6k1+t26*t14/t1*spbk3k1*spbk6k1+t26*t22/t6*spbk6k&
      &3+t5/t6+t4/t6+t8/t11+t7/t11)))
      t4 = t2*spak2k5
      t5 = t26*t4*spbk6k1
      t7 = t5/t6
      t5 = t5/t11
      t8 = t12*spak2k5
      t9 = t26/t1*t8*spbk6k1
      t10 = t18*spak2k5
      t14 = t26*t10/t6*spbk6k1
      abb8n6 = ((16.0_ki)*(t14+t5-(t9+t7)))
      abb8n7 = ((16.0_ki)*(t7+t9-(t5+t14)))
      t5 = t26*t4*spbk5k1
      t7 = t26*t2*spak2k6*spbk6k1
      abb8n8 = ((8.0_ki)*(t5/t6+t7/t6+t26/t1*t8*spbk5k1+t26*t12/t1*spak2k6*spbk6&
      &k1-(t26*t18/t6*spak2k6*spbk6k1+t26*t10/t6*spbk5k1+t7/t11+t5/t11)))
      t3 = t26*t3*spak3k4*spbk4k1*spbk6k1
      t5 = t26*t2*spak3k4*spak5k6*spbk6k1*spbk6k4
      abb8n9 = ((4.0_ki)*(t5/t11+t3/t6+t26*t13/t1*spak3k4*spbk4k1*spbk6k1+t26*t1&
      &8/t6*spak3k4*spak5k6*spbk6k1*spbk6k4-(t26*t12/t1*spak3k4*spak5k6*spbk6k1*&
      &spbk6k4+t26*t19/t6*spak3k4*spbk4k1*spbk6k1+t5/t6+t3/t11)))
      t3 = t26*t2*spak5k6*spbk6k1
      abb8n10 = ((4.0_ki)*(t3/t11+t26*t18/t6*spak5k6*spbk6k1-(t26*t12/t1*spak5k6&
      &*spbk6k1+t3/t6)))
      t2 = t26*t2*spak1k2*spbk6k1
      t3 = t26*t4*spbk6k5
      abb8n11 = ((8.0_ki)*(t2/t6+t3/t6+t26/t1*t8*spbk6k5+t26*t12/t1*spak1k2*spbk&
      &6k1-(t26*t18/t6*spak1k2*spbk6k1+t26*t10/t6*spbk6k5+t3/t11+t2/t11)))
      rat2d8 = abb8n1
      rat2 = rat2 + rat2d8
      abb8n13 = -(abb8n5)
      abb8n14 = abb8n11
      abb8n15 = abb8n10
      abb8n16 = abb8n8
      abb8n17 = abb8n7
      abb8n18 = abb8n6
      abb8n19 = abb8n4
      abb8n20 = abb8n2
      abb8n21 = -(abb8n3)
      abb8n22 = ((2.0_ki)*abb8n4)
      abb8n23 = -(abb8n9)
   end subroutine
end module p8_udbar_neepssbar_abbrevd8h1
