module     p8_udbar_neepssbar_d3h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity1/d3h1l1d.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d3
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd3h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t33 = dotproduct(qshift, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t34 = dotproduct(k3, qshift)
      t35 = dotproduct(k4, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t36 = dotproduct(k2, qshift)
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t7 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t8 = (spvak2k3(1)*qshift(1)-spvak2k3(2)*qshift(2)-spvak2k3(3)*qshift(3)-sp&
      &vak2k3(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb3n32+t1*abb3n50+t2*abb3n52+t3*abb3n59+t33*abb3n48+t34*a&
         &bb3n51+t35*abb3n51+t36*abb3n54+t4*abb3n60+t5*abb3n61+t1*t36*abb3n49+t1&
         &*t4*abb3n41+t1*t7*abb3n47+t2*t3*abb3n38+t2*t33*abb3n55+t2*t36*abb3n46+&
         &t2*t4*abb3n37+t2*t5*abb3n36+t2*t6*abb3n34+t2*t7*abb3n42+t2*t8*abb3n44+&
         &t3*t33*abb3n62+t3*t34*abb3n39+t3*t35*abb3n39+t3*t36*abb3n40+t33*t5*abb&
         &3n64+t33*t7*abb3n57+t34*t5*abb3n35+t34*t7*abb3n43+t35*t5*abb3n35+t35*t&
         &7*abb3n43+t36*t5*abb3n33+t36*t7*abb3n45+t1*t2*t4*abb3n66)
         return
      end if
      t9 = k2(iv1)
      t10 = k3(iv1)
      t11 = k4(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak3k1(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak2k3(iv1)
      t19 = spvak2k4(iv1)
      t20 = t19*abb3n43
      t21 = t14*abb3n35
      t22 = spvak4k1(iv1)
      t23 = t16*abb3n39
      if(deg.eq.1) then
         numerator = (t10*abb3n51+t11*abb3n51+t12*abb3n53+t13*abb3n60+t14*abb3n6&
         &1+t15*abb3n52+t16*abb3n59+t17*abb3n50+t20*t34+t20*t35+t21*t34+t21*t35+&
         &t23*t34+t23*t35+t9*abb3n54+t1*t13*abb3n41+t1*t19*abb3n47+t1*t9*abb3n49&
         &+t10*t3*abb3n39+t10*t5*abb3n35+t10*t7*abb3n43+t11*t3*abb3n39+t11*t5*ab&
         &b3n35+t11*t7*abb3n43+t12*t2*abb3n56+t12*t3*abb3n63+t12*t5*abb3n65+t12*&
         &t7*abb3n58+t13*t2*abb3n37+t14*t2*abb3n36+t14*t33*abb3n64+t14*t36*abb3n&
         &33+t15*t3*abb3n38+t15*t33*abb3n55+t15*t36*abb3n46+t15*t4*abb3n37+t15*t&
         &5*abb3n36+t15*t6*abb3n34+t15*t7*abb3n42+t15*t8*abb3n44+t16*t2*abb3n38+&
         &t16*t33*abb3n62+t16*t36*abb3n40+t17*t36*abb3n49+t17*t4*abb3n41+t17*t7*&
         &abb3n47+t18*t2*abb3n44+t19*t2*abb3n42+t19*t33*abb3n57+t19*t36*abb3n45+&
         &t2*t22*abb3n34+t2*t9*abb3n46+t3*t9*abb3n40+t5*t9*abb3n33+t7*t9*abb3n45&
         &+t1*t13*t2*abb3n66+t1*t15*t4*abb3n66+t17*t2*t4*abb3n66)
         return
      end if
      t33 = d(iv1,iv2)
      t6 = spvak2k4(iv2)
      t8 = spvak3k1(iv2)
      t20 = spvak3k4(iv2)
      t21 = spvak5k1(iv2)
      t23 = spvak5k6(iv2)
      t24 = k2(iv2)
      t25 = k3(iv2)
      t26 = k4(iv2)
      t27 = qshift(iv2)
      t28 = t13*t20
      t29 = t13*t23
      t30 = spvak2k1(iv2)
      t31 = t15*t30
      t32 = t17*t30
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t33*abb3n48+t2*t33*abb3n55+t3*t33*abb3n62+t33*t5&
         &*abb3n64+t33*t7*abb3n57)+t28*abb3n37+t29*abb3n41+t31*abb3n37+t32*abb3n&
         &41+spvak2k3(iv2)*t15*abb3n44+spvak4k1(iv2)*t15*abb3n34+t1*t28*abb3n66+&
         &t1*t31*abb3n66+t10*t21*abb3n39+t10*t6*abb3n43+t10*t8*abb3n35+t11*t21*a&
         &bb3n39+t11*t6*abb3n43+t11*t8*abb3n35+t12*t20*abb3n56+t12*t21*abb3n63+t&
         &12*t6*abb3n58+t12*t8*abb3n65+t14*t20*abb3n36+t14*t24*abb3n33+t14*t25*a&
         &bb3n35+t14*t26*abb3n35+t14*t27*abb3n65+t15*t21*abb3n38+t15*t24*abb3n46&
         &+t15*t27*abb3n56+t15*t6*abb3n42+t15*t8*abb3n36+t16*t20*abb3n38+t16*t24&
         &*abb3n40+t16*t25*abb3n39+t16*t26*abb3n39+t16*t27*abb3n63+t17*t24*abb3n&
         &49+t17*t6*abb3n47+t18*t20*abb3n44+t19*t20*abb3n42+t19*t23*abb3n47+t19*&
         &t24*abb3n45+t19*t25*abb3n43+t19*t26*abb3n43+t19*t27*abb3n58+t2*t29*abb&
         &3n66+t2*t32*abb3n66+t20*t22*abb3n34+t20*t9*abb3n46+t21*t9*abb3n40+t23*&
         &t9*abb3n49+t6*t9*abb3n45+t8*t9*abb3n33+t15*t23*t4*abb3n66+t17*t20*t4*a&
         &bb3n66)
         return
      end if
      t34 = d(iv2,iv3)
      t35 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak5k6(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t33*abb3n57+spvak3k1(iv3)*t33*abb3&
         &n64+spvak5k1(iv3)*t33*abb3n62+t1*t33*abb3n55+t14*t34*abb3n64+t15*t34*a&
         &bb3n55+t16*t34*abb3n62+t19*t34*abb3n57+t20*t35*abb3n55+t21*t35*abb3n62&
         &+t35*t6*abb3n57+t35*t8*abb3n64)+t2*t28*abb3n66+t2*t31*abb3n66+t1*t13*t&
         &23*abb3n66+t1*t17*t30*abb3n66+t15*t23*t3*abb3n66+t17*t20*t3*abb3n66)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d3:
   subroutine     reconstruct_d3(coeffs)
      use p8_udbar_neepssbar_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_3:
      coeffs%coeffs_3%c0 = derivative(czip)
      coeffs%coeffs_3%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_3%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_3%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_3%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_3%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_3%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_3%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_3%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_3%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_3%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_3%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_3%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_3%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_3%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_3%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_3%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_3%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_3%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_3%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_3%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_3%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_3%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_3%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_3%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_3%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_3%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_3%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_3%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_3:
   end subroutine reconstruct_d3
!---#] subroutine reconstruct_d3:
end module p8_udbar_neepssbar_d3h1l1d
