module     p9_udbar_neepgg_abbrevd35h0
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb35n1
   complex(ki), public :: abb35n2
   complex(ki), public :: abb35n3
   complex(ki), public :: abb35n4
   complex(ki), public :: abb35n5
   complex(ki), public :: abb35n6
   complex(ki), public :: abb35n7
   complex(ki), public :: abb35n8
   complex(ki), public :: abb35n9
   complex(ki), public :: abb35n10
   complex(ki), public :: rat2d35
   complex(ki), public :: abb35n12
   complex(ki), public :: abb35n13
   complex(ki), public :: abb35n14
   complex(ki), public :: abb35n15
   complex(ki), public :: abb35n16
   complex(ki), public :: abb35n17
   complex(ki), public :: abb35n18
   complex(ki), public :: abb35n19
   complex(ki), public :: abb35n20
   complex(ki), public :: abb35n21
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1
      t3 = t2*i_
      t4 = t3*spak2k3
      t5 = t4*spak2k6
      t6 = t5*spbk4k2
      t7 = t6*spbk6k1
      t8 = NC*t1
      t9 = es234*t8
      t10 = spak5k6*spak5k6
      t11 = t10*t9
      t12 = t7/t11
      t4 = t4*spak3k6*spbk4k3
      t13 = t4*spbk6k1
      t11 = t13/t11
      t8 = es61*t10*t8
      t7 = t7/t8
      t8 = t13/t8
      t13 = NC*TR*c1
      t14 = t13*i_
      t15 = t14*spak2k3
      t16 = t15*spak2k6
      t17 = t16*spbk4k2
      t18 = t17*spbk6k1
      t19 = es234*t1
      t20 = t10*t19
      t21 = t18/t20
      t15 = t15*spak3k6*spbk4k3
      t22 = t15*spbk6k1
      t23 = t22/t20
      t24 = es61*t1*t10
      t25 = t18/t24
      t24 = t22/t24
      t26 = t5*spbk5k2
      t27 = (es34+es61-(es345+es234))*t1
      t28 = es61*NC*t27
      t29 = t28*spak5k6
      t30 = t26/t29*spbk6k1*spbk6k4
      t31 = t16*spbk5k2
      t32 = t31*spbk6k1*spbk6k4
      t33 = es61*t27
      t34 = t32/(t33*spak5k6)
      t28 = t10*t28
      t3 = t3/t28*spak1k5*spak2k3*spak2k6*spbk4k1*spbk5k2*spbk6k1
      t14 = t14*spak1k5*spak2k3*spak2k6*spbk4k1*spbk5k2*spbk6k1
      t33 = t10*t33
      t35 = t14/t33
      abb35n1 = ((2.0_ki)*(t11+t21+t24+t30+t35+t7-(t8+t34+t3+t25+t23+t12)))
      t1 = t1*t10
      t36 = es56*t13*i_*spak2k3
      t13 = es61*t13*i_*spak2k3
      t37 = t10*t27
      abb35n2 = ((2.0_ki)*(t22/t1+t14/t37+t13/t20*spak2k6*spbk4k2*spbk6k1+t36/t2&
      &0*spak3k6*spbk4k3*spbk6k1-(t36/t20*spak2k6*spbk4k2*spbk6k1+t13/t20*spak3k&
      &6*spbk4k3*spbk6k1+t18/t1+(2.0_ki)/(t27*spak5k6)*t32)))
      t1 = t16*spbk4k1*spbk5k2
      t13 = t17*spbk5k1
      t14 = t15*spbk5k1
      abb35n3 = ((2.0_ki)*(t1/t37+t13/t20-t14/t20))
      t16 = t21+t24-(t25+t23)
      abb35n4 = ((8.0_ki)*(t16+t35-t34))
      t18 = t31*spbk6k4
      t17 = t17*spbk6k5
      t15 = t15*spbk6k5
      abb35n5 = ((2.0_ki)*(t15/t20-(t18/t37+t17/t20)))
      t2 = es56*t2*i_*spak2k3
      t9 = es61*t9
      t20 = t10*t9
      abb35n6 = ((8.0_ki)*(t16+t30+t35+t2/t20*spak2k6*spbk4k2*spbk6k1-(t2/t20*sp&
      &ak3k6*spbk4k3*spbk6k1+t34)))
      abb35n7 = ((4.0_ki)*(t12+t23+t25+t3+t34+t8-(t7+t35+t30+t24+t21+t11)))
      t2 = t5*spbk4k1*spbk5k2
      t3 = t6*spbk5k1
      t5 = t9*spak5k6
      t7 = t4*spbk5k1
      abb35n8 = ((4.0_ki)*(t2/t29*spbk6k1+t3/t5*spbk6k1-t7/t5*spbk6k1))
      t5 = es61*t10*t19
      abb35n9 = ((8.0_ki)*(t14/t5+t7/t20-(t3/t20+t2/t28+t13/t5+t1/t33)))
      abb35n10 = ((4.0_ki)*(t15/t5+t4/t20*spbk6k5-(t26/t28*spbk6k4+t6/t20*spbk6k&
      &5+t18/t33+t17/t5)))
      rat2d35 = abb35n1
      rat2 = rat2 + rat2d35
      abb35n12 = abb35n2
      abb35n13 = abb35n10
      abb35n14 = abb35n9
      abb35n15 = abb35n7
      abb35n16 = -(abb35n3)
      abb35n17 = -(abb35n4)
      abb35n18 = -(abb35n5)
      abb35n19 = -(abb35n6)
      abb35n20 = ((2.0_ki)*abb35n7)
      abb35n21 = -(abb35n8)
   end subroutine
end module p9_udbar_neepgg_abbrevd35h0
