module     p9_udbar_neepgg_d103h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d103h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d103
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd103h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t2 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t41 = dotproduct(qshift, qshift)
      t42 = dotproduct(k5, qshift)
      t43 = dotproduct(k1, qshift)
      t44 = dotproduct(k6, qshift)
      t5 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t6 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t7 = (spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-sp&
      &vak3k5(4)*qshift(4))
      t8 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t9 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t10 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-s&
      &pvak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb103n41+t1*abb103n104+t2*abb103n105+t3*abb103n107+t4*abb&
         &103n108+t41*abb103n59+t42*abb103n80+t43*abb103n81+t44*abb103n90+t5*abb&
         &103n91+t6*abb103n92+t1*t41*abb103n111+t1*t42*abb103n56+t1*t5*abb103n49&
         &+t10*t41*abb103n84+t10*t43*abb103n77+t2*t41*abb103n119+t2*t42*abb103n5&
         &0+t2*t5*abb103n48+t3*t41*abb103n127+t3*t42*abb103n46+t3*t44*abb103n63+&
         &t3*t6*abb103n62+t4*t41*abb103n130+t4*t42*abb103n43+t4*t5*abb103n64+t41&
         &*t5*abb103n96+t41*t6*abb103n115+t41*t9*abb103n87+t42*t6*abb103n69+t43*&
         &t5*abb103n66+t43*t6*abb103n70+t43*t9*abb103n74+t44*t5*abb103n67+t5*t6*&
         &abb103n65+t6*t7*abb103n52+t6*t8*abb103n54+t10*t5*t6*abb103n124+t5*t6*t&
         &9*abb103n133)
         return
      end if
      t11 = k1(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak2k6(iv1)
      t16 = spvak3k6(iv1)
      t17 = spvak5k1(iv1)
      t18 = spvak5k6(iv1)
      t19 = spvak6k1(iv1)
      t20 = spvak6k5(iv1)
      t21 = spvak2k1(iv1)
      t22 = spvak2k5(iv1)
      t23 = spvak3k1(iv1)
      t24 = spvak3k5(iv1)
      if(deg.eq.1) then
         numerator = (t11*abb103n78+t12*abb103n79+t13*abb103n73+t14*abb103n106+t&
         &15*abb103n61+t16*abb103n60+t17*abb103n57+t18*abb103n71+t19*abb103n58+t&
         &20*abb103n72+t1*t12*abb103n109+t1*t14*abb103n110+t1*t20*abb103n122+t10&
         &*t11*abb103n82+t10*t14*abb103n83+t11*t5*abb103n99+t11*t6*abb103n93+t11&
         &*t9*abb103n89+t12*t2*abb103n121+t12*t3*abb103n125+t12*t4*abb103n132+t1&
         &2*t6*abb103n94+t13*t3*abb103n102+t13*t5*abb103n98+t14*t2*abb103n118+t1&
         &4*t3*abb103n126+t14*t4*abb103n129+t14*t5*abb103n95+t14*t6*abb103n114+t&
         &14*t9*abb103n86+t15*t41*abb103n55+t15*t42*abb103n109+t15*t5*abb103n122&
         &+t16*t41*abb103n51+t16*t42*abb103n121+t16*t5*abb103n123+t17*t41*abb103&
         &n44+t17*t42*abb103n132+t17*t5*abb103n101+t18*t3*abb103n103+t18*t41*abb&
         &103n53+t18*t42*abb103n94+t18*t43*abb103n93+t18*t5*abb103n100+t18*t7*ab&
         &b103n117+t18*t8*abb103n113+t19*t41*abb103n45+t19*t42*abb103n125+t19*t4&
         &4*abb103n102+t19*t6*abb103n103+t2*t20*abb103n123+t20*t4*abb103n101+t20&
         &*t41*abb103n68+t20*t43*abb103n99+t20*t44*abb103n98+t20*t6*abb103n100+t&
         &21*t41*abb103n76+t21*t43*abb103n82+t22*t6*abb103n113+t23*t41*abb103n75&
         &+t23*t43*abb103n89+t24*t6*abb103n117+t10*t18*t5*abb103n47+t10*t20*t6*a&
         &bb103n47+t18*t5*t9*abb103n42+t20*t6*t9*abb103n42+t21*t5*t6*abb103n47+t&
         &23*t5*t6*abb103n42)
         return
      end if
      t41 = d(iv1,iv2)
      t7 = spvak2k1(iv2)
      t8 = spvak3k1(iv2)
      t25 = spvak5k6(iv2)
      t26 = spvak6k5(iv2)
      t27 = k1(iv2)
      t28 = spvak2k6(iv2)
      t29 = spvak3k6(iv2)
      t30 = spvak5k1(iv2)
      t31 = spvak6k1(iv2)
      t32 = k5(iv2)
      t33 = k6(iv2)
      t34 = qshift(iv2)
      t35 = t18*t26
      t36 = t20*t25
      t37 = t21*t25
      t38 = t18*t7
      t39 = t23*t25
      t40 = t18*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t41*abb103n59+t1*t41*abb103n111+t10*t41*abb103n8&
         &4+t2*t41*abb103n119+t3*t41*abb103n127+t4*t41*abb103n130+t41*t5*abb103n&
         &96+t41*t6*abb103n115+t41*t9*abb103n87)+t35*abb103n65+t36*abb103n65+spv&
         &ak2k5(iv2)*t18*abb103n54+spvak3k5(iv2)*t18*abb103n52+t10*t35*abb103n12&
         &4+t10*t36*abb103n124+t11*t25*abb103n70+t11*t26*abb103n66+t11*t7*abb103&
         &n77+t11*t8*abb103n74+t12*t25*abb103n69+t12*t28*abb103n56+t12*t29*abb10&
         &3n50+t12*t30*abb103n43+t12*t31*abb103n46+t13*t26*abb103n67+t13*t31*abb&
         &103n63+t14*t25*abb103n116+t14*t26*abb103n97+t14*t28*abb103n112+t14*t29&
         &*abb103n120+t14*t30*abb103n131+t14*t31*abb103n128+t14*t7*abb103n85+t14&
         &*t8*abb103n88+t15*t26*abb103n49+t15*t32*abb103n56+t15*t34*abb103n112+t&
         &16*t26*abb103n48+t16*t32*abb103n50+t16*t34*abb103n120+t17*t26*abb103n6&
         &4+t17*t32*abb103n43+t17*t34*abb103n131+t18*t27*abb103n70+t18*t31*abb10&
         &3n62+t18*t32*abb103n69+t18*t34*abb103n116+t19*t25*abb103n62+t19*t32*ab&
         &b103n46+t19*t33*abb103n63+t19*t34*abb103n128+t20*t27*abb103n66+t20*t28&
         &*abb103n49+t20*t29*abb103n48+t20*t30*abb103n64+t20*t33*abb103n67+t20*t&
         &34*abb103n97+t21*t27*abb103n77+t21*t34*abb103n85+t22*t25*abb103n54+t23&
         &*t27*abb103n74+t23*t34*abb103n88+t24*t25*abb103n52+t35*t9*abb103n133+t&
         &36*t9*abb103n133+t37*t5*abb103n124+t38*t5*abb103n124+t39*t5*abb103n133&
         &+t40*t5*abb103n133+t20*t6*t7*abb103n124+t20*t6*t8*abb103n133+t21*t26*t&
         &6*abb103n124+t23*t26*t6*abb103n133)
         return
      end if
      t42 = d(iv2,iv3)
      t43 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t2 = spvak3k1(iv3)
      t3 = spvak5k6(iv3)
      t4 = spvak6k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k6(iv3)*t41*abb103n55+spvak3k6(iv3)*t41*ab&
         &b103n51+spvak5k1(iv3)*t41*abb103n44+spvak6k1(iv3)*t41*abb103n45+t1*t41&
         &*abb103n76+t15*t42*abb103n55+t16*t42*abb103n51+t17*t42*abb103n44+t18*t&
         &42*abb103n53+t19*t42*abb103n45+t2*t41*abb103n75+t20*t42*abb103n68+t21*&
         &t42*abb103n76+t23*t42*abb103n75+t25*t43*abb103n53+t26*t43*abb103n68+t2&
         &8*t43*abb103n55+t29*t43*abb103n51+t3*t41*abb103n53+t30*t43*abb103n44+t&
         &31*t43*abb103n45+t4*t41*abb103n68+t43*t7*abb103n76+t43*t8*abb103n75)+t&
         &37*t4*abb103n47+t38*t4*abb103n47+t39*t4*abb103n42+t4*t40*abb103n42+t1*&
         &t18*t26*abb103n47+t1*t20*t25*abb103n47+t18*t2*t26*abb103n42+t2*t20*t25&
         &*abb103n42+t20*t3*t7*abb103n47+t20*t3*t8*abb103n42+t21*t26*t3*abb103n4&
         &7+t23*t26*t3*abb103n42)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d103:
   subroutine     reconstruct_d103(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_103:
      coeffs%coeffs_103%c0 = derivative(czip)
      coeffs%coeffs_103%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_103%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_103%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_103%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_103%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_103%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_103%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_103%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_103%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_103%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_103%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_103%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_103%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_103%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_103%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_103%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_103%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_103%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_103%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_103%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_103%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_103%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_103%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_103%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_103%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_103%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_103%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_103%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_103%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_103%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_103%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_103%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_103%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_103%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_103:
   end subroutine reconstruct_d103
!---#] subroutine reconstruct_d103:
end module p9_udbar_neepgg_d103h0l1d
