module     p9_udbar_neepgg_d105h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d105h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d105
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd105h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t2 = (spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-sp&
      &vak3k5(4)*qshift(4))
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t41 = dotproduct(qshift, qshift)
      t42 = dotproduct(k6, qshift)
      t43 = dotproduct(k1, qshift)
      t44 = dotproduct(k5, qshift)
      t5 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t6 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t7 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t9 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t10 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-s&
      &pvak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb105n41+t1*abb105n105+t2*abb105n106+t3*abb105n107+t4*abb&
         &105n108+t41*abb105n61+t42*abb105n80+t43*abb105n81+t44*abb105n90+t5*abb&
         &105n91+t6*abb105n92+t1*t41*abb105n113+t1*t42*abb105n52+t1*t6*abb105n56&
         &+t10*t41*abb105n84+t10*t43*abb105n77+t2*t41*abb105n121+t2*t42*abb105n5&
         &0+t2*t6*abb105n55+t3*t41*abb105n127+t3*t42*abb105n46+t3*t6*abb105n62+t&
         &4*t41*abb105n130+t4*t42*abb105n43+t4*t44*abb105n63+t4*t5*abb105n64+t41&
         &*t5*abb105n117+t41*t6*abb105n94+t41*t9*abb105n87+t42*t5*abb105n66+t43*&
         &t5*abb105n67+t43*t6*abb105n68+t43*t9*abb105n74+t44*t6*abb105n69+t5*t6*&
         &abb105n65+t5*t7*abb105n48+t5*t8*abb105n54+t10*t5*t6*abb105n124+t5*t6*t&
         &9*abb105n133)
         return
      end if
      t11 = k1(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak2k5(iv1)
      t16 = spvak3k5(iv1)
      t17 = spvak5k1(iv1)
      t18 = spvak5k6(iv1)
      t19 = spvak6k1(iv1)
      t20 = spvak6k5(iv1)
      t21 = spvak2k1(iv1)
      t22 = spvak2k6(iv1)
      t23 = spvak3k1(iv1)
      t24 = spvak3k6(iv1)
      if(deg.eq.1) then
         numerator = (t11*abb105n78+t12*abb105n73+t13*abb105n79+t14*abb105n104+t&
         &15*abb105n60+t16*abb105n59+t17*abb105n57+t18*abb105n71+t19*abb105n58+t&
         &20*abb105n72+t1*t13*abb105n115+t1*t14*abb105n112+t1*t18*abb105n109+t10&
         &*t11*abb105n82+t10*t14*abb105n83+t11*t5*abb105n98+t11*t6*abb105n97+t11&
         &*t9*abb105n89+t12*t4*abb105n102+t12*t6*abb105n96+t13*t2*abb105n119+t13&
         &*t3*abb105n125+t13*t4*abb105n132+t13*t5*abb105n99+t14*t2*abb105n120+t1&
         &4*t3*abb105n126+t14*t4*abb105n129+t14*t5*abb105n116+t14*t6*abb105n93+t&
         &14*t9*abb105n86+t15*t41*abb105n53+t15*t42*abb105n115+t15*t6*abb105n109&
         &+t16*t41*abb105n49+t16*t42*abb105n119+t16*t6*abb105n110+t17*t41*abb105&
         &n44+t17*t42*abb105n132+t17*t44*abb105n102+t17*t5*abb105n101+t18*t2*abb&
         &105n110+t18*t3*abb105n103+t18*t41*abb105n70+t18*t43*abb105n97+t18*t44*&
         &abb105n96+t18*t5*abb105n100+t19*t41*abb105n45+t19*t42*abb105n125+t19*t&
         &6*abb105n103+t20*t4*abb105n101+t20*t41*abb105n51+t20*t42*abb105n99+t20&
         &*t43*abb105n98+t20*t6*abb105n100+t20*t7*abb105n123+t20*t8*abb105n111+t&
         &21*t41*abb105n76+t21*t43*abb105n82+t22*t5*abb105n111+t23*t41*abb105n75&
         &+t23*t43*abb105n89+t24*t5*abb105n123+t10*t18*t5*abb105n47+t10*t20*t6*a&
         &bb105n47+t18*t5*t9*abb105n42+t20*t6*t9*abb105n42+t21*t5*t6*abb105n47+t&
         &23*t5*t6*abb105n42)
         return
      end if
      t41 = d(iv1,iv2)
      t7 = spvak2k1(iv2)
      t8 = spvak3k1(iv2)
      t25 = spvak5k6(iv2)
      t26 = spvak6k5(iv2)
      t27 = k1(iv2)
      t28 = spvak5k1(iv2)
      t29 = k5(iv2)
      t30 = spvak2k5(iv2)
      t31 = spvak3k5(iv2)
      t32 = spvak6k1(iv2)
      t33 = k6(iv2)
      t34 = qshift(iv2)
      t35 = t18*t26
      t36 = t20*t25
      t37 = t21*t25
      t38 = t18*t7
      t39 = t23*t25
      t40 = t18*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t41*abb105n61+t1*t41*abb105n113+t10*t41*abb105n8&
         &4+t2*t41*abb105n121+t3*t41*abb105n127+t4*t41*abb105n130+t41*t5*abb105n&
         &117+t41*t6*abb105n94+t41*t9*abb105n87)+t35*abb105n65+t36*abb105n65+spv&
         &ak2k6(iv2)*t20*abb105n54+spvak3k6(iv2)*t20*abb105n48+t10*t35*abb105n12&
         &4+t10*t36*abb105n124+t11*t25*abb105n68+t11*t26*abb105n67+t11*t7*abb105&
         &n77+t11*t8*abb105n74+t12*t25*abb105n69+t12*t28*abb105n63+t13*t26*abb10&
         &5n66+t13*t28*abb105n43+t13*t30*abb105n52+t13*t31*abb105n50+t13*t32*abb&
         &105n46+t14*t25*abb105n95+t14*t26*abb105n118+t14*t28*abb105n131+t14*t30&
         &*abb105n114+t14*t31*abb105n122+t14*t32*abb105n128+t14*t7*abb105n85+t14&
         &*t8*abb105n88+t15*t25*abb105n56+t15*t33*abb105n52+t15*t34*abb105n114+t&
         &16*t25*abb105n55+t16*t33*abb105n50+t16*t34*abb105n122+t17*t26*abb105n6&
         &4+t17*t29*abb105n63+t17*t33*abb105n43+t17*t34*abb105n131+t18*t27*abb10&
         &5n68+t18*t29*abb105n69+t18*t30*abb105n56+t18*t31*abb105n55+t18*t32*abb&
         &105n62+t18*t34*abb105n95+t19*t25*abb105n62+t19*t33*abb105n46+t19*t34*a&
         &bb105n128+t20*t27*abb105n67+t20*t28*abb105n64+t20*t33*abb105n66+t20*t3&
         &4*abb105n118+t21*t27*abb105n77+t21*t34*abb105n85+t22*t26*abb105n54+t23&
         &*t27*abb105n74+t23*t34*abb105n88+t24*t26*abb105n48+t35*t9*abb105n133+t&
         &36*t9*abb105n133+t37*t5*abb105n124+t38*t5*abb105n124+t39*t5*abb105n133&
         &+t40*t5*abb105n133+t20*t6*t7*abb105n124+t20*t6*t8*abb105n133+t21*t26*t&
         &6*abb105n124+t23*t26*t6*abb105n133)
         return
      end if
      t42 = d(iv2,iv3)
      t43 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t2 = spvak3k1(iv3)
      t3 = spvak5k6(iv3)
      t4 = spvak6k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k5(iv3)*t41*abb105n53+spvak3k5(iv3)*t41*ab&
         &b105n49+spvak5k1(iv3)*t41*abb105n44+spvak6k1(iv3)*t41*abb105n45+t1*t41&
         &*abb105n76+t15*t42*abb105n53+t16*t42*abb105n49+t17*t42*abb105n44+t18*t&
         &42*abb105n70+t19*t42*abb105n45+t2*t41*abb105n75+t20*t42*abb105n51+t21*&
         &t42*abb105n76+t23*t42*abb105n75+t25*t43*abb105n70+t26*t43*abb105n51+t2&
         &8*t43*abb105n44+t3*t41*abb105n70+t30*t43*abb105n53+t31*t43*abb105n49+t&
         &32*t43*abb105n45+t4*t41*abb105n51+t43*t7*abb105n76+t43*t8*abb105n75)+t&
         &37*t4*abb105n47+t38*t4*abb105n47+t39*t4*abb105n42+t4*t40*abb105n42+t1*&
         &t18*t26*abb105n47+t1*t20*t25*abb105n47+t18*t2*t26*abb105n42+t2*t20*t25&
         &*abb105n42+t20*t3*t7*abb105n47+t20*t3*t8*abb105n42+t21*t26*t3*abb105n4&
         &7+t23*t26*t3*abb105n42)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d105:
   subroutine     reconstruct_d105(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_105:
      coeffs%coeffs_105%c0 = derivative(czip)
      coeffs%coeffs_105%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_105%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_105%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_105%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_105%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_105%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_105%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_105%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_105%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_105%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_105%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_105%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_105%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_105%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_105%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_105%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_105%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_105%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_105%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_105%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_105%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_105%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_105%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_105%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_105%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_105%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_105%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_105%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_105%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_105%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_105%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_105%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_105:
   end subroutine reconstruct_d105
!---#] subroutine reconstruct_d105:
end module p9_udbar_neepgg_d105h0l1d
