module     p9_udbar_neepgg_abbrevd41h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb41n1
   complex(ki), public :: abb41n2
   complex(ki), public :: abb41n3
   complex(ki), public :: abb41n4
   complex(ki), public :: abb41n5
   complex(ki), public :: abb41n6
   complex(ki), public :: rat2d41
   complex(ki), public :: abb41n8
   complex(ki), public :: abb41n9
   complex(ki), public :: abb41n10
   complex(ki), public :: abb41n11
   complex(ki), public :: abb41n12
   complex(ki), public :: abb41n13
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   real(ki) :: t27
   real(ki) :: t28
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t27 = es34+es56-(es234+es12)
      t2 = TR*c2*i_
      t3 = spak2k5*spak2k5
      t4 = t27*(es345-(es61+es12))*t1
      t5 = NC*t4*spak5k6
      t6 = t2*t3/t5*spak3k5*spbk4k1*spbk6k2
      t28 = NC*TR
      t7 = t28*c2*i_
      t4 = t4*spak5k6
      t8 = t3/t4*t7*spak3k5*spbk4k1*spbk6k2
      t9 = TR*c1*i_
      t1 = t27*(es34+es61-(es345+es234))*t1
      t10 = NC*t1*spak5k6
      t11 = t3/t10*t9*spak3k5*spbk4k1*spbk6k2
      t12 = t28*c1*i_
      t1 = t1*spak5k6
      t13 = t12/t1*t3*spak3k5*spbk4k1*spbk6k2
      t14 = spak2k5*spbk6k2
      t14 = t14*t14
      t15 = t5*spbk6k5
      t16 = t14/t15*t2*spak2k3*spbk4k1
      t17 = t4*spbk6k5
      t18 = t14/t17*t7*spak2k3*spbk4k1
      t19 = t10*spbk6k5
      t20 = t14/t19*t9*spak2k3*spbk4k1
      t21 = t1*spbk6k5
      t22 = t12*t14/t21*spak2k3*spbk4k1
      abb41n1 = ((2.0_ki)*(t11+t16+t20+t6-(t8+t22+t18+t13)))
      t23 = t2*spak3k4*spbk4k1
      t24 = t7*spak3k4*spbk4k1
      t25 = t9*spak3k4*spbk4k1
      t26 = t12*spak3k4*spbk4k1
      abb41n2 = ((4.0_ki)*(t14/t17*t24+t14/t21*t26-(t14/t19*t25+t14/t15*t23)))
      abb41n3 = ((4.0_ki)*(t25/t10*t3*spbk6k2+t23*t3/t5*spbk6k2-(t24*t3/t4*spbk6&
      &k2+t26/t1*t3*spbk6k2)))
      abb41n4 = ((4.0_ki)*(t13+t18+t22+t8-(t6+t20+t16+t11)))
      abb41n5 = ((4.0_ki)*(t14/t15*t2+t14/t19*t9-(t14/t17*t7+t12*t14/t21)))
      abb41n6 = ((4.0_ki)*(t12/t1*t3*spbk6k2+t3/t4*t7*spbk6k2-(t2*t3/t5*spbk6k2+&
      &t3/t10*t9*spbk6k2)))
      rat2d41 = abb41n1
      rat2 = rat2 + rat2d41
      abb41n8 = -(abb41n3)
      abb41n9 = abb41n6
      abb41n10 = abb41n5
      abb41n11 = abb41n4
      abb41n12 = -(abb41n2)
      abb41n13 = ((2.0_ki)*abb41n4)
   end subroutine
end module p9_udbar_neepgg_abbrevd41h1
