module     p9_udbar_neepgg_abbrevd95h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb95n1
   complex(ki), public :: abb95n2
   complex(ki), public :: abb95n3
   complex(ki), public :: abb95n4
   complex(ki), public :: abb95n5
   complex(ki), public :: abb95n6
   complex(ki), public :: abb95n7
   complex(ki), public :: abb95n8
   complex(ki), public :: abb95n9
   complex(ki), public :: abb95n10
   complex(ki), public :: abb95n11
   complex(ki), public :: abb95n12
   complex(ki), public :: abb95n13
   complex(ki), public :: abb95n14
   complex(ki), public :: abb95n15
   complex(ki), public :: abb95n16
   complex(ki), public :: abb95n17
   complex(ki), public :: rat2d95
   complex(ki), public :: abb95n19
   complex(ki), public :: abb95n20
   complex(ki), public :: abb95n21
   complex(ki), public :: abb95n22
   complex(ki), public :: abb95n23
   complex(ki), public :: abb95n24
   complex(ki), public :: abb95n25
   complex(ki), public :: abb95n26
   complex(ki), public :: abb95n27
   complex(ki), public :: abb95n28
   complex(ki), public :: abb95n29
   complex(ki), public :: abb95n30
   complex(ki), public :: abb95n31
   complex(ki), public :: abb95n32
   complex(ki), public :: abb95n33
   complex(ki), public :: abb95n34
   complex(ki), public :: abb95n35
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = TR*c3
      t2 = es234*t1*i_
      t3 = t2*spak1k3
      t4 = spak2k5*spak2k5
      t5 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t6 = t5*spak5k6
      t7 = t6*spbk6k5
      t8 = es34*t1*i_
      t9 = t8*spak1k3
      t10 = es345*t1*i_
      t11 = t10*spak1k3
      t12 = es61*t1*i_
      t13 = t12*spak1k3
      t14 = t1*i_
      t15 = t14*spak1k3
      t16 = t15*spak2k5
      t17 = t16*spbk4k1
      t18 = spak2k5*spbk6k2
      t18 = t18*t18
      t19 = t14*spak2k5
      t20 = t19*spak3k4*spbk4k1
      abb95n1 = ((2.0_ki)*(-(t18*t20/t7*spbk5k4+t17*t18/t7*spbk5k1))+(4.0_ki)*(t&
      &11*t4/t7*spbk4k1*spbk6k1*spbk6k2+t3*t4/t7*spbk4k1*spbk6k1*spbk6k2+t10*t4/&
      &t7*spak3k4*spbk4k1*spbk6k2*spbk6k4+t2*t4/t7*spak3k4*spbk4k1*spbk6k2*spbk6&
      &k4-(t4/t7*t8*spak3k4*spbk4k1*spbk6k2*spbk6k4+t12*t4/t7*spak3k4*spbk4k1*sp&
      &bk6k2*spbk6k4+t4/t7*t9*spbk4k1*spbk6k1*spbk6k2+t13*t4/t7*spbk4k1*spbk6k1*&
      &spbk6k2)))
      abb95n2 = ((4.0_ki)*t17/t7*spbk6k2)
      t21 = t14*spak3k4*spbk4k1
      t22 = t15*spbk4k1
      t1 = es56*t1*i_
      abb95n3 = ((2.0_ki)*(t1/t7*spak1k3*spak2k5*spbk4k1*spbk6k1+t1/t7*spak2k5*s&
      &pak3k4*spbk4k1*spbk6k4)+(6.0_ki)*(t21*t4/t6*spbk4k2+t21*t4/t7*spbk5k4*spb&
      &k6k2+t22*t4/t7*spbk5k1*spbk6k2-t15*t4/t6*spbk2k1*spbk4k1)+(8.0_ki)*(t13/t&
      &7*spak2k5*spbk4k1*spbk6k1+t9/t7*spak2k5*spbk4k1*spbk6k1+t12/t7*spak2k5*sp&
      &ak3k4*spbk4k1*spbk6k4+t8/t7*spak2k5*spak3k4*spbk4k1*spbk6k4-(t2/t7*spak2k&
      &5*spak3k4*spbk4k1*spbk6k4+t10/t7*spak2k5*spak3k4*spbk4k1*spbk6k4+t3/t7*sp&
      &ak2k5*spbk4k1*spbk6k1+t11/t7*spak2k5*spbk4k1*spbk6k1)))
      t1 = t22*spbk6k1
      t2 = t1*t4/t7*spbk6k2
      t3 = t21*t4/t7*spbk6k2*spbk6k4
      abb95n4 = ((8.0_ki)*(t2+t3))
      abb95n5 = ((4.0_ki)*(-(t3+t2)))
      t2 = t14*spak3k5
      t3 = (3.0_ki)*t2*t4/t6*spbk4k1*spbk6k2
      t8 = t14*spak2k3
      t9 = t18/t7*t8*spbk4k1
      abb95n6 = ((4.0_ki)*(t3-t9))
      abb95n7 = ((4.0_ki)*(t9-t3))
      t3 = t14*spak2k4
      abb95n8 = ((2.0_ki)*(-(t18/t7*t8*spbk3k1+t18*t3/t7*spbk4k1))+(6.0_ki)*(t2*&
      &t4/t6*spbk3k1*spbk6k2+t14*t4/t6*spak4k5*spbk4k1*spbk6k2))
      abb95n9 = ((4.0_ki)*t20/t7*spbk6k2)
      t9 = t17/t7*spbk6k1
      t10 = t20/t7*spbk6k4
      abb95n10 = ((4.0_ki)*(t10+t9))
      abb95n11 = ((16.0_ki)*(-(t9+t10)))
      t9 = t19*spak3k5
      t10 = t9/t6*spbk4k1
      t11 = t8*spak2k5
      t12 = t11/t7*spbk4k1*spbk6k2
      abb95n12 = ((8.0_ki)*(t10-t12))
      abb95n13 = ((8.0_ki)*(t12-t10))
      abb95n14 = ((4.0_ki)*(t11/t7*spbk3k1*spbk6k2+t3/t7*spak2k5*spbk4k1*spbk6k2&
      &-(t19/t6*spak4k5*spbk4k1+t9/t6*spbk3k1)))
      t3 = t5*spbk6k5
      abb95n15 = ((4.0_ki)*(t1/t3+t21/t3*spbk6k4+t16/t7*spbk2k1*spbk4k1-t20/t7*s&
      &pbk4k2))
      t1 = t14*spak1k5
      t3 = t14*spak1k2
      abb95n16 = ((2.0_ki)*(-(t18/t7*t8*spbk4k3+t18*t3/t7*spbk4k1))+(6.0_ki)*(t2&
      &*t4/t6*spbk4k3*spbk6k2-t1*t4/t6*spbk4k1*spbk6k2))
      abb95n17 = ((4.0_ki)*(t1/t6*spak2k5*spbk4k1+t11/t7*spbk4k3*spbk6k2+t3/t7*s&
      &pak2k5*spbk4k1*spbk6k2-t9/t6*spbk4k3))
      rat2d95 = 0
      rat2 = rat2 + rat2d95
      abb95n19 = abb95n1
      abb95n20 = abb95n17
      abb95n21 = abb95n16
      abb95n22 = abb95n15
      abb95n23 = abb95n14
      abb95n24 = abb95n13
      abb95n25 = abb95n12
      abb95n26 = abb95n11
      abb95n27 = abb95n10
      abb95n28 = abb95n9
      abb95n29 = abb95n8
      abb95n30 = abb95n7
      abb95n31 = abb95n6
      abb95n32 = abb95n5
      abb95n33 = abb95n4
      abb95n34 = abb95n3
      abb95n35 = abb95n2
   end subroutine
end module p9_udbar_neepgg_abbrevd95h1
