module     p9_udbar_neepgg_d101h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d101h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d101
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd101h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      real(ki) :: t19
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t17 = dotproduct(k1, qshift)
      t18 = dotproduct(k5, qshift)
      t19 = dotproduct(k6, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t3 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t4 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb101n15+t1*abb101n27+t17*abb101n24+t18*abb101n24+t19*abb&
         &101n25+t2*abb101n28+abb101n23*dotproduct(qshift, qshift)+t1*t17*abb101&
         &n18+t1*t18*abb101n19+t1*t19*abb101n19+t1*t2*abb101n16+t1*t3*abb101n17+&
         &t1*t4*abb101n20+t1*t5*abb101n21+t1*t6*abb101n22)
         return
      end if
      t7 = k1(iv1)
      t8 = k5(iv1)
      t9 = k6(iv1)
      t10 = spvak5k1(iv1)
      t11 = spvak5k6(iv1)
      t12 = spvak2k1(iv1)
      t13 = spvak2k6(iv1)
      t14 = spvak3k1(iv1)
      t15 = spvak3k6(iv1)
      t16 = t11*abb101n19
      if(deg.eq.1) then
         numerator = (qshift(iv1)*abb101n26+t10*abb101n28+t11*abb101n27+t16*t18+&
         &t16*t19+t7*abb101n24+t8*abb101n24+t9*abb101n25+t1*t10*abb101n16+t1*t12&
         &*abb101n22+t1*t13*abb101n20+t1*t14*abb101n21+t1*t15*abb101n17+t1*t7*ab&
         &b101n18+t1*t8*abb101n19+t1*t9*abb101n19+t11*t17*abb101n18+t11*t2*abb10&
         &1n16+t11*t3*abb101n17+t11*t4*abb101n20+t11*t5*abb101n21+t11*t6*abb101n&
         &22)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb101n23+k1(iv2)*t11*abb101n18+k5(iv2&
         &)*t11*abb101n19+k6(iv2)*t11*abb101n19+spvak2k1(iv2)*t11*abb101n22+spva&
         &k2k6(iv2)*t11*abb101n20+spvak3k1(iv2)*t11*abb101n21+spvak3k6(iv2)*t11*&
         &abb101n17+spvak5k1(iv2)*t11*abb101n16+t1*t10*abb101n16+t1*t12*abb101n2&
         &2+t1*t13*abb101n20+t1*t14*abb101n21+t1*t15*abb101n17+t1*t7*abb101n18+t&
         &1*t8*abb101n19+t1*t9*abb101n19)
         return
      end if
      if(deg.eq.3) then
         numerator = (0.0_ki)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d101:
   subroutine     reconstruct_d101(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_101:
      coeffs%coeffs_101%c0 = derivative(czip)
      coeffs%coeffs_101%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_101%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_101%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_101%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_101%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_101%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_101%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_101%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_101%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_101%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_101%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_101%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_101%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_101%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_101%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_101%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_101%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_101%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_101%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_101%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_101%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_101%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_101%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_101%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_101%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_101%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_101%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_101%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_101%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_101%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_101%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_101%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_101%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_101%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_101:
   end subroutine reconstruct_d101
!---#] subroutine reconstruct_d101:
end module p9_udbar_neepgg_d101h1l1d
