module     p9_udbar_neepgg_d27h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d27h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d27
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd27h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t31 = dotproduct(qshift, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t32 = dotproduct(k5, qshift)
      t3 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t33 = dotproduct(k2, qshift)
      t34 = dotproduct(k1, qshift)
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t31*abb27n26+t1*t2*abb27n19+t1*t3*abb27n21+t1*t33*abb27n29&
         &+t1*t34*abb27n30+t1*t4*abb27n23+t1*t5*abb27n24+t1*t6*abb27n27+t1*t7*ab&
         &b27n28+t3*t31*abb27n38+t3*t32*abb27n20+t31*t4*abb27n36+t31*t6*abb27n34&
         &+t31*t8*abb27n32+t32*t4*abb27n22+t32*t6*abb27n25+t1*t5*t8*abb27n40)
         return
      end if
      t9 = qshift(iv1)
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak2k4(iv1)
      t15 = spvak2k6(iv1)
      t16 = spvak3k1(iv1)
      t17 = spvak3k4(iv1)
      t18 = spvak5k1(iv1)
      t19 = spvak5k6(iv1)
      t20 = spvak6k1(iv1)
      if(deg.eq.1) then
         numerator = (t9*abb27n31+t1*t10*abb27n30+t1*t11*abb27n29+t1*t13*abb27n2&
         &4+t1*t14*abb27n27+t1*t15*abb27n28+t1*t16*abb27n21+t1*t18*abb27n23+t1*t&
         &20*abb27n19+t12*t3*abb27n20+t12*t4*abb27n22+t12*t6*abb27n25+t14*t31*ab&
         &b27n34+t14*t32*abb27n25+t16*t31*abb27n38+t16*t32*abb27n20+t17*t31*abb2&
         &7n32+t18*t31*abb27n36+t18*t32*abb27n22+t19*t2*abb27n19+t19*t3*abb27n21&
         &+t19*t33*abb27n29+t19*t34*abb27n30+t19*t4*abb27n23+t19*t5*abb27n24+t19&
         &*t6*abb27n27+t19*t7*abb27n28+t3*t9*abb27n39+t4*t9*abb27n37+t6*t9*abb27&
         &n35+t8*t9*abb27n33+t1*t13*t8*abb27n40+t1*t17*t5*abb27n40+t19*t5*t8*abb&
         &27n40)
         return
      end if
      t31 = d(iv1,iv2)
      t2 = spvak5k6(iv2)
      t7 = spvak2k4(iv2)
      t21 = spvak3k1(iv2)
      t22 = spvak5k1(iv2)
      t23 = k5(iv2)
      t24 = spvak3k4(iv2)
      t25 = qshift(iv2)
      t26 = t13*t2
      t27 = spvak2k1(iv2)
      t28 = t19*t27
      t29 = t13*t24
      t30 = t17*t27
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t31*abb27n26+t3*t31*abb27n38+t31*t4*abb27n36+t31&
         &*t6*abb27n34+t31*t8*abb27n32)+t26*abb27n24+t28*abb27n24+k1(iv2)*t19*ab&
         &b27n30+k2(iv2)*t19*abb27n29+spvak2k6(iv2)*t19*abb27n28+spvak6k1(iv2)*t&
         &19*abb27n19+t1*t29*abb27n40+t1*t30*abb27n40+t10*t2*abb27n30+t11*t2*abb&
         &27n29+t12*t21*abb27n20+t12*t22*abb27n22+t12*t7*abb27n25+t14*t2*abb27n2&
         &7+t14*t23*abb27n25+t14*t25*abb27n35+t15*t2*abb27n28+t16*t2*abb27n21+t1&
         &6*t23*abb27n20+t16*t25*abb27n39+t17*t25*abb27n33+t18*t2*abb27n23+t18*t&
         &23*abb27n22+t18*t25*abb27n37+t19*t21*abb27n21+t19*t22*abb27n23+t19*t7*&
         &abb27n27+t2*t20*abb27n19+t21*t9*abb27n39+t22*t9*abb27n37+t24*t9*abb27n&
         &33+t26*t8*abb27n40+t28*t8*abb27n40+t7*t9*abb27n35+t17*t2*t5*abb27n40+t&
         &19*t24*t5*abb27n40)
         return
      end if
      t32 = d(iv2,iv3)
      t33 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t3 = spvak5k6(iv3)
      t4 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t31*abb27n34+spvak3k1(iv3)*t31*abb&
         &27n38+spvak5k1(iv3)*t31*abb27n36+t1*t31*abb27n32+t14*t32*abb27n34+t16*&
         &t32*abb27n38+t17*t32*abb27n32+t18*t32*abb27n36+t21*t33*abb27n38+t22*t3&
         &3*abb27n36+t24*t33*abb27n32+t33*t7*abb27n34)+t29*t3*abb27n40+t3*t30*ab&
         &b27n40+t1*t13*t2*abb27n40+t1*t19*t27*abb27n40+t17*t2*t4*abb27n40+t19*t&
         &24*t4*abb27n40)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d27:
   subroutine     reconstruct_d27(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group10
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group10), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_27:
      coeffs%coeffs_27%c0 = derivative(czip)
      coeffs%coeffs_27%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_27%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_27%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_27%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_27%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_27%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_27%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_27%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_27%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_27%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_27%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_27%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_27%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_27%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_27%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_27%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_27%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_27%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_27%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_27%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_27%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_27%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_27%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_27%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_27%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_27%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_27%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_27%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_27%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_27%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_27%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_27:
   end subroutine reconstruct_d27
!---#] subroutine reconstruct_d27:
end module p9_udbar_neepgg_d27h1l1d
