module     p9_udbar_neepgg_abbrevd14h3
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh3
   implicit none
   private
   complex(ki), public :: abb14n1
   complex(ki), public :: abb14n2
   complex(ki), public :: abb14n3
   complex(ki), public :: abb14n4
   complex(ki), public :: abb14n5
   complex(ki), public :: rat2d14
   complex(ki), public :: abb14n7
   complex(ki), public :: abb14n8
   complex(ki), public :: abb14n9
   complex(ki), public :: abb14n10
   complex(ki), public :: abb14n11
   complex(ki), public :: abb14n12
   complex(ki), public :: abb14n13
   complex(ki), public :: abb14n14
   complex(ki), public :: abb14n15
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   real(ki) :: t39
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1*i_
      t3 = t2*spak2k3
      t4 = t3*spak2k5
      t5 = t4*spbk4k2
      t6 = t5*spbk5k1
      t7 = es234*NC*t1
      t8 = spbk6k5*spbk6k5
      t9 = t7*t8
      t3 = t3*spak3k5*spbk4k3
      t10 = t3*spbk5k1
      t11 = NC*TR*c1*i_
      t12 = t11*spak2k3
      t13 = t12*spak2k5
      t14 = t13*spbk4k2
      t15 = t14*spbk5k1
      t16 = es234*t1
      t17 = t16*t8
      t12 = t12*spak3k5*spbk4k3
      t18 = t12*spbk5k1
      t19 = t2*spak1k6
      t20 = t19*spak2k5*spak3k5
      t21 = t20*spbk4k1
      t22 = t21*spbk5k1
      t1 = (es34+es61-(es345+es234))*t1
      t23 = NC*t1
      t24 = es61*t23
      t25 = t24*spbk6k5
      t26 = t11*spak1k6
      t27 = t26*spak2k5*spak3k5
      t28 = t27*spbk4k1
      t29 = t28*spbk5k1
      t30 = es61*t1
      t31 = t30*spbk6k5
      t19 = t19*spak2k3*spak2k5
      t32 = t19*spbk4k1
      t33 = t32*spbk5k1*spbk6k2
      t24 = t24*t8
      t26 = t26*spak2k3*spak2k5
      t34 = t26*spbk4k1
      t35 = t34*spbk5k1*spbk6k2
      t30 = t30*t8
      abb14n1 = ((4.0_ki)*(t18/t17+t29/t31+t35/t30+t6/t9-(t33/t24+t22/t25+t15/t1&
      &7+t10/t9)))
      t7 = es61*t7
      t9 = t7*t8
      t6 = t6/t9
      t10 = t10/t9
      t16 = es61*t16
      t8 = t16*t8
      t15 = t15/t8
      t17 = t18/t8
      t39 = es61*es61
      t18 = t39*t23*spbk6k5
      t22 = t22/t18
      t36 = t39*t1*spbk6k5
      t29 = t29/t36
      t37 = es61*spbk6k5
      t37 = t37*t37
      t38 = t23*t37
      t33 = t33/t38
      t37 = t1*t37
      t35 = t35/t37
      abb14n2 = ((8.0_ki)*(t10+t15+t22+t33-(t6+t35+t29+t17)))
      abb14n3 = ((16.0_ki)*(t17+t29+t35+t6-(t33+t22+t15+t10)))
      abb14n4 = ((8.0_ki)*(t14/t8*spbk6k1+t3/t9*spbk6k1+t13/t30*spbk4k1*spbk6k2+&
      &t11/t31*spak2k5*spak3k5*spbk4k1-(t2/t25*spak2k5*spak3k5*spbk4k1+t4/t24*sp&
      &bk4k1*spbk6k2+t5/t9*spbk6k1+t12/t8*spbk6k1)))
      t2 = t7*spbk6k5
      t4 = t16*spbk6k5
      abb14n5 = ((4.0_ki)*(t20/t18*spbk5k1*spbk6k4+t19/t38*spbk5k1*spbk6k2*spbk6&
      &k4-(t26/t37*spbk5k1*spbk6k2*spbk6k4+t27/t36*spbk5k1*spbk6k4))+(8.0_ki)*(t&
      &28/(t39*t1)+t12/t4+t5/t2+t34/t36*spbk6k2-(t32/t18*spbk6k2+t3/t2+t14/t4+t2&
      &1/(t39*t23))))
      rat2d14 = 0
      rat2 = rat2 + rat2d14
      abb14n7 = abb14n1
      abb14n8 = abb14n5
      abb14n9 = abb14n4
      abb14n10 = abb14n3
      abb14n11 = abb14n2
      abb14n12 = -(abb14n2)
      abb14n13 = -(abb14n3)
      abb14n14 = -(abb14n4)
      abb14n15 = -(abb14n5)
   end subroutine
end module p9_udbar_neepgg_abbrevd14h3
