module     p9_udbar_neepgg_abbrevd33h3
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh3
   implicit none
   private
   complex(ki), public :: abb33n1
   complex(ki), public :: abb33n2
   complex(ki), public :: abb33n3
   complex(ki), public :: abb33n4
   complex(ki), public :: abb33n5
   complex(ki), public :: abb33n6
   complex(ki), public :: abb33n7
   complex(ki), public :: abb33n8
   complex(ki), public :: abb33n9
   complex(ki), public :: abb33n10
   complex(ki), public :: abb33n11
   complex(ki), public :: abb33n12
   complex(ki), public :: abb33n13
   complex(ki), public :: abb33n14
   complex(ki), public :: abb33n15
   complex(ki), public :: abb33n16
   complex(ki), public :: abb33n17
   complex(ki), public :: abb33n18
   complex(ki), public :: abb33n19
   complex(ki), public :: abb33n20
   complex(ki), public :: abb33n21
   complex(ki), public :: rat2d33
   complex(ki), public :: abb33n23
   complex(ki), public :: abb33n24
   complex(ki), public :: abb33n25
   complex(ki), public :: abb33n26
   complex(ki), public :: abb33n27
   complex(ki), public :: abb33n28
   complex(ki), public :: abb33n29
   complex(ki), public :: abb33n30
   complex(ki), public :: abb33n31
   complex(ki), public :: abb33n32
   complex(ki), public :: abb33n33
   complex(ki), public :: abb33n34
   complex(ki), public :: abb33n35
   complex(ki), public :: abb33n36
   complex(ki), public :: abb33n37
   complex(ki), public :: abb33n38
   complex(ki), public :: abb33n39
   complex(ki), public :: abb33n40
   complex(ki), public :: abb33n41
   complex(ki), public :: abb33n42
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   complex(ki) :: t52
   complex(ki) :: t53
   complex(ki) :: t54
   complex(ki) :: t55
   complex(ki) :: t56
   complex(ki) :: t57
   complex(ki) :: t58
   complex(ki) :: t59
   complex(ki) :: t60
   complex(ki) :: t61
   complex(ki) :: t62
   complex(ki) :: t63
   complex(ki) :: t64
   complex(ki) :: t65
   complex(ki) :: t66
   complex(ki) :: t67
   complex(ki) :: t68
   complex(ki) :: t69
   complex(ki) :: t70
   complex(ki) :: t71
   complex(ki) :: t72
   complex(ki) :: t73
   complex(ki) :: t74
   complex(ki) :: t75
   complex(ki) :: t76
   complex(ki) :: t77
   complex(ki) :: t78
   complex(ki) :: t79
   complex(ki) :: t80
   complex(ki) :: t81
   complex(ki) :: t82
   complex(ki) :: t83
   complex(ki) :: t84
   complex(ki) :: t85
   complex(ki) :: t86
   complex(ki) :: t87
   complex(ki) :: t88
   complex(ki) :: t89
   complex(ki) :: t90
   real(ki) :: t91
   real(ki) :: t92
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t91 = es34+es61-(es345+es234)
      t2 = TR*c1
      t3 = es12*t2*i_
      t4 = t91*(es34+es56-(es234+es12))*t1
      t5 = spbk6k5*spbk6k5
      t6 = NC*t4*t5
      t7 = t3/t6*spak1k3*spak2k5*spbk4k1*spbk5k1
      t3 = t3/t6*spak2k5*spak3k4*spbk4k1*spbk5k4
      t8 = es345*t2*i_
      t9 = t8*spak1k3
      t10 = t9/t6*spak2k5*spbk4k1*spbk5k1
      t11 = t8/t6*spak2k5*spak3k4*spbk4k1*spbk5k4
      t12 = es56*t2*i_
      t13 = t12/t6*spak1k3*spak2k5*spbk4k1*spbk5k1
      t12 = t12/t6*spak2k5*spak3k4*spbk4k1*spbk5k4
      t14 = es61*t2*i_
      t15 = t14*spak1k3
      t16 = t15/t6*spak2k5*spbk4k1*spbk5k1
      t17 = t14/t6*spak2k5*spak3k4*spbk4k1*spbk5k4
      t18 = t10+t11+t12+t13-(t7+t3+t17+t16)
      t19 = NC*TR*c1
      t20 = es12*t19
      t21 = t20*i_
      t22 = t4*t5
      t23 = t21/t22*spak1k3*spak2k5*spbk4k1*spbk5k1
      t21 = t21/t22*spak2k5*spak3k4*spbk4k1*spbk5k4
      t24 = es345*t19
      t25 = t24*i_
      t26 = t25*spak1k3
      t27 = t26/t22*spak2k5*spbk4k1*spbk5k1
      t28 = t25*spak2k5
      t29 = t28/t22*spak3k4*spbk4k1*spbk5k4
      t30 = es56*t19
      t31 = t30*i_
      t32 = t31/t22*spak1k3*spak2k5*spbk4k1*spbk5k1
      t31 = t31/t22*spak2k5*spak3k4*spbk4k1*spbk5k4
      t33 = es61*t19*i_
      t34 = t33*spak1k3
      t35 = t34/t22*spak2k5*spbk4k1*spbk5k1
      t36 = t33*spak2k5
      t37 = t36/t22*spak3k4*spbk4k1*spbk5k4
      t38 = t2*i_
      t39 = t38*spak1k6
      t40 = t39*spak2k5
      t1 = t91*t1
      t41 = NC*t1
      t42 = es61*t41
      t43 = t42*spbk6k5
      t44 = t40/t43*spak3k5*spbk4k1*spbk5k1
      t45 = t19*i_
      t46 = t45*spak1k6
      t47 = t46*spak2k5
      t48 = t47*spak3k5*spbk4k1*spbk5k1
      t49 = es61*t1
      t50 = t49*spbk6k5
      t51 = t48/t50
      t52 = t39*spak2k3
      t42 = t42*t5
      t53 = t52/t42*spak2k5*spbk4k1*spbk5k1*spbk6k2
      t54 = t46*spak2k3
      t55 = t54*spak2k5*spbk4k1*spbk5k1*spbk6k2
      t56 = t49*t5
      t57 = t55/t56
      abb33n1 = ((2.0_ki)*(t18+t21+t23+t35+t37+t51+t57-(t53+t44+t32+t31+t29+t27)&
      &))
      t58 = es234*t19
      t59 = t58*i_
      t60 = t59*spak2k5
      t61 = t60*spak3k6
      t4 = t4*spbk6k5
      t62 = t61/t4*spbk4k1
      t19 = es34*t19
      t63 = t19*i_
      t64 = t63*spak2k5
      t65 = t64*spak3k6
      t66 = t65/t4*spbk4k1
      t67 = t28*spak3k6
      t68 = t67/t4*spbk4k1
      t69 = t36*spak3k6
      t70 = t69/t4*spbk4k1
      abb33n2 = ((12.0_ki)*(t62+t68-(t70+t66)))
      t71 = t59*spak1k6
      t72 = t71*spak2k5
      t73 = t63*spak1k6
      t74 = t73*spak2k5
      t75 = t25*spak1k6
      t76 = t75*spak2k5
      abb33n3 = ((6.0_ki)*(t65/t4*spbk4k3+t69/t4*spbk4k3+t72/t4*spbk4k1+t76/t4*s&
      &pbk4k1-(t33/t4*spak1k6*spak2k5*spbk4k1+t74/t4*spbk4k1+t67/t4*spbk4k3+t61/&
      &t4*spbk4k3)))
      t77 = es56*t58*i_
      t78 = es56*t19*i_
      t79 = es56*t24*i_
      t24 = es61*t24*i_
      t30 = es61*t30*i_
      t80 = t45*spak1k3
      t81 = t80*spak2k5
      t82 = t81*spbk4k1*spbk5k1
      t91 = es345*es345
      t83 = t45*spak2k5
      t84 = t83*spak3k4*spbk4k1*spbk5k4
      t92 = es61*es61
      t85 = t1*t5
      t86 = es234*t20*i_
      t87 = es34*t20*i_
      t88 = es345*t20*i_
      t20 = es61*t20*i_
      t89 = es345*t58*i_
      t58 = es61*t58*i_
      t90 = es345*t19*i_
      t19 = es61*t19*i_
      t71 = t71*spak2k3
      t73 = t73*spak2k3
      t75 = t75*spak2k3
      abb33n4 = ((4.0_ki)*(t48/(t1*spbk6k5)+t74/t50*spak3k5*spbk4k1*spbk5k1+t77/&
      &t22*spak1k3*spak2k5*spbk4k1*spbk5k1+t77/t22*spak2k5*spak3k4*spbk4k1*spbk5&
      &k4+t79/t22*spak1k3*spak2k5*spbk4k1*spbk5k1+t79/t22*spak2k5*spak3k4*spbk4k&
      &1*spbk5k4-(t78/t22*spak2k5*spak3k4*spbk4k1*spbk5k4+t78/t22*spak1k3*spak2k&
      &5*spbk4k1*spbk5k1+t30/t22*spak2k5*spak3k4*spbk4k1*spbk5k4+t30/t22*spak1k3&
      &*spak2k5*spbk4k1*spbk5k1+t24/t22*spak2k5*spak3k4*spbk4k1*spbk5k4+t24/t22*&
      &spak1k3*spak2k5*spbk4k1*spbk5k1+t76/t50*spak3k5*spbk4k1*spbk5k1+t72/t50*s&
      &pak3k5*spbk4k1*spbk5k1))+(2.0_ki)*(t55/t85+t91*t82/t22+t92*t82/t22+t91*t8&
      &4/t22+t92*t84/t22+t19/t22*spak1k3*spak2k5*spbk4k1*spbk5k1+t19/t22*spak2k5&
      &*spak3k4*spbk4k1*spbk5k4+t20/t22*spak1k3*spak2k5*spbk4k1*spbk5k1+t20/t22*&
      &spak2k5*spak3k4*spbk4k1*spbk5k4+t87/t22*spak1k3*spak2k5*spbk4k1*spbk5k1+t&
      &87/t22*spak2k5*spak3k4*spbk4k1*spbk5k4+t89/t22*spak1k3*spak2k5*spbk4k1*sp&
      &bk5k1+t89/t22*spak2k5*spak3k4*spbk4k1*spbk5k4+t73/t56*spak2k5*spbk4k1*spb&
      &k5k1*spbk6k2-(t75/t56*spak2k5*spbk4k1*spbk5k1*spbk6k2+t71/t56*spak2k5*spb&
      &k4k1*spbk5k1*spbk6k2+t90/t22*spak2k5*spak3k4*spbk4k1*spbk5k4+t90/t22*spak&
      &1k3*spak2k5*spbk4k1*spbk5k1+t88/t22*spak2k5*spak3k4*spbk4k1*spbk5k4+t88/t&
      &22*spak1k3*spak2k5*spbk4k1*spbk5k1+t86/t22*spak2k5*spak3k4*spbk4k1*spbk5k&
      &4+t86/t22*spak1k3*spak2k5*spbk4k1*spbk5k1+t58/t22*spak2k5*spak3k4*spbk4k1&
      &*spbk5k4+t58/t22*spak1k3*spak2k5*spbk4k1*spbk5k1)))
      abb33n5 = ((8.0_ki)*(t21+t23+t31+t32+t35+t37+t57-(t51+t29+t27)))
      t1 = spak2k5*spak2k5
      t19 = spak2k5*spbk5k1
      abb33n6 = ((6.0_ki)*(t65/t4*spbk3k1+t69/t4*spbk3k1+t36/t4*spak4k6*spbk4k1+&
      &t64/t4*spak4k6*spbk4k1+t1*t46/t50*spbk2k1*spbk5k1-(t60/t4*spak4k6*spbk4k1&
      &+t28/t4*spak4k6*spbk4k1+t67/t4*spbk3k1+t61/t4*spbk3k1))+(2.0_ki)*t19*t19*&
      &t46/t56*spbk6k2)
      t19 = t45*spak3k6
      t20 = t19*spbk4k2
      t24 = t1*t20/t50*spbk5k1
      t28 = t1*t19/t56*spbk5k1*spbk5k4*spbk6k2
      abb33n7 = ((4.0_ki)*(t28-(3.0_ki)*t24))
      abb33n8 = ((12.0_ki)*(t24+t66+t70-(t68+t62))-(4.0_ki)*t28)
      t24 = t45*spak3k4
      t28 = t24*spbk4k1
      t19 = t19*spbk5k4
      abb33n9 = ((6.0_ki)*(t1*t20/t50*spbk6k1+t1/t4*t80*spbk2k1*spbk4k1-t1*t28/t&
      &4*spbk4k2)+(2.0_ki)*(t1/t22*t28*spbk5k4*spbk6k2+t1/t22*t80*spbk4k1*spbk5k&
      &1*spbk6k2-t1*t19/t56*spbk6k1*spbk6k2))
      abb33n10 = ((6.0_ki)*(t1/t50*t80*spbk4k2*spbk5k1-t1*t20/t49)+(2.0_ki)*(t1*&
      &t19/t50*spbk6k2-t1/t56*t80*spbk5k1*spbk5k4*spbk6k2))
      t1 = t52*spbk4k1*spbk5k1
      t4 = t54*spbk4k1*spbk5k1
      t19 = es234*t2*i_
      t2 = es34*t2*i_
      abb33n11 = ((4.0_ki)*(t71/t56*spbk4k1*spbk5k1+t75/t56*spbk4k1*spbk5k1+t26/&
      &t22*spak2k6*spbk4k1*spbk5k1+t9/t6*spak2k6*spbk4k1*spbk5k1+t19/t42*spak1k6&
      &*spak2k3*spbk4k1*spbk5k1+t19/t6*spak1k3*spak2k6*spbk4k1*spbk5k1+t19/t6*sp&
      &ak2k6*spak3k4*spbk4k1*spbk5k4+t25/t22*spak2k6*spak3k4*spbk4k1*spbk5k4+t59&
      &/t22*spak1k3*spak2k6*spbk4k1*spbk5k1+t59/t22*spak2k6*spak3k4*spbk4k1*spbk&
      &5k4+t8/t42*spak1k6*spak2k3*spbk4k1*spbk5k1+t8/t6*spak2k6*spak3k4*spbk4k1*&
      &spbk5k4-(t63/t22*spak2k6*spak3k4*spbk4k1*spbk5k4+t63/t22*spak1k3*spak2k6*&
      &spbk4k1*spbk5k1+t33/t22*spak2k6*spak3k4*spbk4k1*spbk5k4+t2/t6*spak2k6*spa&
      &k3k4*spbk4k1*spbk5k4+t2/t6*spak1k3*spak2k6*spbk4k1*spbk5k1+t2/t42*spak1k6&
      &*spak2k3*spbk4k1*spbk5k1+t14/t6*spak2k6*spak3k4*spbk4k1*spbk5k4+t34/t22*s&
      &pak2k6*spbk4k1*spbk5k1+t15/t6*spak2k6*spbk4k1*spbk5k1+t73/t56*spbk4k1*spb&
      &k5k1+t4/t85+t1/(t41*t5))))
      t2 = t38*spak1k3
      t5 = t2/t6*spak2k6*spbk4k1*spbk5k1
      t8 = t38/t6*spak2k6*spak3k4*spbk4k1*spbk5k4
      t9 = t80/t22*spak2k6*spbk4k1*spbk5k1
      t14 = t45/t22*spak2k6*spak3k4*spbk4k1*spbk5k4
      t1 = t1/t42
      t4 = t4/t56
      abb33n12 = ((16.0_ki)*(t1+t14+t4+t5+t8+t9))
      abb33n13 = ((8.0_ki)*(-(t9+t8+t5+t4+t14+t1)))
      abb33n14 = ((4.0_ki)*(t16+t17+t27+t29+t3+t31+t32+t44+t53+t7-(t57+t51+t37+t&
      &35+t23+t21+t13+t12+t11+t10)))
      abb33n15 = ((8.0_ki)*(t18+t27+t29+t51-(t57+t53+t44+t37+t35+t32+t31+t23+t21&
      &)))
      abb33n16 = ((4.0_ki)*(t39/t42*spak3k5*spbk4k1*spbk5k1+t46/t56*spak3k5*spbk&
      &4k1*spbk5k1-(t38/t6*spak3k4*spak5k6*spbk4k1*spbk5k4+t80/t22*spak5k6*spbk4&
      &k1*spbk5k1+t24/t22*spak5k6*spbk4k1*spbk5k4+t2/t6*spak5k6*spbk4k1*spbk5k1)&
      &))
      t1 = spbk5k1*spbk5k1
      abb33n17 = ((8.0_ki)*(-(t1*t47/t56+t1*t40/t42)))
      t1 = t38*spak2k5
      t3 = t1*spak3k6
      t4 = t3/t42*spbk5k1*spbk5k4
      t5 = t83*spak3k6
      t7 = t5/t56*spbk5k1*spbk5k4
      abb33n18 = ((16.0_ki)*(t4+t7))
      abb33n19 = ((16.0_ki)*(-(t7+t4)))
      t2 = t2*spak2k5
      t3 = t3*spbk5k4
      t4 = t5*spbk5k4
      abb33n20 = ((8.0_ki)*(t3/t42*spbk6k1+t4/t56*spbk6k1-(t1/t6*spak3k4*spbk4k1&
      &*spbk5k4+t2/t6*spbk4k1*spbk5k1+t84/t22+t82/t22)))
      abb33n21 = ((8.0_ki)*(t2/t42*spbk5k1*spbk5k4+t81/t56*spbk5k1*spbk5k4-(t4/t&
      &50+t3/t43)))
      rat2d33 = abb33n1
      rat2 = rat2 + rat2d33
      abb33n23 = abb33n4
      abb33n24 = abb33n21
      abb33n25 = abb33n20
      abb33n26 = abb33n19
      abb33n27 = abb33n18
      abb33n28 = abb33n17
      abb33n29 = abb33n16
      abb33n30 = abb33n15
      abb33n31 = abb33n14
      abb33n32 = abb33n13
      abb33n33 = abb33n12
      abb33n34 = abb33n11
      abb33n35 = abb33n10
      abb33n36 = abb33n9
      abb33n37 = abb33n8
      abb33n38 = abb33n7
      abb33n39 = abb33n6
      abb33n40 = abb33n5
      abb33n41 = abb33n3
      abb33n42 = abb33n2
   end subroutine
end module p9_udbar_neepgg_abbrevd33h3
