module     p9_udbar_neepgg_abbrevd35h3
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh3
   implicit none
   private
   complex(ki), public :: abb35n1
   complex(ki), public :: abb35n2
   complex(ki), public :: abb35n3
   complex(ki), public :: abb35n4
   complex(ki), public :: abb35n5
   complex(ki), public :: abb35n6
   complex(ki), public :: abb35n7
   complex(ki), public :: abb35n8
   complex(ki), public :: rat2d35
   complex(ki), public :: abb35n10
   complex(ki), public :: abb35n11
   complex(ki), public :: abb35n12
   complex(ki), public :: abb35n13
   complex(ki), public :: abb35n14
   complex(ki), public :: abb35n15
   complex(ki), public :: abb35n16
   complex(ki), public :: abb35n17
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1*i_
      t3 = t2*spak2k3
      t4 = t3*spak2k5
      t5 = t4*spbk4k2
      t6 = es234*NC*t1
      t7 = spbk6k5*spbk6k5
      t8 = t6*t7
      t9 = t5/t8*spbk5k1
      t3 = t3*spak3k5*spbk4k3
      t8 = t3/t8*spbk5k1
      t10 = NC*TR*c1
      t11 = t10*i_
      t12 = t11*spak2k3
      t13 = t12*spak2k5
      t14 = t13*spbk4k2
      t15 = es234*t1
      t16 = t15*t7
      t17 = t14/t16*spbk5k1
      t12 = t12*spak3k5*spbk4k3
      t18 = t12/t16*spbk5k1
      t19 = t2*spak1k6
      t1 = (es34+es61-(es345+es234))*t1
      t20 = es61*NC*t1
      t21 = t20*spbk6k5
      t22 = t19/t21*spak2k5*spak3k5*spbk4k1*spbk5k1
      t23 = t11*spak1k6
      t24 = t23*spak2k5*spak3k5
      t25 = t24*spbk4k1
      t26 = t25*spbk5k1
      t27 = es61*t1
      t28 = t27*spbk6k5
      t29 = t26/t28
      t20 = t20*t7
      t19 = t19/t20*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2
      t23 = t23*spak2k3*spak2k5
      t30 = t23*spbk4k1
      t31 = t30*spbk5k1*spbk6k2
      t32 = t27*t7
      t33 = t31/t32
      abb35n1 = ((2.0_ki)*(t18+t29+t33+t9-(t8+t22+t19+t17)))
      t2 = t2*spak2k5*spak3k5
      t11 = t11*spak2k5*spak3k5
      abb35n2 = ((4.0_ki)*(-(t4/t20*spbk6k2*spbk6k4+t13/t32*spbk6k2*spbk6k4+t2/t&
      &21*spbk6k4+t11/t28*spbk6k4)))
      t34 = t1*spbk6k5
      t10 = es61*t10*i_*spak2k3
      t1 = t1*t7
      abb35n3 = ((2.0_ki)*(t31/t1+t26/t34+t10/t16*spak3k5*spbk4k3*spbk5k1-t10/t1&
      &6*spak2k5*spbk4k2*spbk5k1))
      abb35n4 = ((8.0_ki)*(t18+t29+t33-t17))
      t10 = t11*spbk4k1
      t11 = t13*spbk4k1*spbk6k2
      t13 = t14*spbk6k1
      t26 = t12*spbk6k1
      abb35n5 = ((2.0_ki)*(t11/t1+t10/t34+t13/t16-t26/t16))
      t1 = t15*spbk6k5
      abb35n6 = ((2.0_ki)*(t24/t28*spbk5k1*spbk6k4+t23/t32*spbk5k1*spbk6k2*spbk6&
      &k4)+(6.0_ki)*(t12/t1+t25/t27+t30/t28*spbk6k2-t14/t1))
      abb35n7 = ((4.0_ki)*(t17+t19+t22+t8-(t9+t33+t29+t18)))
      t1 = es61*t6*t7
      t6 = es61*t15*t7
      abb35n8 = ((8.0_ki)*(t26/t6+t3/t1*spbk6k1-(t4/t20*spbk4k1*spbk6k2+t2/t21*s&
      &pbk4k1+t5/t1*spbk6k1+t13/t6+t11/t32+t10/t28)))
      rat2d35 = abb35n1
      rat2 = rat2 + rat2d35
      abb35n10 = abb35n3
      abb35n11 = abb35n8
      abb35n12 = abb35n7
      abb35n13 = abb35n2
      abb35n14 = -(abb35n4)
      abb35n15 = -(abb35n5)
      abb35n16 = -(abb35n6)
      abb35n17 = ((2.0_ki)*abb35n7)
   end subroutine
end module p9_udbar_neepgg_abbrevd35h3
