module     p9_udbar_neepgg_abbrevd3h3
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh3
   implicit none
   private
   complex(ki), public :: abb3n1
   complex(ki), public :: abb3n2
   complex(ki), public :: abb3n3
   complex(ki), public :: abb3n4
   complex(ki), public :: abb3n5
   complex(ki), public :: abb3n6
   complex(ki), public :: rat2d3
   complex(ki), public :: abb3n8
   complex(ki), public :: abb3n9
   complex(ki), public :: abb3n10
   complex(ki), public :: abb3n11
   complex(ki), public :: abb3n12
   complex(ki), public :: abb3n13
   complex(ki), public :: abb3n14
   complex(ki), public :: abb3n15
   complex(ki), public :: abb3n16
   complex(ki), public :: abb3n17
   complex(ki), public :: abb3n18
   complex(ki), public :: abb3n19
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   real(ki) :: t15
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t15 = NC*TR
      t1 = t15*c2
      t2 = t1*i_*spak2k3
      t3 = t2*spak2k5*spbk4k2
      t4 = es234*(es34+wW*mW*i_-mW*mW)
      t5 = t4*spbk6k5*spbk6k5
      t6 = t2*spak3k5*spbk4k3
      t7 = TR*c3
      t8 = t7*i_*spak2k3
      t9 = t8*spak2k5*spbk4k2
      t10 = t8*spak3k5*spbk4k3
      t11 = t15*c1
      t12 = t11*i_*spak2k3
      t13 = t12*spak2k5*spbk4k2
      t14 = t12*spak3k5*spbk4k3
      abb3n1 = ((4.0_ki)*(t6/t5*spbk6k1-t3/t5*spbk6k1)+(2.0_ki)*(t10/t5*spbk6k1+&
      &t13/t5*spbk6k1-(t9/t5*spbk6k1+t14/t5*spbk6k1)))
      t7 = es56*t7*i_*spak2k3
      t11 = es56*t11*i_*spak2k3
      t1 = es56*t1*i_*spak2k3
      abb3n2 = ((2.0_ki)*(t1/t5*spbk4k2+t11/t5*spbk4k2+(2.0_ki)/t5*t7*spbk4k2))
      abb3n3 = ((2.0_ki)*(-((2.0_ki)/t5*t7*spbk4k3+t11/t5*spbk4k3+t1/t5*spbk4k3)&
      &))
      t1 = t12*spak2k6*spbk4k2
      t7 = t12*spak3k6*spbk4k3
      t11 = t8*spak2k6*spbk4k2
      t8 = t8*spak3k6*spbk4k3
      t12 = t2*spak2k6*spbk4k2
      t2 = t2*spak3k6*spbk4k3
      abb3n4 = ((4.0_ki)*(t7/t5*spbk5k1-t1/t5*spbk5k1)+(2.0_ki)*(t12/t5*spbk5k1+&
      &t8/t5*spbk5k1-(t2/t5*spbk5k1+t11/t5*spbk5k1)))
      t4 = t4*spbk6k5
      abb3n5 = ((4.0_ki)*(t3/t4-t6/t4)+(2.0_ki)*(t14/t4+t9/t4-(t13/t4+t10/t4)))
      abb3n6 = ((4.0_ki)*(t7/t4-t1/t4)+(2.0_ki)*(t12/t4+t8/t4-(t2/t4+t11/t4)))
      rat2d3 = 0
      rat2 = rat2 + rat2d3
      abb3n8 = -(abb3n1)
      abb3n9 = abb3n6
      abb3n10 = abb3n5
      abb3n11 = abb3n4
      abb3n12 = abb3n3
      abb3n13 = abb3n2
      abb3n14 = abb3n1
      abb3n15 = -(abb3n2)
      abb3n16 = -(abb3n3)
      abb3n17 = -(abb3n4)
      abb3n18 = -(abb3n5)
      abb3n19 = -(abb3n6)
   end subroutine
end module p9_udbar_neepgg_abbrevd3h3
