module     p9_udbar_neepgg_d18h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d18h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d18
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd18h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      real(ki) :: t47
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t44 = dotproduct(qshift, qshift)
      t45 = dotproduct(k5, qshift)
      t3 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t46 = dotproduct(k2, qshift)
      t47 = dotproduct(k6, qshift)
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t7 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t9 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t10 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-s&
      &pvak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb18n42+t1*abb18n101+t2*abb18n121+t3*abb18n90+t4*abb18n91&
         &+t44*abb18n53+t45*abb18n94+t45*t45*abb18n54+t46*abb18n93+t47*abb18n95+&
         &t5*abb18n96+t6*abb18n98+t1*t6*abb18n65+t1*t8*abb18n52+t10*t6*abb18n61+&
         &t2*t44*abb18n127+t2*t45*abb18n45+t2*t46*abb18n47+t2*t47*abb18n45+t2*t6&
         &*abb18n44+t2*t8*abb18n73+t3*t44*abb18n105+t3*t45*abb18n62+t3*t46*abb18&
         &n60+t3*t47*abb18n62+t3*t6*abb18n63+t3*t8*abb18n80+t4*t6*abb18n50+t4*t8&
         &*abb18n81+t44*t45*abb18n114+t44*t5*abb18n87+t44*t6*abb18n110+t45*t46*a&
         &bb18n57+t45*t47*abb18n54+t45*t5*abb18n78+t45*t6*abb18n59+t45*t8*abb18n&
         &68+t46*t5*abb18n76+t46*t6*abb18n66+t46*t8*abb18n79+t47*t5*abb18n78+t5*&
         &t6*abb18n49+t6*t7*abb18n46+t6*t9*abb18n55+t4*t6*t8*abb18n124+t6*t7*t8*&
         &abb18n131)
         return
      end if
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak2k1(iv1)
      t16 = spvak2k5(iv1)
      t17 = spvak3k1(iv1)
      t18 = spvak5k2(iv1)
      t19 = spvak6k1(iv1)
      t20 = spvak6k5(iv1)
      t21 = t16*abb18n103
      t22 = spvak2k6(iv1)
      t23 = t17*abb18n85
      t24 = spvak3k4(iv1)
      t25 = spvak5k1(iv1)
      t26 = spvak5k6(iv1)
      t27 = t19*abb18n129
      if(deg.eq.1) then
         numerator = (t11*abb18n72+t12*abb18n71+t13*abb18n70+t14*abb18n119+t15*a&
         &bb18n74+t16*abb18n75+t17*abb18n69+t18*abb18n64+t19*abb18n51+t20*abb18n&
         &67+t21*t45+t21*t47+t23*t45+t23*t47+t27*t45+t27*t47+t1*t20*abb18n100+t1&
         &*t24*abb18n120+t10*t20*abb18n105+t11*t2*abb18n125+t11*t3*abb18n107+t11&
         &*t45*abb18n112+t11*t5*abb18n89+t11*t6*abb18n99+t11*t8*abb18n84+t12*t2*&
         &abb18n129+t12*t3*abb18n103+t12*t44*abb18n56+t12*t45*abb18n118+t12*t46*&
         &abb18n112+t12*t47*abb18n117+t12*t5*abb18n85+t12*t6*abb18n108+t12*t8*ab&
         &b18n97+t13*t2*abb18n129+t13*t3*abb18n103+t13*t45*abb18n117+t13*t5*abb1&
         &8n85+t14*t2*abb18n126+t14*t3*abb18n104+t14*t45*abb18n113+t14*t5*abb18n&
         &86+t14*t6*abb18n109+t15*t6*abb18n122+t15*t8*abb18n82+t16*t44*abb18n61+&
         &t16*t46*abb18n107+t16*t6*abb18n102+t16*t8*abb18n83+t17*t44*abb18n77+t1&
         &7*t46*abb18n89+t17*t6*abb18n123+t18*t6*abb18n100+t18*t8*abb18n120+t19*&
         &t44*abb18n46+t19*t46*abb18n125+t19*t6*abb18n130+t19*t8*abb18n92+t2*t20&
         &*abb18n130+t2*t24*abb18n92+t20*t3*abb18n102+t20*t4*abb18n122+t20*t44*a&
         &bb18n58+t20*t45*abb18n108+t20*t46*abb18n99+t20*t5*abb18n123+t20*t7*abb&
         &18n127+t20*t9*abb18n116+t22*t6*abb18n105+t24*t3*abb18n83+t24*t4*abb18n&
         &82+t24*t45*abb18n97+t24*t46*abb18n84+t25*t6*abb18n127+t26*t6*abb18n116&
         &+t15*t6*t8*abb18n48+t20*t4*t8*abb18n48+t20*t7*t8*abb18n43+t24*t4*t6*ab&
         &b18n48+t24*t6*t7*abb18n43+t25*t6*t8*abb18n43)
         return
      end if
      t44 = d(iv1,iv2)
      t1 = k5(iv2)
      t9 = spvak2k5(iv2)
      t10 = spvak3k1(iv2)
      t21 = spvak3k4(iv2)
      t23 = spvak6k1(iv2)
      t27 = spvak6k5(iv2)
      t28 = k2(iv2)
      t29 = k6(iv2)
      t30 = qshift(iv2)
      t31 = t15*t21
      t32 = t15*t27
      t33 = spvak2k1(iv2)
      t34 = t24*t33
      t35 = t20*t33
      t36 = spvak5k2(iv2)
      t37 = t25*t27
      t38 = spvak5k1(iv2)
      t39 = t20*t38
      t40 = t24*t38
      t41 = t24*t27
      t42 = t21*t25
      t43 = t20*t21
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t44*abb18n53+t1*t12*abb18n54+t2*t44*abb18n127+t3&
         &*t44*abb18n105+t44*t45*abb18n114+t44*t5*abb18n87+t44*t6*abb18n110)+t31&
         &*abb18n81+t32*abb18n50+t34*abb18n81+t35*abb18n50+t37*abb18n46+t39*abb1&
         &8n46+spvak2k6(iv2)*t20*abb18n61+spvak5k6(iv2)*t20*abb18n55+t1*t11*abb1&
         &8n57+t1*t13*abb18n54+t1*t14*abb18n115+t1*t16*abb18n62+t1*t17*abb18n78+&
         &t1*t19*abb18n45+t1*t20*abb18n59+t1*t24*abb18n68+t10*t11*abb18n76+t10*t&
         &12*abb18n78+t10*t13*abb18n78+t10*t14*abb18n88+t10*t20*abb18n49+t11*t21&
         &*abb18n79+t11*t23*abb18n47+t11*t27*abb18n66+t11*t9*abb18n60+t12*t21*ab&
         &b18n68+t12*t23*abb18n45+t12*t27*abb18n59+t12*t28*abb18n57+t12*t29*abb1&
         &8n54+t12*t30*abb18n115+t12*t9*abb18n62+t13*t23*abb18n45+t13*t9*abb18n6&
         &2+t14*t23*abb18n128+t14*t27*abb18n111+t14*t9*abb18n106+t16*t21*abb18n8&
         &0+t16*t27*abb18n63+t16*t28*abb18n60+t16*t29*abb18n62+t16*t30*abb18n106&
         &+t17*t27*abb18n49+t17*t28*abb18n76+t17*t29*abb18n78+t17*t30*abb18n88+t&
         &18*t21*abb18n52+t18*t27*abb18n65+t19*t21*abb18n73+t19*t27*abb18n44+t19&
         &*t28*abb18n47+t19*t29*abb18n45+t19*t30*abb18n128+t20*t23*abb18n44+t20*&
         &t28*abb18n66+t20*t30*abb18n111+t20*t36*abb18n65+t20*t9*abb18n63+t22*t2&
         &7*abb18n61+t23*t24*abb18n73+t24*t28*abb18n79+t24*t36*abb18n52+t24*t9*a&
         &bb18n80+t26*t27*abb18n55+t31*t6*abb18n124+t32*t8*abb18n124+t34*t6*abb1&
         &8n124+t35*t8*abb18n124+t37*t8*abb18n131+t39*t8*abb18n131+t4*t41*abb18n&
         &124+t4*t43*abb18n124+t40*t6*abb18n131+t41*t7*abb18n131+t42*t6*abb18n13&
         &1+t43*t7*abb18n131)
         return
      end if
      t45 = d(iv2,iv3)
      t46 = d(iv1,iv3)
      t2 = spvak6k5(iv3)
      t3 = spvak3k4(iv3)
      t4 = spvak2k1(iv3)
      t5 = spvak5k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(k5(iv3)*t44*abb18n56+spvak2k5(iv3)*t44*abb18n61+&
         &spvak3k1(iv3)*t44*abb18n77+spvak6k1(iv3)*t44*abb18n46+t1*t46*abb18n56+&
         &t10*t46*abb18n77+t12*t45*abb18n56+t16*t45*abb18n61+t17*t45*abb18n77+t1&
         &9*t45*abb18n46+t2*t44*abb18n58+t20*t45*abb18n58+t23*t46*abb18n46+t27*t&
         &46*abb18n58+t46*t9*abb18n61)+t2*t31*abb18n48+t2*t34*abb18n48+t2*t40*ab&
         &b18n43+t2*t42*abb18n43+t15*t27*t3*abb18n48+t20*t21*t4*abb18n48+t20*t21&
         &*t5*abb18n43+t20*t3*t33*abb18n48+t20*t3*t38*abb18n43+t24*t27*t4*abb18n&
         &48+t24*t27*t5*abb18n43+t25*t27*t3*abb18n43)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d18:
   subroutine     reconstruct_d18(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_18:
      coeffs%coeffs_18%c0 = derivative(czip)
      coeffs%coeffs_18%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_18%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_18%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_18%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_18%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_18%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_18%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_18%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_18%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_18%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_18%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_18%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_18%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_18%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_18%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_18%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_18%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_18%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_18%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_18%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_18%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_18%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_18%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_18%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_18%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_18%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_18%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_18%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_18%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_18%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_18%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_18%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_18%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_18%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_18:
   end subroutine reconstruct_d18
!---#] subroutine reconstruct_d18:
end module p9_udbar_neepgg_d18h3l1d
