module     p9_udbar_neepgg_d89h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d89h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d89
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd89h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      real(ki) :: t74
      real(ki) :: t75
      real(ki) :: t76
      real(ki) :: t77
      real(ki) :: t78
      real(ki) :: t79
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k5(iv1)
      t2 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb89n84+t2*abb89n44)
         return
      end if
      t74 = d(iv1,iv2)
      t3 = k2(iv1)
      t4 = k5(iv2)
      t5 = k2(iv2)
      t6 = spvak2k1(iv2)
      t7 = spvak2k6(iv2)
      t8 = t1*t7
      t9 = spvak3k1(iv2)
      t10 = t1*t9
      t11 = spvak3k4(iv2)
      t12 = t1*t11
      t13 = spvak5k6(iv2)
      t14 = t1*t13
      t15 = spvak6k1(iv2)
      t16 = spvak2k1(iv1)
      t17 = spvak2k6(iv1)
      t18 = t17*t4
      t19 = spvak3k1(iv1)
      t20 = t19*t4
      t21 = spvak3k4(iv1)
      t22 = t21*t4
      t23 = t2*t4
      t24 = spvak6k1(iv1)
      t25 = k6(iv1)
      t26 = t13*t25
      t27 = k6(iv2)
      t28 = t2*t27
      t29 = spvak2k5(iv1)
      t30 = t13*t29
      t31 = spvak2k5(iv2)
      t32 = t2*t31
      t33 = t13*t19
      t34 = t2*t9
      t35 = t15*t2
      t36 = spvak6k5(iv2)
      t37 = t2*t36
      t38 = t13*t24
      t39 = spvak6k5(iv1)
      t40 = t13*t39
      if(deg.eq.2) then
         numerator = (t10*abb89n72+t12*abb89n75+t14*abb89n77+t18*abb89n70+t20*ab&
         &b89n72+t22*abb89n75+t23*abb89n77+t26*abb89n77+t28*abb89n77+t30*abb89n8&
         &3+t32*abb89n83+t33*abb89n79+t34*abb89n79+t35*abb89n82+t37*abb89n76+t38&
         &*abb89n82+t40*abb89n76+(2.0_ki)*t74*abb89n85+t8*abb89n70+t1*t15*abb89n&
         &80+t1*t5*abb89n61+t1*t6*abb89n56+t16*t4*abb89n56+t24*t4*abb89n80+t3*t4&
         &*abb89n61)
         return
      end if
      t75 = d(iv2,iv3)
      t76 = d(iv1,iv3)
      t41 = k2(iv3)
      t42 = k5(iv3)
      t43 = spvak2k1(iv3)
      t44 = spvak2k6(iv3)
      t45 = spvak3k1(iv3)
      t46 = spvak3k4(iv3)
      t47 = spvak5k6(iv3)
      t48 = spvak6k1(iv3)
      t49 = spvak6k5(iv3)
      t50 = spvak2k5(iv3)
      t51 = spvak5k1(iv3)
      t52 = spvak5k1(iv2)
      t53 = t1*t46
      t54 = spvak5k1(iv1)
      t55 = t4*t46
      t56 = t21*t42
      t57 = t11*t42
      t58 = k6(iv3)
      t59 = spvak2k4(iv1)
      t60 = spvak2k4(iv2)
      t61 = spvak2k4(iv3)
      t62 = t29*t47
      t63 = t31*t47
      t64 = t2*t50
      t65 = t13*t50
      t66 = t19*t47
      t67 = t47*t9
      t68 = t2*t45
      t69 = t13*t45
      t70 = t2*t48
      t71 = t13*t48
      t72 = t24*t47
      t73 = t15*t47
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t75*abb89n59+t11*t76*abb89n74+t13*t76*abb89n7&
         &8+t15*t76*abb89n81+t16*t75*abb89n57+t17*t75*abb89n71+t19*t75*abb89n73+&
         &t2*t75*abb89n78+t21*t75*abb89n74+t24*t75*abb89n81+t3*t75*abb89n59+t4*t&
         &76*abb89n59+t41*t74*abb89n59+t42*t74*abb89n59+t43*t74*abb89n57+t44*t74&
         &*abb89n71+t45*t74*abb89n73+t46*t74*abb89n74+t47*t74*abb89n78+t48*t74*a&
         &bb89n81+t5*t76*abb89n59+t6*t76*abb89n57+t7*t76*abb89n71+t76*t9*abb89n7&
         &3)+t10*t47*abb89n50+t12*t48*abb89n52+t12*t51*abb89n46+t14*t48*abb89n54&
         &+t15*t53*abb89n52+t15*t56*abb89n52+t18*t46*abb89n62+t20*t47*abb89n50+t&
         &22*t48*abb89n52+t22*t51*abb89n46+t23*t48*abb89n54+t24*t55*abb89n52+t24&
         &*t57*abb89n52+t26*t48*abb89n54+t28*t48*abb89n54+t30*t49*abb89n66+t32*t&
         &49*abb89n66+t33*t49*abb89n48+t34*t49*abb89n48+t35*t49*abb89n53+t36*t62&
         &*abb89n66+t36*t64*abb89n66+t36*t66*abb89n48+t36*t68*abb89n48+t36*t70*a&
         &bb89n53+t36*t72*abb89n53+t38*t49*abb89n53+t39*t63*abb89n66+t39*t65*abb&
         &89n66+t39*t67*abb89n48+t39*t69*abb89n48+t39*t71*abb89n53+t39*t73*abb89&
         &n53+t46*t8*abb89n62+t52*t53*abb89n46+t52*t56*abb89n46+t54*t55*abb89n46&
         &+t54*t57*abb89n46+t1*t11*t44*abb89n62+t1*t13*t45*abb89n50+t1*t13*t50*a&
         &bb89n65+t1*t15*t47*abb89n54+t1*t31*t47*abb89n65+t11*t17*t42*abb89n62+t&
         &13*t16*t49*abb89n58+t13*t17*t49*abb89n64+t13*t19*t42*abb89n50+t13*t19*&
         &t58*abb89n50+t13*t24*t42*abb89n54+t13*t24*t58*abb89n54+t13*t25*t45*abb&
         &89n50+t13*t25*t50*abb89n65+t13*t29*t42*abb89n65+t13*t29*t58*abb89n65+t&
         &13*t3*t49*abb89n68+t13*t39*t41*abb89n68+t13*t39*t43*abb89n58+t13*t39*t&
         &44*abb89n64+t13*t39*t51*abb89n55+t13*t39*t61*abb89n69+t13*t49*t54*abb8&
         &9n55+t13*t49*t59*abb89n69+t15*t2*t42*abb89n54+t15*t2*t58*abb89n54+t15*&
         &t25*t47*abb89n54+t16*t36*t47*abb89n58+t17*t36*t47*abb89n64+t19*t27*t47&
         &*abb89n50+t2*t27*t45*abb89n50+t2*t27*t50*abb89n65+t2*t31*t42*abb89n65+&
         &t2*t31*t58*abb89n65+t2*t36*t41*abb89n68+t2*t36*t43*abb89n58+t2*t36*t44&
         &*abb89n64+t2*t36*t51*abb89n55+t2*t36*t61*abb89n69+t2*t4*t45*abb89n50+t&
         &2*t4*t50*abb89n65+t2*t42*t9*abb89n50+t2*t49*t5*abb89n68+t2*t49*t52*abb&
         &89n55+t2*t49*t6*abb89n58+t2*t49*t60*abb89n69+t2*t49*t7*abb89n64+t2*t58&
         &*t9*abb89n50+t21*t4*t44*abb89n62+t21*t42*t7*abb89n62+t24*t27*t47*abb89&
         &n54+t24*t4*t47*abb89n54+t25*t31*t47*abb89n65+t25*t47*t9*abb89n50+t27*t&
         &29*t47*abb89n65+t29*t4*t47*abb89n65+t3*t36*t47*abb89n68+t36*t47*t54*ab&
         &b89n55+t36*t47*t59*abb89n69+t39*t47*t5*abb89n68+t39*t47*t52*abb89n55+t&
         &39*t47*t6*abb89n58+t39*t47*t60*abb89n69+t39*t47*t7*abb89n64)
         return
      end if
      t77 = d(iv3,iv4)
      t78 = d(iv2,iv4)
      t79 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t3 = spvak2k5(iv4)
      t4 = spvak3k4(iv4)
      t5 = spvak2k6(iv4)
      t8 = spvak3k1(iv4)
      t10 = spvak5k1(iv4)
      t12 = spvak6k1(iv4)
      t14 = spvak6k5(iv4)
      t18 = t11*t16
      t20 = t16*t46
      t16 = t16*t4
      t22 = t21*t6
      t23 = t46*t6
      t6 = t4*t6
      t25 = t21*t43
      t26 = t11*t43
      t27 = t4*t43
      t28 = spvak2k1(iv4)
      t41 = t21*t28
      t42 = t11*t28
      t28 = t28*t46
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t74*t77*abb89n60+t75*t79*abb89n60+t76*t78*abb89n&
         &60)+(2.0_ki)*(t30*t77*abb89n64+t32*t77*abb89n64+t33*t77*abb89n49+t34*t&
         &77*abb89n49+t35*t77*abb89n55+t37*t77*abb89n67+t38*t77*abb89n55+t40*t77&
         &*abb89n67+t62*t78*abb89n64+t63*t79*abb89n64+t64*t78*abb89n64+t65*t79*a&
         &bb89n64+t66*t78*abb89n49+t67*t79*abb89n49+t68*t78*abb89n49+t69*t79*abb&
         &89n49+t70*t78*abb89n55+t71*t79*abb89n55+t72*t78*abb89n55+t73*t79*abb89&
         &n55+t1*t15*t76*abb89n55+t1*t19*t75*abb89n49+t1*t24*t75*abb89n55+t1*t29&
         &*t75*abb89n64+t1*t31*t76*abb89n64+t1*t36*t76*abb89n67+t1*t39*t75*abb89&
         &n67+t1*t45*t74*abb89n49+t1*t48*t74*abb89n55+t1*t49*t74*abb89n67+t1*t50&
         &*t74*abb89n64+t1*t76*t9*abb89n49+t10*t11*t76*abb89n47+t10*t21*t75*abb8&
         &9n47+t10*t46*t74*abb89n47+t11*t12*t76*abb89n51+t11*t17*t77*abb89n63+t1&
         &1*t24*t77*abb89n51+t11*t44*t79*abb89n63+t11*t48*t79*abb89n51+t11*t5*t7&
         &6*abb89n63+t11*t51*t79*abb89n47+t11*t54*t77*abb89n47+t12*t13*t76*abb89&
         &n55+t12*t2*t75*abb89n55+t12*t21*t75*abb89n51+t12*t46*t74*abb89n51+t12*&
         &t47*t74*abb89n55+t13*t14*t76*abb89n67+t13*t3*t76*abb89n64+t13*t49*t79*&
         &abb89n67+t13*t76*t8*abb89n49+t14*t2*t75*abb89n67+t14*t47*t74*abb89n67+&
         &t15*t21*t77*abb89n51+t15*t4*t76*abb89n51+t15*t46*t79*abb89n51+t17*t4*t&
         &75*abb89n63+t17*t46*t78*abb89n63+t2*t3*t75*abb89n64+t2*t49*t78*abb89n6&
         &7+t2*t75*t8*abb89n49+t21*t44*t78*abb89n63+t21*t48*t78*abb89n51+t21*t5*&
         &t75*abb89n63+t21*t51*t78*abb89n47+t21*t52*t77*abb89n47+t21*t7*t77*abb8&
         &9n63+t24*t4*t75*abb89n51+t24*t46*t78*abb89n51+t3*t47*t74*abb89n64+t36*&
         &t47*t79*abb89n67+t39*t47*t78*abb89n67+t4*t44*t74*abb89n63+t4*t48*t74*a&
         &bb89n51+t4*t51*t74*abb89n47+t4*t52*t76*abb89n47+t4*t54*t75*abb89n47+t4&
         &*t7*t76*abb89n63+t46*t5*t74*abb89n63+t46*t52*t79*abb89n47+t46*t54*t78*&
         &abb89n47+t46*t7*t79*abb89n63+t47*t74*t8*abb89n49)+t1*t18*t49*abb89n45+&
         &t1*t20*t36*abb89n45+t1*t22*t49*abb89n45+t1*t23*t39*abb89n45+t1*t25*t36&
         &*abb89n45+t1*t26*t39*abb89n45+t13*t14*t20*abb89n45+t13*t14*t25*abb89n4&
         &5+t13*t16*t49*abb89n45+t13*t27*t39*abb89n45+t13*t28*t39*abb89n45+t13*t&
         &41*t49*abb89n45+t14*t18*t47*abb89n45+t14*t2*t23*abb89n45+t14*t2*t26*ab&
         &b89n45+t14*t22*t47*abb89n45+t16*t36*t47*abb89n45+t2*t27*t36*abb89n45+t&
         &2*t28*t36*abb89n45+t2*t42*t49*abb89n45+t2*t49*t6*abb89n45+t36*t41*t47*&
         &abb89n45+t39*t42*t47*abb89n45+t39*t47*t6*abb89n45)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d89:
   subroutine     reconstruct_d89(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_89:
      coeffs%coeffs_89%c0 = derivative(czip)
      coeffs%coeffs_89%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_89%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_89%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_89%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_89%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_89%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_89%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_89%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_89%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_89%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_89%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_89%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_89%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_89%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_89%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_89%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_89%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_89%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_89%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_89%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_89%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_89%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_89%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_89%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_89%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_89%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_89%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_89%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_89%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_89%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_89%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_89%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_89%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_89%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_89%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_89%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_89%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_89%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_89%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_89%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_89%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_89%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_89%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_89%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_89%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_89%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_89%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_89%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_89:
   end subroutine reconstruct_d89
!---#] subroutine reconstruct_d89:
end module p9_udbar_neepgg_d89h3l1d
